2004-10-16  Kim F. Storm  <storm@cua.dk>

	* fringe.el (fringe-bitmaps): Only initialize when defined.

	* pcvs.el (cvs-mode-view-file, cvs-mode-view-file-other-window): Add.
	(cvs-mode-find-file): Add optional `view' arg to enter view mode.

	* pcvs-defs.el (cvs-mode-map): Bind v to cvs-mode-view-file.

2004-10-15  Simon Josefsson  <jas@extundo.com>

	* net/password.el: Add.

2004-10-13  Daniel Pfeiffer  <occitan@esperanto.org>

	* button.el (button-activate): Allow a marker to display as an
	action.

	* help-fns.el (describe-variable): Use it to make "below" a
	hyperlink.

	* help.el (describe-mode): Use it to make minor mode list into
	hyperlinks.

2004-10-14  Masatake YAMATO  <jet@gyve.org>

	* progmodes/gud.el (gdb-script-beginning-of-defun): New function.
	(gdb-script-end-of-defun): New function.
	(gdb-script-mode): Use `gdb-script-beginning-of-defun' and
	`gdb-script-end-of-defun' as *-of-defun-function.

2004-10-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc.el (vc-annotate-display-select): Fix typo.

	* subr.el (substitute-key-definition-key): New function.
	(substitute-key-definition): Use it with map-keymap.
	(event-modifiers): Use push.
	(mouse-movement-p, with-temp-buffer): Simplify.

2004-10-12  Michael Albinus  <michael.albinus@gmx.de>

	Sync with Tramp 2.0.45.

	* net/tramp.el (top): Apply `def-edebug-spec' only if function is
	defined.  This is not the case for XEmacs without package "edebug".
	(tramp-set-auto-save-file-modes): Set permissions of autosaved
	remote files to the permissions of the original file.  This is not
	the case for Emacs < 21.3.50 and XEmacs < 21.5.  Add function to
	`auto-save-hook'.  Reported by Thomas Prokosch <thomas@nadev.net>.
	(tramp-perl-decode): Fix an error in Perl implementation.
	$pending must be cleared every loop.  Reported by Benjamin Place
	<benjaminplace@sprintmail.com>

	* net/tramp-smb.el (tramp-smb-advice-PC-do-completion):
	Don't activate advice during definition.  This is done later on,
	depending on test result of `substitute-in-file-name'.
	Suggested by Stefan Monnier <monnier@iro.umontreal.ca>.

2004-10-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* pcvs-parse.el (cvs-parse-commit): Fix parsing for new commit message.

	* emacs-lisp/lisp.el (mark-sexp): Preserve direction when repeating.

2004-10-12  David Ponce  <david@dponce.com>

	* recentf.el (recentf-edit-list): Update the menu when the recentf
	list has been modified.

2004-10-12  Simon Josefsson  <jas@extundo.com>

	* net/tls.el (tls-certtool-program): New variable.
	(tls-certificate-information): New function, based on
	ssl-certificate-information.

2004-10-12  Kenichi Handa  <handa@m17n.org>

	* international/mule.el (coding-system-equal): Move from mule-util.el.

	* international/mule-util.el (coding-system-equal): Move to mule.el.

2004-10-12  Kim F. Storm  <storm@cua.dk>

	* kmacro.el (kmacro-insert-counter, kmacro-add-counter): Use and
	reset kmacro-initial-counter-value if set.
	(kmacro-set-counter): Only set kmacro-counter if defining or executing
	macro.  Set kmacro-initial-counter-value otherwise. Never set both.
	(kmacro-display): Show macro counter if non-zero.

	* subr.el (substitute-key-definition): Mention command remapping
	in doc string.

2004-10-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* pcvs-defs.el (pcl-cvs-load-hook): Remove unused var.

	* font-lock.el (font-lock-apply-highlight): Fix last change.

2004-10-11  Simon Josefsson  <jas@extundo.com>

	* mail/smtpmail.el (smtpmail-open-stream): Look for
	starttls-gnutls-program instead of starttls-program iff
	starttls-use-gnutls is non-nil.
	(smtpmail-open-stream): Don't overwrite user settings of
	starttls-extra-arguments and starttls-extra-args.

2004-10-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* comint.el (comint-mouse-insert-input): Remove.
	(comint-insert-input): Make it work for mouse bindings.
	(comint-mode-map): Move defs into the declaration.
	(comint-output-filter): Typo.

	* diff-mode.el (diff-current-defun): Fix 2004-06-13's change.

2004-10-10  Kai Grossjohann  <kai.grossjohann@gmx.net>

	* net/ange-ftp.el (ange-ftp-remote-shell): Remove variable.
	(ange-ftp-call-chmod): Reference remote-shell-program instead of
	ange-ftp-remote-shell.

2004-10-10  Andreas Schwab  <schwab@suse.de>

	* emacs-lisp/byte-opt.el (byte-optimize-backward-word): Optimize
	`(backward-word)' to `(forward-word -1)', not `(forward-char -1)'.
	Reported by <sri@asu.edu>.

2004-10-10  Benjamin Rutt  <brutt@bloomington.in.us>

	* vc.el (vc-annotate-mode): Remove variable.
	(vc-annotate-display-select): Only call vc-annotate-mode
	if we're not in that mode already.

2004-10-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* imenu.el (imenu--completion-buffer): Don't return t for rescan.
	(imenu-choose-buffer-index): Check here for rescan instead.

	* font-lock.el (font-lock-apply-highlight): Explicitly check the case
	where the face expression evals to nil.

	* textmodes/tex-mode.el (tex-font-lock-append-prop): New fun.
	(tex-font-lock-keywords-2): Use it.
	(tex-font-lock-syntactic-keywords): Fix the `verbatim' treatment.

	* emacs-lisp/lisp-mode.el (lisp-fill-paragraph): Fix backslashes.

2004-10-09  Kim F. Storm  <storm@cua.dk>

	* subr.el (progress-reporter-update): Define before first usage.
	(make-progress-reporter): Doc fix.

2004-10-09  Luc Teirlinck  <teirllm@auburn.edu>

	* textmodes/paragraphs.el (sentence-end-double-space)
	(sentence-end-without-period, sentence-end-without-space)
	(sentence-end): Doc fixes.

2004-10-08  Peter Seibel  <peter@javamonkey.com>  (tiny change)

	* emacs-lisp/lisp-mode.el (lisp-fill-paragraph):
	Change paragraph-start regexp so we don't fill code starting with #'(.

2004-10-08  Sebastien Kirche  <seki@seki.fr>  (tiny change)

	* mail/mail-extr.el (mail-extr-ignore-realname-equals-mailbox-name):
	New defcustom.
	(extract-address-components): Use it.

2004-10-08  Paul Pogonyshev  <pogonyshev@gmx.net>

	* subr.el (make-progress-reporter, progress-reporter-update)
	(progress-reporter-force-update, progress-reporter-do-update)
	(progress-reporter-done): New functions.

	* tar-mode.el (tar-summarize-buffer): Use progress reporter.

	* progmodes/etags.el (etags-tags-completion-table): Use progress
	reporter.
	(etags-tags-apropos): Likewise.

2004-10-08  Alan Mackenzie  <acm@muc.de>

	* isearch.el (isearch-yank-line): C-y yanks to next EOL, not end
	of current line.

2004-10-08  Masatake YAMATO  <jet@gyve.org>

	* server.el (server-process-filter): Wrap `process-send-region'
	by `condition-case' to guard the case when the pipe to PROC is closed.

2004-10-07  Mark A. Hershberger  <mah@everybody.org>

	* xml.el (xml-substitute-special): Limit handling of external entities.

2004-10-06  Nick Roberts  <nickrob@snap.net.nz>

	* progmodes/gdb-ui.el (gdb-ann3): (Re-)initialise gdb-input-queue.

2004-10-06  John Paul Wallington  <jpw@gnu.org>

	* xml.el (xml-parse-dtd): Fix `error' call.

2004-10-05  Mark A. Hershberger  <mah@everybody.org>

	* xml.el (xml-substitute-special): Return a single string instead
	of a list of strings if an entity substitution is made.

2004-10-05  Ulf Jasper  <ulf.jasper@web.de>

	* calendar/icalendar.el: New file.

2004-10-05  Juri Linkov  <juri@jurta.org>

	* isearch.el (isearch-done): Set mark after running hook.
	Suggested by Drew Adams <drew.adams@oracle.com>.

	* info.el (Info-history, Info-toc): Fix Info headers.
	(Info-toc): Narrow buffer before Info-fontify-node.
	(Info-build-toc): Don't check for special Info file names.
	Set main-file to nil if Info-find-file returns a symbol.

2004-10-05  Emilio C. Lopes  <eclig@gmx.net>:

	* calendar/calendar.el (calendar-goto-iso-week): Add autoload.
	(calendar-mode-map): Add binding for `calendar-goto-iso-week'.
	* calendar/cal-menu.el (calendar-mode-map): Ditto.

2004-10-05  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* calendar/cal-iso.el (calendar-iso-read-args): New function,
	for old interactive spec from calendar-goto-iso-date.
	(calendar-goto-iso-date): Use it.
	(calendar-goto-iso-week): New function.  Suggested by Emilio
	C. Lopes <eclig@gmx.net>.

2004-10-04  Luc Teirlinck  <teirllm@auburn.edu>

	* textmodes/enriched.el (enriched-mode-map): Give `set-left-margin' and
	`set-right-margin' bindings that follow the minor mode conventions.

2004-10-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textmodes/tex-mode.el (tex-dvi-view-command): Use `yap' on w32.
	(tex-font-lock-keywords-1): Add url and nolinkurl for args with `_'.
	(latex-block-args-alist): Add minipage and picture.
	(latex-block-body-alist): Use reftex-label if enabled.
	(latex-insert-block): Don't insert a \n if not necessary.
	(tex-compile-commands): Make sure dvips doesn't send to printer.
	(tex-compile-default): Handle the case where no executable is found.
	(latex-noindent-environments): New var.
	(latex-find-indent): Use it.  Take an empty line as an arg-breaker.
	If tex-indent-allhanging is non-nil, make sure we only align for macros
	at beginning of line.

2004-10-03  Daniel Pfeiffer  <occitan@esperanto.org>

	* newcomment.el (comment-beginning): Doc fix and don't choke on
	unset `comment-end-skip' when at beginning of comment.

2004-10-02  Dan Nicolaescu  <dann@ics.uci.edu>

	* term.el (term-adjust-current-row-cache): Don't allow the current
	row to become negative.
	(term-emulate-terminal): Fix insert mode. Handle tab insertion at
	the end of the line. Fix scroll down. Add comments.
	(term-handle-ansi-escape): Don't exceed terminal width when moving
	right.
	(term-scroll-region): Move the cursor after setting the scroll region.

2004-10-01  Luc Teirlinck  <teirllm@auburn.edu>

	* indent.el (set-left-margin, set-right-margin): Rename `lm' arg
	to `width' for consistency with docstring.  Doc fix.

2004-10-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* progmodes/cc-langs.el: Load cl here since cc-defs doesn't do it.
	This is necessary for derived modes.

2004-09-30  Kim F. Storm  <storm@cua.dk>

	* kmacro.el (kmacro-lambda-form, kmacro-extract-lambda): Add.
	(kmacro-bind-to-key, kmacro-name-last-macro): Use kmacro-lambda-form.

	* edmacro.el: Require kmacro to use the new kmacro-lambda-form and
	kmacro-extract-lambda functions.
	(edit-kbd-macro): Handle kmacro lambda forms.
	Include counter and counter format in edit buffer.
	(edmacro-finish-edit): Get counter and format from edit buffer and
	update kmacro bindings when found.

2004-09-29  Luc Teirlinck  <teirllm@auburn.edu>

	* textmodes/paragraphs.el (forward-paragraph):
	Avoid args-out-of-range error when point winds up at the beginning of
	the buffer and hard newlines are enabled.

	* newcomment.el (comment-multi-line): Doc fix.

2004-09-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* diff-mode.el (diff-file-header-re): Tighten up regexp a tiny bit.
	(diff-fixup-modifs): Catch unified-diff file-headers.

2004-09-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.el (dired-view-command-alist): Use more efficient regexps.
	Remove dubious arguments.
	(dired-align-file): New function.
	(dired-insert-directory): Use it.
	(dired-move-to-end-of-filename): Make the " -> " search more specific.
	(dired-buffers-for-dir): Remove unused var `pattern'.

2004-09-29  Kim F. Storm  <storm@cua.dk>

	* progmodes/gdb-ui.el (breakpoint): Define as fringe bitmap.
	(gdb-mouse-toggle-breakpoint): Fix fringe-bitmaps-at-pos usage.
	(gdb-put-breakpoint-icon): Use breakpoint bitmap.

	* fringe.el (fringe-bitmap-p): New macro.
	(fringe-bitmaps): Add standard fringe bitmaps on load.

2004-09-28  Matthew Mundell  <matt@mundell.ukfsn.org>  (tiny change)

	* calendar/diary-lib.el (list-diary-entries): Save diary buffer
	from diary display excursion.  Store diary buffer's point for
	`simple-diary-display'.
	(simple-diary-display): Set window point and start when
	displaying buffer, to preserve point.

2004-09-27  Luc Teirlinck  <teirllm@auburn.edu>

	* textmodes/enriched.el (enriched-translations): Replace defconst
	with defvar.

2004-09-26  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: Doc fix.
	(pr-version): New version number (6.8.1).
	(pr-ps-file-using-ghostscript): Use make-temp-file instead of
	make-temp-name.
	(pr-delete-file): Check if file exists before deleting it.
	Reported by Lennart Borgman <lennart.borgman.073@student.lu.se>.

2004-09-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term.el (term-display-table): New variable.
	(term-mode): Use it.
	(term-exec-1): Set the coding system to binary.
	(term-emulate-terminal): Decode the string before inserting it.

2004-09-26  Dan Nicolaescu  <dann@ics.uci.edu>

	* term.el (term-ansi-at-eval-string, term-ansi-default-fg)
	(term-ansi-default-bg, term-ansi-current-temp): Delete unused vars.
	(map): Bind S-prior, S-next and S-insert.
	(term-mode): Set `indent-tabs-mode' to nil.
	(term-paste): New function to be bound to S-insert.
	(term-send-del, term-send-backspace): Change the strings sent.
	(term-termcap-format): Synchronyze with etc/e/eterm.ti.
	(term-handle-colors-array): Fix handling of underline and reverse.
	(term-handle-ansi-escape): Do not handle smcup/rmcup.  Add comments.
	(term-erase-in-line): Fix comparison.
	(term-emulate-terminal): Fix line wrap handling.
	(term-start-output-log): Rename from `term-set-output-log'.
	(term-stop-output-log): Rename from `term-stop-photo'.
	(term-switch-to-alternate-sub-buffer): Comment out, unused.

2004-09-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.el (dired-move-to-filename): Don't output a message if
	raise-error is non-nil.  Fix return position and value.

	* files.el (insert-directory): Obey --dired even with symlinks.

2004-09-25  Lars Hansen  <larsh@math.ku.dk>

	* ls-lisp.el (ls-lisp-format): Mark file names with property
	dired-filename.

2004-09-25  Kim F. Storm  <storm@cua.dk>

	* ido.el (ido-max-directory-size): New defcustom.
	(ido-decorations): Add "too big" element.
	(ido-directory-too-big): New dynamic var.
	(ido-may-cache-directory): Don't cache big directories.
	(ido-directory-too-big-p): New defun.
	(ido-set-current-directory): Update ido-directory-too-big.
	(ido-read-internal): Make empty ido-cur-item if too-big.
	(ido-buffer-internal): Use ido-read-internal directly instead of
	ido-read-buffer.
	(ido-file-internal): Init ido-directory-too-big.
	(ido-complete): <TAB> If ido-directory-too-big is set, clear it,
	and redo completion with full list.
	(ido-toggle-ignore): <C-a> If ido-directory-too-big is set, clear
	it, and show completions.
	(ido-all-completions): Let bind ido-directory-too-big to nil.
	(ido-exhibit): Handle ido-directory-too-big.
	(ido-read-buffer): Handle fallback to read-buffer.
	Init ido-directory-too-big.
	(ido-read-file-name, ido-read-directory-name, ido-completing-read):
	Init ido-directory-too-big.

2004-09-24  Luc Teirlinck  <teirllm@auburn.edu>

	* subr.el (delay-mode-hooks): Doc fix.

2004-09-23  Luc Teirlinck  <teirllm@auburn.edu>

	* textmodes/enriched.el
	(enriched-default-text-properties-local-flag): New variable.
	(enriched-mode): Make sure that enabling and disabling the mode is
	a no-op.  Doc fix.

2004-09-23  H,Ae(Bkon Malmedal  <hmalmedal@yahoo.no>  (tiny change)

	* calendar/holidays.el (holiday-advent): Report on a specified day
	offset from advent, not just advent.
	(holiday-easter-etc): Report on one specified day offset from
	easter, not all easter holidays. Various Easter holidays moved to
	`christian-holidays' variable in calendar.el.
	* calendar/calendar.el (christian-holidays): Adapt for new
	behaviour of `holiday-advent' and `holiday-easter-etc' functions.

2004-09-23  Kim F. Storm  <storm@cua.dk>

	* image.el (insert-sliced-image): Add doc string.

	* ido.el (ido-choice-list): New dynamic var for `list' context.
	(ido-context-switch-command): New dynamic var.
	(ido-define-mode-map): Generalize switch between file/buffer contexts.
	(ido-read-internal): Handle new `list' context.
	Handle insert-buffer and insert-file ido-exit values.
	(ido-buffer-internal): New arg switch-cmd.  Use it to setup
	ido-context-switch-command. Handle insert-file ido-exit value.
	(ido-read-buffer): Set ido-context-switch-command to 'ignore
	unless it is already bound by caller.
	(ido-file-internal): New arg switch-cmd.  Use it to setup
	ido-context-switch-command.  Handle insert-buffer ido-exit value.
	(ido-enter-insert-buffer, ido-enter-insert-file): New commands
	used for context switching.
	(ido-all-completions): Handle new `list' context.
	(ido-make-choice-list): Return choices for `list' context.
	(ido-find-file-in-dir, ido-display-file, ido-write-file)
	(ido-display-buffer, ido-kill-buffer): Disable context switching.
	(ido-insert-buffer, ido-insert-file): Setup context switching.
	(ido-exhibit): Handle `list' context.
	(ido-read-file-name): Disable context switching.  Handle fallback.
	(ido-read-directory-name): Disable context switching.
	(ido-completing-read): New defun like completing-read.  Setup and
	use new `list' context.

2004-09-20  Jesper Harder  <harder@ifa.au.dk>

	* progmodes/tcl.el (inferior-tcl): Use pop-to-buffer.

2004-09-21  Luc Teirlinck  <teirllm@auburn.edu>

	* subr.el (after-change-major-mode-hook): Doc fix.

2004-09-21  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: Doc fix.  Add a new tip about the use of gsprint instead
	of ghostscript for monochrome PostScript file in Windows.

2004-09-21  Kenichi Handa  <handa@m17n.org>

	* descr-text.el (describe-char): Checking of quail activation
	fixed.

2004-09-20  Luc Teirlinck  <teirllm@auburn.edu>

	* subr.el (run-mode-hooks): Run `after-change-major-mode-hook'
	after the mode hooks instead of before.  Doc fix.

2004-09-20  Jason Rumney  <jasonr@gnu.org>

	* startup.el (command-line) [windows-nt]: Try .emacs first, then
	_emacs, but revert to .emacs if neither exists in home directory.

2004-09-20  John Paul Wallington  <jpw@gnu.org>

	* bindings.el (completion-ignored-extensions): Add .dfsl.

2004-09-20  Richard M. Stallman  <rms@gnu.org>

	* bindings.el (scroll-left): Make it disabled.

	* files.el (enable-local-eval): Doc fix.

	* indent.el (move-to-left-margin): Special case for minibuffer.

	* term.el (term-emulate-terminal): Turn off undo for output.
	Use with-current-buffer and save-selected-window.

	* eshell/esh-ext.el (eshell-explicit-command-char): Doc fix.

	* progmodes/make-mode.el (makefile-fill-paragraph):
	Don't insist on spaces when looking for comments.  # is enough.

	* files.el (hack-local-variables): Copy the variables list
	to another buffer, strip prefixes and suffixes there, then read.
	(enable-local-eval): Doc fix.
	(ignored-local-variables): Initialize to nil.
	(risky-local-variable-p): Don't check ignored-local-variables here.
	(hack-one-local-variable): Ignore var if in ignored-local-variables.

2004-09-20  Dan Nicolaescu  <dann@ics.uci.edu>

	* progmodes/sh-script.el (sh-mode-default-syntax-table): Set syntax
	of = to "." (punctuation).

2004-09-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (event-basic-type): Fix mask (extend to 22bits).

2004-09-18  Luc Teirlinck  <teirllm@auburn.edu>

	* textmodes/enriched.el (enriched-rerun-flag): New variable.
	(enriched-before-change-major-mode): New function.
	Add it to `change-major-mode-hook'.
	(enriched-after-change-major-mode): New function.
	Add it to `after-change-major-mode-hook'.
	(enriched-mode): Make it work correctly if called from
	`after-change-major-mode-hook'.
	No longer set `indent-line-function'.

	* simple.el (fundamental-mode): Run `after-change-major-mode-hook'.

	* subr.el (after-change-major-mode-hook): New variable.
	(run-mode-hooks): Implement it.

2004-09-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* battery.el (battery-linux-proc-apm): Use string-to-number.
	(battery-linux-proc-acpi): Ignore all hidden files in the battery dir.
	Use dolist (and less indentation).  Use erase-buffer.
	Pre-initialize `design-capacity', `warn', and `low'.
	(battery-format): Use replace-regexp-in-string.

2004-09-18  Ralph Schleicher  <rs@nunatak.allgaeu.org>

	* battery.el: Delete superfluous empty lines.
	(battery-linux-proc-acpi): Attempt to gather information from all
	battery subdirectories regardless of their file name.
	(battery-linux-proc-apm): Replace all occurrences of
	battery-hex-to-int-2 with string-to-int (base 16).
	(battery-hex-to-int-2, battery-hex-to-int): Delete functions.
	(battery-hex-map): Delete variable.

2004-09-18  John Paul Wallington  <jpw@gnu.org>

	* calc/calc-units.el (calc-quick-units): Fix overzealous
	s/or/unless/.

2004-09-17  Romain Francoise  <romain@orebokech.com>

	* ibuf-ext.el (define-ibuffer-filter filename):
	Expand dired-directory since buffer-file-name is absolute.

2004-09-17  Dan Nicolaescu  <dann@ics.uci.edu>

	* ediff-init.el (ediff-current-diff-face-A)
	(ediff-current-diff-face-B, ediff-current-diff-face-C)
	(ediff-current-diff-face-Ancestor)
	(ediff-fine-diff-face-A, ediff-fine-diff-face-B)
	(ediff-fine-diff-face-C, ediff-fine-diff-face-Ancestor)
	(ediff-even-diff-face-A, ediff-even-diff-face-B)
	(ediff-even-diff-face-C, ediff-even-diff-face-Ancestor)
	(ediff-odd-diff-face-A, ediff-odd-diff-face-B)
	(ediff-odd-diff-face-C, ediff-odd-diff-face-Ancestor):
	Use min-colors.

	* term.el (term-down): Perform vertical motion if DOWN is negative.
	(term-exec-1): Set both TERMCAP and TERMINFO unconditionally.
	(term-termcap-format): Synchronyze with the eterm terminfo entry
	in etc/e/eterm.ti.
	(term-handle-colors-array): If the current foreground or
	background are zero (i.e. unspecified), use the foreground and
	background of the default face for reverse video.
	(term-ansi-at-eval-string, term-ansi-default-fg)
	(term-ansi-default-bg, term-ansi-current-temp): Delete unused variable.
	(term-mem): Delete ununsed function.
	(term-protocol-version): Increment.
	(term-current-face): Set to default.

2004-09-15  Thien-Thi Nguyen  <ttn@gnu.org>

	* vc.el (annotate-time): Document point handling.
	(vc-annotate-display-autoscale): Doc fix.

2004-09-15  Miles Bader  <miles@gnu.org>

	* generic.el (generic-make-keywords-list): Use symbol rather than
	word anchors in regexp.

2004-09-14  Sean O'Rourke  <sorourke@cs.ucsd.edu>

	* ibuf-ext.el (define-ibuffer-filter filename): If buffer has
	no file name consider `dired-directory'.

2004-09-14  Kim F. Storm  <storm@cua.dk>

	* faces.el (cursor): Add face-no-inherit property.  Doc fix.

2004-09-14  Simon Josefsson  <jas@extundo.com>

	* files.el (auto-mode-alist): Map .soa and .zone to dns-mode.

	* textmodes/dns-mode.el: Add.

2004-09-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* novice.el (disabled-command-hook): Use shorthand for obsolescence.
	(disabled-command-function): Make the ?\  char more obvious.

	* vc-arch.el (vc-arch-root, vc-arch-registered):
	* vc-mcvs.el (vc-mcvs-root, vc-mcvs-registered): Use vc-find-root.

2004-09-13  Hovav Shacham  <hovav@sha1.stanford.edu>

	* windmove.el (windmove-frame-edges): Report coordinates of
	outside edges of frame, not inside edges.
	(windmove-coordinates-of-position): Convert into wrapper to new
	function `windmove-coordinates-of-window-position';
	`compute-motion' always applies to selected window.
	(windmove-coordinates-of-position): Update documentation to refer
	to Emacs 21 Lisp Reference Manual.
	(windmove-find-other-window): Fix off-by-one errors for max x,y.

2004-09-13  Kim F. Storm  <storm@cua.dk>

	* isearch.el (isearch-resume-in-command-history): Rename from
	isearch-resume-enabled and change default to nil.

2004-09-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-hooks.el (vc-ignore-dir-regexp): New var.
	(vc-registered): Use it.
	(vc-find-root): New fun.

	* emacs-lisp/checkdoc.el (checkdoc-this-string-valid-engine):
	Don't tell to use \\{...} when it's already done.

	* textmodes/bibtex.el (bibtex-generate-url-list): Change format.
	Provide a sample complex default.
	(bibtex-url, bibtex-font-lock-url): Adapt to new format.
	(bibtex-entry): Use mapc.

2004-09-12  Kim F. Storm  <storm@cua.dk>

	* kmacro.el (kmacro-step-edit-prompt): Add "%s" format to message.

	* emulation/cua-rect.el (cua--rectangle-operation): Let bind
	inhibit-field-text-motion to t so rectangles work in comint buffers.

	* simple.el (choose-completion-string): Set buffer before running
	choose-completion-string-functions hook so it can be buffer-local.

2004-09-12  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-start): Parse command to see
	if it starts with a cd, and if so perform it for the *compilation*
	buffer.  Change the header to reflect this.

2004-09-11  Kim F. Storm  <storm@cua.dk>

	* ido.el (ido-enable-dot-prefix): Doc fix.
	(ido-enable-dot-prefix): New defcustom.
	(ido-set-matches1): Use it.

2004-09-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textmodes/bibtex.el (bibtex-mark-active)
	(bibtex-run-with-idle-timer): Move the `if' inside the defun.

2004-09-10  Roland Winkler  <Roland.Winkler@physik.uni-erlangen.de>

	* textmodes/bibtex.el (bibtex-autokey-titleword-ignore): Regexp is
	used in a case insensitive environment.
	(bibtex-mode-map): Rearrange order of menus.
	(bibtex-quoted-string-re): Obsolete.
	(bibtex-complete-key-cleanup): Variable replaced by new function.
	(bibtex-font-lock-keywords): Use backquotes.
	(bibtex-font-lock-url-regexp): New internal variable.
	(bibtex-name-in-field): New optional arg remove-opt-alt to remove
	"OPT" and "ALT".
	(bibtex-insert-current-kill, bibtex-make-field)
	(bibtex-prepare-new-entry, bibtex-yank-pop, bibtex-String): Use unless.
	(bibtex-parse-field-text): Simplify.
	(bibtex-string=): New helper function.
	(bibtex-member-of-regexp): Merge with bibtex-autokey-get-title.
	(bibtex-map-entries): Use bibtex-string=.
	(bibtex-search-entry): Use not.
	(bibtex-enclosing-field): Fix docstring.
	(bibtex-assoc-regexp): Obsolete.
	(bibtex-format-entry): Use assoc-string and bibtex-string=.
	(bibtex-autokey-get-names): Handle empty name field.
	(bibtex-parse-strings): Use assoc-string and unless.
	(bibtex-complete-string-cleanup): Expansion list is passed as an arg.
	Use assoc-string.
	(bibtex-pop): Simplify.
	(bibtex-mode): Set font-lock-extra-managed-props.
	(bibtex-entry-update): Use assoc-string.
	(bibtex-parse-entry): Remove "OPT" and "ALT" from FIELD.
	(bibtex-autofill-entry): Use bibtex-string=.
	(bibtex-print-help-message): Simplify.
	(bibtex-find-entry): New optional arg START.
	(bibtex-validate): Use bibtex-string= and assoc-string.
	Do not call obsolete function compilation-parse-errors.
	(bibtex-remove-delimiters): Only remove delimiters if present.
	(bibtex-copy-entry-as-kill): Add docstring.
	(bibtex-clean-entry): Use bibtex-string=. Handle empty keys.
	Detect duplicate keys if bibtex-maintain-sorted-entries is nil.
	(bibtex-complete): Use bibtex-predefined-month-strings,
	bibtex-string=, and new function bibtex-complete-key-cleanup.
	(bibtex-generate-url-list): New variable.
	(bibtex-url): New command bound to C-c C-l and mouse-2.
	(bibtex-url-map): New local keymap for bibtex-url-mouse.
	(bibtex-font-lock-url): New function.

2004-09-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/grep.el (grep-mode): Remove unnecessary autoload.

2004-09-09  Kim F. Storm  <storm@cua.dk>

	* kmacro.el (kmacro-bind-to-key): Associate dedicated macro
	counter and format with binding.
	(kmacro-name-last-macro): New defun.  Like name-last-kbd-macro, but
	the declared macro uses own macro counter and format.  Give symbol
	kmacro property.
	(kmacro-keymap): Bind kmacro-name-last-macro to n.
	(kmacro-start-macro, kmacro-end-macro, kmacro-call-macro)
	(kmacro-end-and-call-macro): Doc fix.

2004-09-09  Lars Hansen  <larsh@math.ku.dk>

	* desktop.el (desktop-clear-preserve-buffers):
	Remove make-obsolete-variable.

2004-09-08  Richard M. Stallman  <rms@gnu.org>

	* buff-menu.el (list-buffers-noselect): Call format-mode-line
	with the buffer as argument.

2004-09-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-arch.el (vc-arch-state): Fix parsing for `names' method.

2004-09-08  Juri Linkov  <juri@jurta.org>

	* replace.el (perform-replace): Use `query-replace-descr'.

	* cus-start.el (history-delete-duplicates): Specify customization.

	* diff-mode.el (diff-mode-map):
	* progmodes/compile.el (compilation-mode-map):
	* progmodes/grep.el (grep-mode-map):
	* replace.el (occur-mode-map): Rename `next-error-follow-mode'
	to `next-error-follow-minor-mode'.

2004-09-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* isearch.el (isearch-lazy-highlight-update): Take into account
	the case of zero-length match at the search bound.

2004-09-08  Kim F. Storm  <storm@cua.dk>

	* emulation/cua-rect.el (cua--highlight-rectangle): Fix last
	change.  Use zero width overlays when necessary.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* subr.el (split-string): Docfix.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-generate-call-tree): Doc fix.
	(display-call-tree): Ensure newline after caller/calls blocks.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* startup.el (command-line-1): Make option
	--directory/-L modify `load-path' straight away.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* progmodes/grep.el (grep-mode): Use normal autoload cookie.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* emacs-lisp/autoload.el (make-autoload):
	Handle `define-compilation-mode'.

	* emacs-lisp/lisp-mode.el (define-compilation-mode):
	Specify `doc-string-elt' property.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* bs.el (bs-mode): Doc fix.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* info.el (Info-insert-dir): Fix temp buffer leak bug.

2004-09-08  Thien-Thi Nguyen  <ttn@gnu.org>

	* play/blackbox.el (bb-trace-ray): Avoid double tracing.

2004-09-08  Kenichi Handa  <handa@m17n.org>

	* ps-mule.el: Fix old function calls (ps-mule-chars-in-string ->
	length, ps-mule-string-char -> aref, ps-mule-next-index -> 1+,
	ps-mule-next-point -> 1+).

	* composite.el (encode-composition-rule): Add autoload cooky.

2004-09-07  Luc Teirlinck  <teirllm@auburn.edu>

	* format.el (buffer-auto-save-file-format): Make it permanent local.

2004-09-07  Kim F. Storm  <storm@cua.dk>

	* emacs-lisp/authors.el (authors-aliases): Add more aliases.
	(authors-fixed-entries): Fix typo.
	(authors-canonical-author-name): Compact multiple spaces.
	Ignore trivial names (e.g. only first name).

	* term.el (term-window-width): Only use full window width on
	window system if overflow-newline-into-fringe is enabled.
	(term-mode): Don't disable overflow-newline-into-fringe.

2004-09-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term/xterm.el (function-key-map): Add bindings for C- and S- cursor
	motion as seen on my Mac OS X xterms.

	* newcomment.el (uncomment-region-default, comment-region-default):
	New functions extracted from uncomment-region and comment-region.
	(comment-region, comment-region-function, uncomment-region)
	(uncomment-region-function): Use them.

	* pcvs-util.el (cvs-string-prefix-p): Use compare-strings.

	* pcvs-info.el (cvs-states): Allow `ignore' on NEED-UPDATE.
	It's not crucial but can make sense at times.

	* vc-arch.el (vc-arch-workfile-version): Handle the special case before
	the first commit.

	* vc.el (vc-buffer-context, vc-restore-buffer-context):
	Disable obsolete code.

2004-09-07  Juri Linkov  <juri@jurta.org>

	* progmodes/grep.el (grep-highlight-matches): Change default from
	`t' to `auto-detect', and type from `boolean' to `choice'.  Doc fix.
	(grep-compute-defaults): Set `grep-highlight-matches' to `t'
	if grep option `--color' is available, or to `nil' otherwise.
	(grep-process-setup): Call `grep-compute-defaults' if
	`grep-highlight-matches' is not computed.  Set env-vars only
	if `grep-highlight-matches' is `t'.
	(grep-use-null-device): Remove redundant type `boolean' (`choice'
	is already defined).

	* progmodes/compile.el (compilation-start): Use copy of
	`process-environment' created by `copy-sequence' to not
	modify env-vars in the global `process-environment'.

2004-09-06  Eli Zaretskii  <eliz@gnu.org>

	* simple.el (next-error-follow-minor-mode): Fix last change.

2004-09-05  Luc Teirlinck  <teirllm@auburn.edu>

	* textmodes/paragraphs.el (use-hard-newlines): Make it into a
	permanent local.

2004-09-04  Richard M. Stallman  <rms@gnu.org>

	* isearch.el (isearch-lazy-highlight-new-loop): Don't invoke
	highlighting if the search string is empty.

2004-09-04  Luc Teirlinck  <teirllm@auburn.edu>

	* facemenu.el (facemenu-active-faces): Change condition of inner
	`while' loop to also check the first two elements of `face-atts'
	and `mask-atts'.

2004-09-04  John Paul Wallington  <jpw@gnu.org>

	* thumbs.el (thumbs-view-image-mode-map): Fix command name typo.
	(thumbs-view-image-mode): Make buffer read-only.

2004-09-04  Christopher J. Madsen  <cjm@pobox.com>

	* textmodes/ispell.el (ispell-really-aspell): New defvar.
	(ispell-check-version): Set it.
	(ispell-send-replacement): New function.
	(ispell-process-line): Call ispell-send-replacement.

2004-09-04  Matt Hodges  <matt@stchem.bham.ac.uk>  (tiny change)

	* eshell/em-pred.el (eshell-predicate-help-string): Doc fix.
	Support choosing seconds with "s".

2004-09-04  Jari Aalto  <jari.aalto@poboxes.com>

	* terminal.el (te-escape): Show `?' in prompt for help key.

2004-09-04  Emilio C. Lopes <eclig@gmx.net>

	* emacs-lisp/lisp.el (kill-backward-up-list): New function.

2004-09-04  Dan Nicolaescu  <dann@ics.uci.edu>

	* simple.el (next-error-follow-minor-mode)
	(next-error-follow-mode-post-command-hook): New functions.
	(next-error-follow-last-line): New defvar.

	* diff-mode.el (diff-mode-map): Bind next-error-follow-mode.
	* progmodes/compile.el (compilation-mode-map): Likewise.
	* progmodes/grep.el (grep-mode-map): Likewise.
	* replace.el (occur-mode-map): Likewise.

	* newcomment.el (uncomment-region): Bind comment-use-global-state
	to nil.

2004-09-03  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el (auto-revert-handler): Bind `buffer-read-only'
	locally around the call to `revert-buffer'.

2004-09-03  Juri Linkov  <juri@jurta.org>

	* isearch.el (isearch-toggle-regexp): Set `isearch-success' and
	`isearch-adjusted' to `t'.
	(isearch-toggle-case-fold): Set `isearch-success' to `t'.
	(isearch-message-prefix): Add "pending" for isearch-adjusted.
	(isearch-other-meta-char): Restore isearch-point unconditionally.
	(isearch-query-replace): Add new arg `regexp-flag' and use it.
	Set point to start of match if region is not active in transient
	mark mode (to include the current match to region boundaries).
	Push the search string to `query-replace-from-history-variable'.
	Add prompt "Query replace regexp" for isearch-regexp.
	Add region beginning/end as last arguments of `perform-replace.'
	(isearch-query-replace-regexp): Replace code by the call to
	`isearch-query-replace' with arg `t'.

2004-09-03  Richard M. Stallman  <rms@gnu.org>

	* startup.el (normal-top-level): Undo previous TERM change.

2004-09-03  Kim F. Storm  <storm@cua.dk>

	* emulation/cua-rect.el (cua--overlay-keymap): New keymap for
	highlight overlays; allow using RET when cursor is over a button.
	(cua--highlight-rectangle): Use it.
	(cua--rectangle-set-corners): Don't move backwards at eol.
	(cua--forward-line): Don't move into void after eob.

	* emulation/cua-rect.el (cua--rectangle-set-corners): Ensure that
	point is set (and displayed) inside rectangle.
	(cua--rectangle-operation): Fix for highlight of empty lines.
	(cua--highlight-rectangle): Fix highlight for tabs.
	Position cursor at left/right edge of rectangle using new `cursor'
	property on overlay strings.
	(cua--indent-rectangle): Don't tabify.
	(cua-rotate-rectangle): Ignore that point has moved.

2004-09-02  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* term/mac-win.el: Add ASCII equivalents for some function keys.
	(mode-line-frame-identification): Sync with x-win.el.

2004-09-02  Juri Linkov  <juri@jurta.org>

	* progmodes/compile.el (compilation-buffer-name): Compare major
	mode with second element of compilation-arguments instead of third
	to reflect latest changes in compilation-arguments structure.
	(recompile): Use global variable `compilation-directory' to get
	recent compilation directory only when `recompile' is invoked NOT
	in the compilation buffer.  Otherwise, use `default-directory' of
	the compilation buffer.
	(compilation-error-properties): Allow to funcall col and end-col.
	(compilation-mode-font-lock-keywords): Check col and end-col by
	`integerp'.
	(compilation-goto-locus): If end-mk is non-nil in transient mark
	mode don't activate the mark (and don't display message in
	push-mark), but highlight overlay between mk and end-mk.

	* progmodes/grep.el (grep-highlight-matches): New defcustom.
	(grep-regexp-alist): Add rule to highlight grep matches.
	(grep-process-setup): Set env-vars GREP_OPTIONS and GREP_COLOR.

	* info.el (Info-fontify-node): Don't compute other-tag
	if Info-hide-note-references=hide.

	* help.el (function-called-at-point):
	* help-fns.el (variable-at-point):
	Try `find-tag-default' when other methods failed.

	* emacs-lisp/lisp.el (beginning-of-defun, end-of-defun):
	Do not push mark if inhibit-mark-movement is non-nil.

	* textmodes/ispell.el (ispell-html-skip-alists):
	Fix backslashes in docstring.

2004-09-01  Juri Linkov  <juri@jurta.org>

	* isearch.el (isearch-wrap-function)
	(isearch-push-state-function): New defvars.
	(isearch-pop-fun-state): New defsubst.
	(isearch-top-state): Call function saved in `isearch-pop-fun-state'.
	(isearch-push-state): Set the result of calling
	`isearch-push-state-function' to the `isearch-pop-fun-state' field.
	(isearch-cancel): Call function saved in `isearch-pop-fun-state' to
	restore the mode-specific starting point of terminated search.
	(isearch-abort): Call `isearch-cancel' instead of its duplicated code.
	(isearch-repeat): Call `isearch-wrap-function' if defined.
	(isearch-message-prefix): Don't add prefix "over" to the message
	for wrapped search if `isearch-wrap-function' is defined.
	(isearch-search): Call function saved in `isearch-pop-fun-state' to
	restore the mode-specific starting point of failed search.

	* info.el (Info-search-whitespace-regexp): Fix backslashes.
	(Info-search): Add new optional arguments for the sake of isearch.
	Replace whitespace in Info-search-whitespace-regexp literally.
	Add backward search.  Don't call `Info-select-node' if regexp is
	found in the same Info node.  Don't add node to Info-history for
	wrapped isearch.
	(Info-search-backward, Info-isearch-search, Info-isearch-wrap)
	(Info-isearch-push-state, Info-isearch-pop-state): New funs.
	(Info-mode): Set local variables `isearch-search-fun-function',
	`isearch-wrap-function', `isearch-push-state-function',
	`search-whitespace-regexp'.

	* isearch.el: Remove ancient Change Log section.
	(isearch-string, isearch-message-string, isearch-point)
	(isearch-success, isearch-forward-flag, isearch-other-end)
	(isearch-word, isearch-invalid-regexp, isearch-wrapped)
	(isearch-barrier, isearch-within-brackets)
	(isearch-case-fold-search): Add suffix `-state' to state-related
	defsubsts to avoid name clashes with other function names.

	* simple.el (next-error): New defgroup and defface.
	(next-error-highlight, next-error-highlight-no-select):
	New defcustoms.
	(next-error-no-select): Let-bind next-error-highlight to the value
	of next-error-highlight-no-select before calling `next-error'.

	* progmodes/compile.el (compilation-goto-locus):
	Use `next-error' face instead of `region'.  Set 4-th argument of
	`move-overlay' to `current-buffer' to move overlay to different
	source buffers.  Use new variable `next-error-highlight'.

	* simple.el (next-error-find-buffer): Move the rule
	"if current buffer is a next-error capable buffer" after the
	rule "if next-error-last-buffer is set to a live buffer".
	Simplify to test all rules in one `or'.
	(next-error): Doc fix.
	(next-error, previous-error, first-error)
	(next-error-no-select, previous-error-no-select):
	Make arguments optional.

2004-08-31  Luc Teirlinck  <teirllm@auburn.edu>

	* macros.el (apply-macro-to-region-lines): Make it operate on all
	lines that begin in the region, rather than on all complete lines
	in the region.

2004-08-31  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* x-dnd.el (x-dnd-protocol-alist): Document update.
	(x-dnd-known-types): Defcustom it.
	(x-dnd-handle-motif): Print message-atom in error message.

2004-08-30  John Paul Wallington  <jpw@gnu.org>

	* textmodes/tex-mode.el (tex-validate-buffer): Use distinct
	strings rather than programatically constructing message.

2004-08-30  Richard M. Stallman  <rms@gnu.org>

	* emacs-lisp/lisp-mode.el (prin1-char): Don't turn S-a into A.
	Don't return a string that would read as the wrong character code.

2004-08-29  Kim F. Storm  <storm@cua.dk>

	* emulation/cua-base.el (cua-auto-expand-rectangles):
	Remove automatic rectangle padding feature; replace by non-destructive
	virtual rectangle edges feature.
	(cua-virtual-rectangle-edges): New defcustom.
	(cua-auto-tabify-rectangles): New defcustom.
	(cua-paste): If paste into a marked rectangle, insert rectangle at
	current column, even if virtual; also paste exactly as many lines
	as has been marked (ignore additional lines or add empty lines),
	but paste whole source if only one line is marked.
	(cua--update-indications): No longer use overwrite-cursor to
	indicate rectangle padding

	* emulation/cua-rect.el (cua--rectangle-padding): Remove.
	(cua--rectangle-virtual-edges): New defun.
	(cua--rectangle-get-corners): Remove optional PAD arg.
	(cua--rectangle-set-corners): Never do padding.
	(cua--forward-line): Remove optional PAD arg.  Simplify.
	(cua-resize-rectangle-right, cua-resize-rectangle-left)
	(cua-resize-rectangle-down, cua-resize-rectangle-up):
	(cua-resize-rectangle-bot, cua-resize-rectangle-top)
	(cua-resize-rectangle-page-up, cua-resize-rectangle-page-down)
	(cua--rectangle-move): Never do padding.  Simplify.
	(cua--tabify-start): New defun.
	(cua--rectangle-operation): Add tabify arg.  All callers changed.
	(cua--pad-rectangle): Remove.
	(cua--delete-rectangle): Handle delete with virtual edges.
	(cua--extract-rectangle): Add spaces if rectangle has virtual edges.
	(cua--insert-rectangle): Handle insert at virtual column.
	Perform auto-tabify if necessary.
	(cua--activate-rectangle): Remove optional FORCE arg.
	Never do padding.  Simplify.
	(cua--highlight-rectangle): Enhance for virtual edges.
	(cua-toggle-rectangle-padding): Remove command.
	(cua-toggle-rectangle-virtual-edges): New command.
	(cua-sequence-rectangle): Add optional TABIFY arg.  Callers changed.
	(cua--rectangle-post-command): Don't force rectangle padding.
	(cua--init-rectangles): Bind M-p to cua-toggle-rectangle-virtual-edges.

2004-08-28  Luc Teirlinck  <teirllm@auburn.edu>

	* indent.el (edit-tab-stops-buffer): Doc fix.

2004-08-28  Richard M. Stallman  <rms@gnu.org>

	* progmodes/grep.el (grep-default-command): Use find-tag-default.
	(grep-tag-default): Function deleted.

	* subr.el (find-tag-default): Moved from etags.el.

	* progmodes/etags.el (find-tag-default): Moved to subr.el.

	* emacs-lisp/lisp-mode.el (prin1-char): Put `shift' modifier
	into the basic character if it has an uppercase form.

2004-08-27  Kenichi Handa  <handa@m17n.org>

	* international/utf-8.el (utf-8-post-read-conversion): If the
	buffer is unibyte, temporarily make it multibyte.

2004-08-27  Masatake YAMATO  <jet@gyve.org>

	* calendar/time-date.el (time-to-seconds): Add autoload cookies.

2004-08-25  John Paul Wallington  <jpw@gnu.org>

	* textmodes/tex-mode.el (tex-validate-buffer): Distinguish between
	0, 1, and many mismatches in message.
	(tex-start-shell): Use `set-process-query-on-exit-flag'.

	* ielm.el (ielm-tab, ielm-complete-symbol): Doc fix.
	(inferior-emacs-lisp-mode): Use	`set-process-query-on-exit-flag'.

2004-08-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-svn.el (vc-svn-diff): Treat options from vc-svn-diff-switches and
	vc-diff-switches differently.

2004-08-22  Luc Teirlinck  <teirllm@auburn.edu>

	* speedbar.el (speedbar-file-regexp): Give it a phony defvar
	before and a real defvar after
	`speedbar-supported-extension-expressions'.  This is to silence
	the compiler without breaking bootstrapping.

2004-08-22  Richard M. Stallman  <rms@gnu.org>

	* textmodes/flyspell.el (flyspell-word):
	Use set-process-query-on-exit-flag.
	(flyspell-highlight-duplicate-region): Take POSS as arg.
	(flyspell-word): Pass POSS as arg.

	* progmodes/ada-xref.el: Many doc and style fixes.
	(ada-find-any-references): Use compilation-start.
	(ada-get-ali-file-name): Improve error msg.
	(ada-get-ada-file-name): Likewise.

	* net/ange-ftp.el (ange-ftp-gwp-start, ange-ftp-nslookup-host)
	(ange-ftp-start-process): Use set-process-query-on-exit-flag.

	* mail/mail-extr.el (mail-extr-all-top-level-domains):
	Add forward defvar.

	* whitespace.el (global-whitespace-mode): New alias
	for whitespace-global-mode.

	* speedbar.el (speedbar-file-regexp): Definition moved up.
	(speedbar-mode, speedbar-set-mode-line-format):
	Use with-no-warnings.
	(speedbar-emacs-popup-kludge): Delete Emacs 19 alternative.

	* simple.el (shell-command-on-region): New arg DISPLAY-ERROR-BUFFER
	controls whether to display the error buffer.

	* ps-mule.el: Delete compatibility code for old Emacses.
	(ps-mule-find-wrappoint): Don't use chars-in-region.

	* frame.el (display-mouse-p, display-selections-p):
	Use with-no-warnings.

	* font-lock.el (font-lock-set-defaults): Use with-no-warnings.

2004-08-22  David Kastrup  <dak@gnu.org>

	* textmodes/reftex-auc.el, progmodes/meta-mode.el: Update AUCTeX
	information.

	* speedbar.el, iswitchb.el, ido.el: Update AUCTeX information.

2004-08-22  Andreas Schwab  <schwab@suse.de>

	* cvs-status.el: Require pcvs during byte-compiling for defun-cvs-mode.

2004-08-22  Masatake YAMATO  <jet@gyve.org>

	* cvs-status.el (cvs-status-checkout): New function.
	(cvs-status-mode-map): Add a key definition for `cvs-status-checkout'.

2004-08-21  David Kastrup  <dak@gnu.org>

	* net/ange-ftp.el (ange-ftp-hash-entry-exists-p)
	(ange-ftp-file-entry-p, ange-ftp-file-symlink-p): Since the code
	has been converted to use hashtables, the relation `nil=none' is
	no longer valid, as `nil' is not a hashtable.  This patch tries to
	reduce the number of resulting errors.

2004-08-21  John Paul Wallington  <jpw@gnu.org>

	* subr.el (process-kill-without-query): Made obsolete in
	version	21.4, not 21.5.

	* log-edit.el (vc-comment-ring, vc-comment-ring-index)
	(vc-previous-comment, vc-next-comment)
	(vc-comment-search-reverse, vc-comment-search-forward)
	(vc-comment-to-change-log): Likewise.

	* international/latin1-disp.el (latin1-char-displayable-p): Likewise.

2004-08-21  Peter Seibel  <peter@javamonkey.com>  (tiny patch)

	* emacs-lisp/cl-indent.el (lisp-indent-defmethod):
	Correct indentation of DEFMETHODS with non-standard method
	combinations (e.g., PROGN, MIN, MAX).

2004-08-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* startup.el (normal-top-level-add-subdirs-to-load-path):
	Avoid unnecessarily checking system-type.
	(normal-top-level): Set TERM to "dumb".  Simplify.

	* avoid.el (mouse-avoidance-ignore-p): New fun.
	Also ignore switch-frame, select-window, double, and triple clicks.
	(mouse-avoidance-banish-hook, mouse-avoidance-exile-hook)
	(mouse-avoidance-fancy-hook): Use it.

2004-08-20  Zoran Milojevic  <zoran@sipquest.com>  (tiny change)

	* avoid.el (mouse-avoidance-nudge-mouse)
	(mouse-avoidance-banish-destination): Stay within the current window
	to avoid problems with mouse-autoselect-window.

2004-08-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* pcvs-parse.el (cvs-parse-table, cvs-parse-commit): Try to adapt to
	the newer format of some messages in cvs-1.12.1.

2004-08-19  Masatake YAMATO  <jet@gyve.org>

	* emacs-lisp/elp.el (elp-results-symname-map): New keymap.
	(elp-results-jump-to-definition-by-mouse)
	(elp-results-jump-to-definition, elp-output-insert-symname): New funs.
	(elp-output-result): Use elp-output-insert-symname.

2004-08-18  Kenichi Handa  <handa@m17n.org>

	* language/cyrillic.el: Register koi8-r in
	ctext-non-standard-encodings-alist.
	("Cyrillic-KOI8"): Add ctext-non-standard-encoding.

2004-08-17  Luc Teirlinck  <teirllm@auburn.edu>

	* emacs-lisp/copyright.el (copyright-update-year): Delete code
	that replaces 20xy with xy.

2004-08-17  John Paul Wallington  <jpw@gnu.org>

	* emacs-lisp/re-builder.el (reb-mode-map): Define within defvar.
	(reb-force-update): Doc fix.

2004-08-16  Richard M. Stallman  <rms@gnu.org>

	* progmodes/which-func.el (which-func-update-1): Doc fix.

	* progmodes/sh-script.el (sh-set-shell): Use sh-mode-abbrev-table.
	(sh-mode-abbrev-table): New variable.

	* progmodes/compile.el (compilation-mode): Doc fix.

	* emacs-lisp/lisp-mode.el (eval-last-sexp):
	Don't cons a new symbol each time.
	(eval-last-sexp-fake-value): New variable.

	* emacs-lisp/copyright.el (copyright-years-regexp): New variable.
	(copyright-update-year): Detect continuation of list of years.

	* term.el (term-default-fg-color, term-default-bg-color)
	(ansi-term-color-vector): Use `unspecified', not nil, as default.

	* imenu.el: Several doc fixes: don't say variables are buffer-local.

2004-08-16  Davis Herring <herring@lanl.gov>

	* isearch.el (isearch-string, isearch-message-string, isearch-point)
	(isearch-success, isearch-forward-flag, isearch-other-end)
	(isearch-word, isearch-invalid-regexp, isearch-wrapped)
	(isearch-barrier, isearch-within-brackets)
	(isearch-case-fold-search): Fix broken `nth'-like calls to `aref'.

2004-08-16  Kenichi Handa  <handa@m17n.org>

	* ps-mule.el (ps-mule-font-info-database): Fix docstring.

2004-08-15  Kenichi Handa  <handa@m17n.org>

	* term/x-win.el (x-selection-value): If utf8 was successful but
	ctext was not, use utf8 string.

2004-08-14  Davis Herring  <herring@lanl.gov>

	* isearch.el: Remove accidental changes of March 4.  Fix backing
	up when a regexp isearch is made more general.  Use symbolic
	accessor functions for isearch stack frames to make usage clearer.
	(search-whitespace-regexp): Made groups in documentation shy (as
	is the group in the default value).
	(isearch-fallback): New function, addresses problems with regexps
	liberalized by `\|', adds support for liberalization by `\}' (the
	general repetition construct), and incorporates behavior for
	`*'/`?'.
	(isearch-}-char): New command, calls `isearch-fallback' with
	arguments appropriate to a typed `}'.
	(isearch-*-char, isearch-|-char): Now just call `isearch-fallback'
	appropriately.
	(isearch-mode-map): Bind `}' to `isearch-}-char'.
	(isearch-string, isearch-message,string, isearch-point)
	(isearch-success, isearch-forward-flag, isearch-other-end)
	(isearch-word, isearch-invalid-regexp, isearch-wrapped)
	(isearch-barrier, isearch-within-brackets, isearch-case-fold-search):
	New inline functions to read fields of a stack frame.

2004-08-14  Kurt Hornik  <Kurt.Hornik@wu-wien.ac.at>  (tiny change)

	* battery.el (battery-linux-proc-acpi): Look into battery
	directories matching the literal string "CMB", too (required for
	Linux kernel version 2.6.7).

2004-08-14  John Paul Wallington  <jpw@gnu.org>

	* cus-start.el (read-file-name-completion-ignore-case): Add.
	(blink-cursor-alist): Change version to "21.4".

	* emacs-lisp/bytecomp.el (forward-word): Allow 0 args.

2004-08-11  Daniel Pfeiffer  <occitan@esperanto.org>

	* speedbar.el (speedbar-scan-subdirs): New option.
	(speedbar-file-lists): Don't ignore file-name case on Unix and use
	dolist.
	(speedbar-insert-files-at-point): Take an extra argument and use
	it to optionally find out if a subdir is empty.  Also unreadable
	files don't get expand buttons.
	(speedbar-directory): New image (unused pixmap already existed).
	(speedbar-expand-image-button-alist): Use it.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	CC Mode update to 5.30.9:

	* progmodes/cc-defs.el, progmodes/cc-vars.el (c-emacs-features):
	Move from cc-vars to cc-defs for dependency reasons.  Fix the
	POSIX char class test to check that it works in
	`skip-chars-(forward|backward)' too.

	* progmodes/cc-align.el (c-lineup-arglist): Fix bug when the
	first argument starts with a special brace list.

	* progmodes/cc-engine.el (c-forward-type): Fix promotion bug
	when `c-opt-type-concat-key' is used (i.e. in Pike).

	* progmodes/cc-engine.el (c-looking-at-special-brace-list):
	Fix bug when the inner char pair doesn't have paren syntax, i.e. "(<
	>)".

	* progmodes/cc-align.el (c-lineup-multi-inher): Made it syntactic
	whitespace safe.

	* progmodes/cc-engine.el (c-guess-basic-syntax): Fix anchor
	position for `arglist-intro', `arglist-cont-nonempty' and
	`arglist-close' when there are two arglist open parens on the same
	line and there's nothing in front of the first.

	* progmodes/cc-fonts.el (c-basic-matchers-before): Fix font
	locking of qualified names in Java, which previously could fontify
	common indexing expressions in many cases.  The standard Java
	naming conventions are used to tell them apart.

	* progmodes/cc-align.el (c-lineup-whitesmith-in-block):
	Fix inconsistency wrt opening parens on the first line inside a paren
	block.

	* progmodes/cc-defs.el (c-langs-are-parametric): Must be known at
	compile time for the sake of `c-major-mode-is'.

	(c-mode-is-new-awk-p): Made it a macro to delay expansion of
	`c-major-mode-is' in the event that this is used inside a
	`c-lang-defconst'.

	* progmodes/cc-defs.el (c-major-mode-is): Fix expansion inside
	`c-lang-defconst' so that it works better with fallback languages.

	* progmodes/cc-defs.el (c-add-language): Fix a typo that caused
	it to fail to record the base mode.

	* progmodes/cc-engine.el (c-syntactic-re-search-forward):
	Fix bug so that it doesn't go past the closing paren when PAREN-LEVEL
	is used.  Reordered the syntax checks to get more efficient
	skipping in some situations.

	* progmodes/cc-cmds.el (c-electric-brace): Don't trip up on a line
	continuation which might precede the newly inserted '{'.

	* progmodes/cc-engine.el (c-syntactic-re-search-forward):
	Fix cases where it could loop indefinitely.

	* progmodes/cc-fonts.el (c-font-lock-declarators): Handle array
	size specs correctly.  Only fontify identifiers in front of '('
	with as functions - don't accept any paren char.  Tightened up
	initializer skipping to stop before function and class blocks.

	* progmodes/cc-engine.el (c-beginning-of-decl-1): Fix bug where
	the point could be left directly after an open paren when finding
	the beginning of the first decl in the block.

	* progmodes/cc-engine.el (c-parse-state): Don't use the syntax
	table when filtering out legitimate open parens to be recorded.
	This could cause cache inconsistencies when e.g.
	`c++-template-syntax-table' was temporarily in use.

	* progmodes/cc-engine.el (c-on-identifier)
	(c-simple-skip-symbol-backward): Small fix for handling "-"
	correctly in `skip-chars-backward'.  Affected the operator lfun
	syntax in Pike.

	* progmodes/cc-engine.el (c-invalidate-sws-region-after):
	Fix bug that could cause an error from `after-change-functions' when
	the changed region is at bob.

2004-08-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	CC Mode update to 5.30.9:

	* progmodes/cc-cmds.el, progmodes/cc-vars.el: Amend doc(-strings)
	to say that <TAB> doesn't insert WS into a CPP line.
	(c-indent-command, c-tab-always-indent): Amend doc strings.

	* progmodes/cc-styles.el, progmodes/cc-engine.el: Add in two
	checks for user errors, thus eliminating cryptic and unhelpful
	Emacs error messages.  (1) Check the arg to `c-set-style' is a
	string.  (2) Check that settings to `c-offsets-alist' are not
	spuriously quoted.

	* progmodes/cc-cmds.el: (c-electric-brace): Don't delete a comment
	which precedes the newly inserted `{'.

2004-08-10  Michael Albinus  <michael.albinus@gmx.de>

	Sync with Tramp 2.0.44.

	* net/tramp.el (tramp-post-connection): Quote $1 and $2 of shell
	function "tramp_file_attributes".  Otherwise, file names
	containing spaces are misinterpreted.  Reported by Magnus Henoch
	<mange@freemail.hu>.
	(tramp-handle-file-truename): FILENAME must be expanded first.
	Otherwise, parameters like "/ssh:deego@gnufans.net:~" will return
	obscure results.  Reported by D. Goel <deego@gnufans.org>.
	(tramp-handle-verify-visited-file-modtime): If file does not
	exist, say it is not modified if and only if that agrees with the
	buffer's record.  Check whether a file is visiting the buffer, or
	the buffer has no recorded last modification time.  Return t in
	case the visiting file doesn't exist.  Suggested by Luc Teirlinck
	<teirllm@auburn.edu>.
	(tramp-handle-write-region): Pass modtime explicitely to
	`set-visited-file-modtime', because filename can be different
	from (buffer-file-name) if `file-precious-flag' is set.
	`set-visited-file-modtime' must be called always when `visit' is t
	or a string.  Suggested by Luc Teirlinck <teirllm@auburn.edu>.
	(tramp-handle-set-visited-file-modtime): If `time-list' is not
	nil, don't apply the whole body.  If the file doesn't exists, set
	modtime to '(-1 65535).  Suggested by Luc Teirlinck
	<teirllm@auburn.edu>.

2004-08-09  Luc Teirlinck  <teirllm@auburn.edu>

	* help.el (describe-bindings): Doc fix.

	* subr.el (kbd): Doc fix.

2004-08-08  John Paul Wallington  <jpw@gnu.org>

	* ibuffer.el (define-ibuffer-column size): Use `string-to-number'
	instead of `string-to-int'.
	(define-ibuffer-column mode): Fix indentation.

2004-08-08  Lars Hansen  <larsh@math.ku.dk>

	* wid-edit.el (widget-sexp-validate): Allow whitespace after expression.

2004-08-08  Luc Teirlinck  <teirllm@auburn.edu>

	* subr.el (global-unset-key, local-unset-key): Doc fixes.

	* novice.el (disabled-command-function): New variable renamed from
	`disabled-command-hook'.
	(disabled-command-hook): Keep the _variable_ as alias for
	`disabled-command-function' and make obsolete.
	(disabled-command-function): Function renamed from
	`disabled-command-hook'.  Adapt code to name change of the variable.

2004-08-07  Satyaki Das  <satyaki@theforce.stanford.edu>  (tiny change)

	* simple.el (completion-root-regexp): New defvar.
	(completion-setup-function): Use it instead of a literal string.

2004-08-07  John Paul Wallington  <jpw@gnu.org>

	* emacs-lisp/re-builder.el (reb-re-syntax): Add `rx' syntax.
	(reb-lisp-mode): Require `rx' feature when `re-reb-syntax' is `rx'.
	(reb-lisp-syntax-p, reb-change-syntax): `rx' is a Lisp syntax.
	(reb-cook-regexp): Call `rx-to-string' when `re-reb-syntax' is `rx'.

2004-08-05  Katsumi Yamaoka  <yamaoka@jpl.org>  (tiny change)

	* mail/mail-extr.el (mail-extr-disable-voodoo): New variable.
	(mail-extr-voodoo): Check mail-extr-disable-voodoo.

2004-08-04  Kenichi Handa  <handa@m17n.org>

	* international/encoded-kb.el (encoded-kbd-setup-keymap):
	Fix previous change.

2004-08-03  Kenichi Handa  <handa@m17n.org>

	* international/encoded-kb.el: The following changes are to
	utilize key-translation-map instead of minor mode map.
	(encoded-kbd-iso2022-non-ascii-map): Delete it.
	(encoded-kbd-coding, encoded-kbd-handle-8bit): Delete them.
	(encoded-kbd-last-key): New function.
	(encoded-kbd-iso2022-single-shift): New function.
	(encoded-kbd-iso2022-designation)
	(encoded-kbd-self-insert-iso2022-7bit)
	(encoded-kbd-self-insert-iso2022-8bit)
	(encoded-kbd-self-insert-sjis, encoded-kbd-self-insert-big5)
	(encoded-kbd-self-insert-ccl): Make them suitable for bindings in
	key-translation-map.
	(encoded-kbd-setup-keymap): Setup key-translation-map.
	(saved-key-translation-map): New variable.
	(encoded-kbd-mode): Save/restore key-translation-map.
	Adjust for the change of encoded-kbd-setup-keymap.

2004-08-02  Kim F. Storm  <storm@cua.dk>

	* avoid.el (mouse-avoidance-point-position): Use window-inside-edges
	and call compute-motion with nil for topos and width to get proper
	usable width and height for both window and non-window systems.

	* windmove.el (windmove-coordinates-of-position): Let compute-motion
	calculate usable window width and height.

	* window.el (window-buffer-height): Call compute-motion with nil width.

2004-08-01  David Kastrup  <dak@gnu.org>

	* replace.el (query-replace-read-from):
	Use `query-replace-compile-replacement'.
	(query-replace-compile-replacement): New function.
	(query-replace-read-to): Use `query-replace-compile-replacement'
	for repeating the last command.

2004-08-01  John Paul Wallington  <jpw@gnu.org>

	* printing.el (toplevel, pr-ps-fast-fire, pr-ps-set-utility)
	(pr-ps-set-printer, pr-txt-set-printer, pr-eval-setting-alist)
	(pr-switches): Remove period from end of error messages.

	* help-mode.el (help-go-back): Likewise.

	* abbrev.el (only-global-abbrevs): Doc fix.
	(edit-abbrevs-map): Define within defvar.
	(quietly-read-abbrev-file): Doc fix.

2004-07-31  Luc Teirlinck  <teirllm@auburn.edu>

	* novice.el (enable-command, disable-command): Doc fixes.

	* subr.el (event-modifiers, event-basic-type): Doc fixes.

2004-07-30  Richard M. Stallman  <rms@gnu.org>

	* subr.el (with-local-quit): Doc fix.

2004-07-30  Luc Teirlinck  <teirllm@auburn.edu>

	* international/utf-8.el (utf-translate-cjk-mode): Doc fix.

2004-07-28  Luc Teirlinck  <teirllm@auburn.edu>

	* custom.el (defcustom): Doc fix.

2004-07-28  Masatake YAMATO  <jet@gyve.org>

	* progmodes/etags.el (etags-tags-apropos): Show building progress.

2004-07-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* imenu.el (imenu-prev-index-position-function)
	(imenu-extract-index-name-function, imenu-name-lookup-function)
	(imenu--index-alist): Docstring redundancy fix.

2004-07-25  Lars Hansen  <larsh@math.ku.dk>

	* wdired.el (wdired-finish-edit): Require dired-aux before locally
	binding dired-backup-overwrite.

2004-07-25  John Paul Wallington  <jpw@gnu.org>

	* subr.el (butlast, event-modifiers, event-basic-type): Doc fixes.

2004-07-24  Luc Teirlinck  <teirllm@auburn.edu>

	* term/tty-colors.el (tty-color-approximate): Doc fix.

	* select.el (x-get-selection, x-set-selection): Doc fixes.

	* frame.el (make-frame): Doc fix.

2004-07-24  Richard M. Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-mime-charset-pattern):
	Don't include semicolon in the charset value.

	* replace.el (occur-next-error): Call set-window-point.
	(occur-engine): Handle negative NLINES.

2004-07-23  Luc Teirlinck  <teirllm@auburn.edu>

	* frame.el (modify-all-frames-parameters): Minor doc fix.
	(set-frame-configuration): Doc fix.

2004-07-23  Matt Hodges  <matt@stchem.bham.ac.uk>  (tiny change)

	* simple.el (completion-setup-function): Compute the common parts
	and the first difference place correctly when
	partial-completion-mode is on.

2004-07-22  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* ps-print.el: Doc fix.
	(ps-print-version): New version 6.6.5.
	(ps-printing-region): Doc fix.
	(ps-generate-string-list): Comment fix.
	(ps-message-log-max): Code fix.

2004-07-22  Michael Piotrowski  <mxp@dynalabs.de>  (tiny change)

	* ps-print.el (ps-begin-file): Improve the DSC compliance of the
	generated PostScript.

2004-08-17  Reiner Steib  <Reiner.Steib@gmx.de>

	* net/tls.el (tls-process-connection-type): Fix docstring.  (Sync
	with Gnus v5_10 branch.)

2004-08-16  Reiner Steib  <Reiner.Steib@gmx.de>

	* calendar/time-date.el (time-to-number-of-days): New function.
	Imported from from Gnus.

2004-07-22  Kim F. Storm  <storm@cua.dk>

	* progmodes/make-mode.el: Fix comments.

2004-07-21  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: Doc fix.

2004-07-20  Luc Teirlinck  <teirllm@auburn.edu>

	* frame.el (modify-all-frames-parameters): Minor doc fix.

2004-07-20  Richard M. Stallman  <rms@gnu.org>

	* textmodes/fill.el (fill-nobreak-p): If this break point is
	at the end of the line, don't consider the newline which follows
	as a reason to return t.

2004-07-19  John Paul Wallington  <jpw@gnu.org>

	* dired-aux.el (dired-file-set-difference): Don't use `caddr'.

2004-07-18  Luc Teirlinck  <teirllm@auburn.edu>

	* dired-aux.el (dired-do-kill-lines): Expand docstring.
	Delete irrelevant code.

2004-07-17  Kai Grossjohann  <kai.grossjohann@gmx.net>

	* net/tramp.el (tramp-handle-verify-visited-file-modtime):
	New docstring.  From Luc Teirlinck.

2004-07-17  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el: Describe `Auto Revert Tail Mode' in `Commentary'
	section.
	(auto-revert-handler): Do not check `auto-revert-tail-mode' for
	non-file buffers.  We know it is nil.

2004-07-17  Kai Grossjohann  <kai.grossjohann@gmx.net>

	Sync with Tramp 2.0.43.

	* net/tramp.el (tramp-handle-verify-visited-file-modtime):
	Remove outdated comment.
	(tramp-locked, tramp-locker): New variables for implementing a
	global lock.
	(tramp-sh-file-name-handler): Use them to implement the global lock.

2004-07-13  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (all): Code cleanup.  Change all `tramp-handle-xxx'
	calls to respective `xxx` calls.
	(tramp-process-alive-regexp): Precise doc string.
	(tramp-multi-action-process-alive): New defun.
	(tramp-multi-actions): Use it.
	(tramp-handle-find-backup-file-name): `copy-tree' is available
	since Emacs 21.4 only (XEmacs has it).  Implementation rewritten
	in order to avoid this function.
	(tramp-handle-write-region): Set current buffer.  If connection
	wasn't open, `file-modes' has changed it accidently.  Reported by
	David Kastrup <dak@gnu.org>.
	(tramp-enter-password, tramp-read-passwd): New arguments USER and
	HOST.
	(tramp-action-password, tramp-multi-action-password): Apply it.
	(tramp-open-connection-rsh): If a port is given, the Tramp buffer
	name must still contain the port number.  Otherwise, we have two
	Tramp buffers, with all the confusion.  Reported by Myron Selby
	<myron@xytech.com> and Rolf Dubitzky
	<Dubitzky@physi.uni-heidelberg.de>.

	* net/tramp-smb.el (tramp-smb-open-connection): Apply USER and
	HOST to `tramp-enter-passwd'.

	* net/tramp-vc.el (all): Code cleanup.  Change all
	`tramp-handle-xxx' calls to respective `xxx` calls.

2004-07-17  Jonathan Yavner  <jyavner@member.fsf.org>

	* emacs-lisp/testcover.el: New category "potentially-1valued" for
	functions that are not erroneous if either 1-valued or
	multi-valued.  Detect functions in this class.
	(testcover-1value-functions, testcover-compose-functions)
	(testcover-progn-functions) Added some additional functions to lists.
	(testcover-mark): Bugfix when marking up the definition for an
	empty function.

2004-07-17  Richard M. Stallman  <rms@gnu.org>

	* replace.el (occur-read-primary-args): Pass default to
	read-from-minibuffer.

	* mail/footnote.el (footnote-section-tag): Use defcustom.

	* font-lock.el (font-lock-add-keywords, font-lock-remove-keywords):
	Compile font-lock-keywords, not KEYWORDS.
	(lisp-font-lock-keywords-2): Add multiple-value-prog1, go.
	Add warn, check-type.  Handle cerror like error.

2004-07-14  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/which-func.el (which-func-keymap): New var.
	(which-func-face): New face.
	(which-func-format): Use them.

2004-07-16  Stephan Stahl  <stahl@eos.franken.de>  (tiny change)

	* buff-menu.el (list-buffers-noselect): Append the buffer's
	process status to its mode name.

2004-07-16  Kim F. Storm  <storm@cua.dk>

	* simple.el (inhibit-mark-movement): New defvar.
	(beginning-of-buffer, end-of-buffer): Do not push mark if
	inhibit-mark-movement is non-nil or C-u prefix is given.

	* emulation/cua-base.el (cua--preserve-mark-commands): New defvar.
	Init to beginning-of-buffer and end-of-buffer.
	(cua--undo-push-mark): New defvar.
	(cua--pre-command-handler): Set inhibit-mark-movement if mark is
	already active and command is in cua--preserve-mark-commands.
	Also fix check for shift modifier on non-window systems.
	(cua--post-command-handler): Clear inhibit-mark-movement if set.

2004-07-14  Luc Teirlinck  <teirllm@auburn.edu>

	* calendar/cal-dst.el (calendar-time-from-absolute): Return a list
	of two integers, instead of a cons.

	* net/tramp.el (tramp-handle-verify-visited-file-modtime):
	`visited-file-modtime' now returns a list of two integers, instead
	of a cons.

	* dired.el (dired-directory-changed-p): Ditto.

	* progmodes/grep.el (grep): Doc fix.

2004-07-14  Daniel Pfeiffer  <occitan@esperanto.org>

	* autorevert.el (auto-revert-tail-mode)
	(auto-revert-tail-mode-text, auto-revert-tail-pos): New vars.
	(auto-revert-mode): Turn off auto-revert-tail-mode, so we're not
	in both at the same time.
	(auto-revert-tail-mode): New command.
	(turn-on-auto-revert-tail-mode, auto-revert-tail-handler): New funs.
	(auto-revert-handler): Revert only either tail or whole file.

	* bindings.el (mode-line-mode-menu): Fix alphabetical ordering and
	add auto-revert-tail-mode.

2004-07-12  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: Doc fix.  Change name of some funs.
	(pr-dosify-file-name): New fun.  Replace ps-dosify-path.
	(pr-unixify-file-name): New fun.  Replace ps-unixify-path.
	(pr-standard-file-name): New fun.  Replace pr-standard-path.
	(pr-call-process): Code fix.

2004-07-12  Luc Teirlinck  <teirllm@auburn.edu>

	* subr.el (with-selected-window): Doc fix.

2004-07-11  Luc Teirlinck  <teirllm@auburn.edu>

	* subr.el (get-buffer-window-list): Doc fix.

2004-07-10  Luc Teirlinck  <teirllm@auburn.edu>

	* files.el (switch-to-buffer-other-window): Doc fix.

	* window.el (save-selected-window, one-window-p)
	(split-window-keep-point, split-window-vertically)
	(split-window-horizontally): Doc fixes.

2004-07-10  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: Doc fix.  Now it uses call-process instead of
	shell-command for low command execution.
	(pr-version): New version number (6.8).
	(pr-shell-file-name): Option removed.
	(pr-shell-command): Fun removed.
	(pr-call-process): New fun.  Replace pr-shell-command.
	(pr-standard-path, pr-remove-nil-from-list): New funs.
	(zmacs-region-stays, current-mouse-event, current-menubar): New var.
	(pr-ps-file-preview, pr-ps-file-using-ghostscript, pr-ps-file-print)
	(pr-setup, pr-ps-set-printer, pr-txt-set-printer)
	(pr-ps-utility-process, pr-txt-print): Code fix.

2004-07-10  Stephan Stahl  <stahl@eos.franken.de>  (tiny change)

	* ediff-mult.el (ediff-meta-truncate-filenames): Change type to
	boolean.

2004-07-09  Lars Hansen  <larsh@math.ku.dk>

	* wid-edit.el (widget-field-buffer): Doc fix.

2004-07-09  John Paul Wallington  <jpw@gnu.org>

	* emacs-lisp/re-builder.el (reb-update-overlays):
	Distinguish between one and several matches in message.

2004-07-09  Richard M. Stallman  <rms@gnu.org>

	* mouse.el (mouse-set-region-1): If transient-mark-mode
	is `identity', change it to `only'.

	* simple.el (current-word): Doc fix.

2004-07-09  Mark A. Hershberger  <mah@everybody.org>

	* progmodes/cperl-mode.el (cperl-mode): Adapt defun-prompt-regexp
	so that it is more understanding of whitespace.

	* xml.el (xml-maybe-do-ns, xml-parse-tag): Produce elements in the
	form
	(("ns" . "element") (attr-list) children) instead of
	((:ns . "element") (attr-list) children) in order to reduce the
	number of symbols used.
	(xml-skip-dtd): Change to use xml-parse-dtd but set
	xml-validating-parsing to nil.
	(xml-parse-dtd): Parse entity deleclarations in DOCTYPEs.
	(xml-substitute-entity): Remove in favor of new entity substitution.
	(xml-substitute-special): Rewrite in to substitute complex
	entities from DOCTYPE declarations.
	(xml-parse-fragment): Parse fragments from entity deleclarations.
	(xml-parse-region, xml-parse-tag, xml-parse-attlist)
	(xml-parse-dtd, xml-substitute-special): Make validity checks
	conditioned on xml-validating-parser.  Add "Not Well Formed" to
	error messages about well-formedness.

2004-07-08  Steven Tamm  <steventamm@mac.com>

	* term/mac-win.el (mac-scroll-ignore-events, mac-scroll-down)
	(mac-scroll-down-line, mac-scroll-up, mac-scroll-up-line):
	Do not treat double clicks and triple clicks specially in the
	scroll bar (preventing strange repositioning problems)

2004-07-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* replace.el (query-replace-regexp-eval): Fix last change.

2004-07-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* replace.el (query-replace-descr): New fun.
	(query-replace-read-from, query-replace-read-args): Default to the
	previous from&to.
	(query-replace-read-to): Quote the `from' string when displaying it.
	(query-replace-regexp-eval): Immediately check read-only status.
	Use query-replace-read-from to get the \n checking.
	Quote the `from' string when displaying it.
	(map-query-replace-regexp, occur-read-primary-args):
	Quote the `from' string when displaying it.

	* isearch.el (isearch-query-replace): Pass the regexp-ness and
	delimited-ness of the search to query-replace.

	* replace.el (query-replace-read-from, query-replace-read-to):
	New funs extracted from query-replace-read-args.
	(query-replace-read-args): Use them.

	* replace.el (query-replace-interactive, query-replace-read-args):
	Remove the `initial' special value.
	(query-replace-regexp-eval, map-query-replace-regexp): Simplify.
	(occur-engine): Remove unused var `matchend'.

	* isearch.el (isearch-query-replace, isearch-query-replace-regexp):
	Use the search string without prompting.

2004-07-05  Kenichi Handa  <handa@m17n.org>

	* international/mule.el (decode-coding-inserted-region):
	Set last-coding-system-used only when coding is nil.

2004-07-03  Eli Zaretskii  <eliz@gnu.org>

	* progmodes/grep.el (grep-compute-defaults, grep-command)
	(grep-program, find-program, grep-find-use-xargs, grep-history)
	(grep-find-history, grep-tag-default, grep-find-command)
	(grep-regexp-alist, grep-process-setup, grep-compute-defaults):
	Add autoload cookies, for unbundled packages that load `compile'
	and expect all grep-related symbols to become defined.

2004-07-03  KOSEKI Yoshinori  <kose@meadowy.org>

	* iimage.el (turn-on-iimage-mode, iimage-mode): Add autoload cookies.
	(iimage-mode-image-search-path): New user option to search the
	image file.
	(iimage-locate-file): New funcion.  Emacs21.3 or earlier does not
	have locate-file.
	(iimage-mode-buffer): Use it.

2004-07-03  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el (gdb-goto-breakpoint): String match more
	carefully.
	(gdb-delete-breakpoint, gdb-toggle-breakpoint): Handle gdbmi.

2004-07-03  Juri Linkov  <juri@jurta.org>

	* replace.el (query-replace-read-args): Swallow space after 'foo,
	not after (quote foo).  Match space only immediately after symbol,
	not anywhere in the whole string.

2004-07-02  Richard M. Stallman  <rms@gnu.org>

	* replace.el (query-replace-read-args): Swallow space after
	symbols, not after closeparens.  But avoid error if string ends there.

	* progmodes/python.el (python-beginning-of-statement):
	Exit the loop if backward-up-list gets error.

	* textmodes/enriched.el (enriched-encode): Bind inhibit-read-only.

2004-07-02  Andre Spiegel  <spiegel@gnu.org>

	* vc-rcs.el (vc-rcs-checkout-model): Look at the version headers
	only if vc-consult-headers is non-nil.

2004-07-02  Juri Linkov  <juri@jurta.org>

	* pcvs.el (cvs-mode-diff-repository): New command.

	* pcvs-defs.el (cvs-mode-diff-map): Bind r to cvs-mode-diff-repository.

2004-07-01  Juri Linkov  <juri@jurta.org>

	* isearch.el (isearch-mode-map): Bind C-M-w to isearch-del-char,
	C-M-y to isearch-yank-char.  Bind M-% to isearch-query-replace,
	C-M-% to isearch-query-replace-regexp.
	(minibuffer-local-isearch-map): Add arrow key bindings.
	Bind C-f to isearch-yank-char-in-minibuffer.
	(isearch-forward): Doc fix.
	(isearch-edit-string): Doc fix.
	(isearch-query-replace, isearch-query-replace-regexp): New funs.
	(isearch-del-char): Add optional arg.  Set isearch-yank-flag to t.
	(isearch-yank-char): Add optional arg.
	(isearch-yank-char-in-minibuffer): New fun.

	* replace.el (query-replace-interactive): Change type from boolean
	to choice.  Add value `initial'.
	(query-replace-read-args): Handle value `initial' of
	query-replace-interactive.

2004-06-29  Kim F. Storm  <storm@cua.dk>

	* progmodes/gdb-ui.el (breakpoint-enabled-bitmap-face)
	(breakpoint-disabled-bitmap-face): Add :group 'gud.

	* progmodes/ada-xref.el (ada-tight-gvd-integration):
	Add :group 'ada.

	* vc-arch.el (vc-arch-mode-line-rewrite): Add :group 'vc.

2004-06-29  Juri Linkov  <juri@jurta.org>

	* replace.el (query-replace-read-args): Swallow a space after
	everything except )]" which in most cases means after a symbol.

	* emacs-lisp/pp.el (pp-buffer): Add autoload.

2004-06-28  Richard M. Stallman  <rms@gnu.org>

	* font-lock.el (font-lock-fontify-syntactic-keywords-region):
	More changes to go with previous change in font-lock.el.

2004-06-26  David Kastrup  <dak@gnu.org>

	* replace.el (perform-replace): Highlight the match even in
	non-query mode if there is potential replace string editing.

2004-06-26  Kai Grossjohann  <kai.grossjohann@gmx.net>

	* net/tramp.el (tramp-handle-file-remote-p): New implementation to
	agree with new return value of `file-remote-p'.
	This syncs with Tramp 2.0.42.

	* net/ange-ftp.el (ange-ftp-file-remote-p): New return value,
	according to new documentation of `file-remote-p'.

	* files.el (file-remote-p): Fix doc to say that return value is
	identification of remote system, if not nil.
	(file-relative-name): Use new return value of `file-remote-p'.

2004-06-26  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el (gdb-toggle-breakpoint)
	(gdb-goto-breakpoint): Fix breakage.

2004-06-26  Eli Zaretskii  <eliz@gnu.org>

	* man.el (Man-getpage-in-background): Add windows-nt to the list
	of systems where shell-file-name should be used instead of
	literal "sh".

2004-06-25  Sam Steingold  <sds@gnu.org>

	* add-log.el (change-log-font-lock-keywords): Support Common Lisp
	function names `(setf symbol)'.

2004-06-24  Richard M. Stallman  <rms@gnu.org>

	* replace.el (query-replace-read-args): Swallow space after \,SYMBOL.

	* font-lock.el (font-lock-keywords): Change format of compiled values.
	Document it.
	(font-lock-add-keywords): If font-lock-keywords is compiled,
	extract the uncompiled version, modify, then recompile.
	(font-lock-remove-keywords): Likewise.
	(font-lock-fontify-keywords-region): Handle changed format.
	(font-lock-compile-keywords): Handle changed format.
	(font-lock-set-defaults): Compile the keywords explicitly here.

2004-06-24  David Kastrup  <dak@gnu.org>

	* replace.el (query-replace-read-args): Implement `\,' and `\#'
	replacements here.
	(query-replace-regexp): Doc string explaining this and the new
	`\?' replacement.  Remove `\,' and `\#' implementation here, as it
	is better placed in `query-replace-read-args'.
	(replace-regexp): Explain `\,', `\#' and `\?'.
	(replace-match-data): New function for thorough reuse/destruction
	of old match-data.
	(replace-match-maybe-edit): Function for implementing `\?' editing.
	(perform-replace): Fix maintaining of the match stack including
	already matched regions, implement `\?', fix various problems
	with regions while editing and other stuff.
	(replace-highlight): Simplify.

2004-06-24  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/grep.el (grep-error-screen-columns): New variable.
	(grep-regexp-alist): Give it the full functionality of gnu style
	compilation messages with line and column ranges.  Ask me for the
	perl script I'm working on, that uses these.

2004-06-23  Nick Roberts  <nickrob@gnu.org>

	* comint.el: (comint-insert-clicked-input, comint-copy-old-input):
	Remove.
	(comint-insert-input, comint-mouse-insert-input): New functions
	based on comint-insert-clicked-input for two bindings but just
	one functionality.

2004-06-23  Luc Teirlinck  <teirllm@auburn.edu>

	* net/goto-addr.el (goto-address-fontify): Fix help-echo text.

2004-06-23  Lars Hansen  <larsh@math.ku.dk>

	* files.el (write-contents-functions): Doc fix.

2004-06-21  Juanma Barranquero  <lektu@terra.es>

	* image.el (image-library-alist): Rewrite docstring in active voice.

2004-06-20  Richard M. Stallman  <rms@gnu.org>

	* mouse.el (mouse-set-region-1): Set transient-mark-mode to `only'.

	* isearch.el (isearch-repeat): Avoid testing old match data.
	(isearch-message): Display trailing space in special font
	when search is failing.
	(isearch-search-fun-function): Doc fix.

	* autorevert.el (global-auto-revert-non-file-buffers): Doc fix.

2004-06-19  Luc Teirlinck  <teirllm@auburn.edu>

	* frame.el (show-trailing-whitespace): Doc fix.

	* cus-edit.el (custom-variable-documentation): New function.
	(custom-variable): Use it.

2004-06-19  Nick Roberts  <nickrob@gnu.org>

	* man.el (Man-getpage-in-background): Revert previous change but
	make cygwin a special case.

2004-06-18  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el (global-auto-revert-non-file-buffers):
	Update docstring.

2004-06-19  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-error-properties): Store one
	more than end-col, if present, so that transient-mark-mode will
	highlight last char too.
	* progmodes/grep.el (grep-regexp-alist): Match columns and column
	ranges, if present.

2004-06-18  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in: Double percent signs in for loops.

2004-06-17  David Kastrup  <dak@gnu.org>

	* replace.el (query-replace-read-args): Only warn about use of \n
	and \t when we are doing a regexp replacement and the actual
	escaped character is n or t.
	(query-replace-regexp): Add \, and \# interpretation to
	interactive call and document it.
	(query-replace-regexp-eval, replace-match-string-symbols): Add \#
	as shortkey for replace-count.
	(replace-quote): New function for doubling backslashes.

2004-06-17  Juanma Barranquero  <lektu@terra.es>

	* files.el (parse-colon-path, cd): Mention in docstring that the
	path separator is colon in GNU-like systems.

	* newcomment.el (comment-region-internal): Fix docstring.

	* emacs-lisp/ewoc.el (ewoc-create, ewoc-map, ewoc-locate)
	(ewoc-invalidate, ewoc-collect): Doc fixes.
	(ewoc--create-node, ewoc--delete-node-internal):
	Fix typos in docstring.

2004-06-15  Luc Teirlinck  <teirllm@auburn.edu>

	* files.el (buffer-stale-function): Add hyperlink to emacs-xtra
	manual to docstring.

2004-06-15  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* ps-print.el (ps-time-stamp-iso8601): Comment doc string of defalias.

2004-06-15  Luc Teirlinck  <teirllm@auburn.edu>

	* dired-aux.el (dired-do-redisplay, dired-maybe-insert-subdir):
	Add hyperlink to emacs-xtra manual to docstring.

	* autorevert.el (global-auto-revert-non-file-buffers):
	Add hyperlink to emacs-xtra manual to docstring, as well as an
	info-link.

2004-06-14  Juanma Barranquero  <lektu@terra.es>

	* image.el (image-library-alist): New variable to map image types
	to external libraries.  Initialized to nil, unless system-specific
	configs change it.
	(image-type-available-p): Determine whether an image type is
	available by calling `init-image-library'.

	* term/w32-win.el (image-library-alist): Initialize to a known set
	of probable library names.

2004-06-14  Kenichi Handa  <handa@m17n.org>

	* international/code-pages.el (windows-1256, cp1125): Fix tables
	for several characters.

	* international/utf-8.el (ccl-encode-mule-utf-8): Fix previous change.

2004-06-13  Richard M. Stallman  <rms@gnu.org>

	* textmodes/paragraphs.el (sentence-end): Add 0x5397d as close brace.

	* emulation/pc-select.el: Doc fixes: say "PC Selection mode",
	not "`pc-selection-mode'".

	* emacs-lisp/bytecomp.el: Put `...' around symbols in warning messages.

	* simple.el (previous-matching-history-element): Specify a default.

	* hexl.el (hexl-mode): Catch errors in hexl-goto-address.

	* cus-face.el (custom-declare-face): Simplify code.

	* abbrev.el (abbrev-mode, edit-abbrevs-map): Doc fixes.

2004-06-13  Luc Teirlinck  <teirllm@auburn.edu>

	* files.el (before-save-hook): Add `time-stamp' to the options.

	* time-stamp.el (time-stamp): Recommend adding it to
	`before-save-hook', rather than `write-file-functions'.
	Make a similar change in `Commentary' section.

2004-06-13  Kai Grossjohann  <kai.grossjohann@gmx.net>

	* diff-mode.el (diff-current-defun): If at start of hunk, use
	position of first change.

2004-06-13  Lars Hansen  <larsh@math.ku.dk>

	* dired-x.el (dired-mark-omitted): Bind to "*O".

2004-06-12  Karl Fogel  <kfogel@red-bean.com>

	* bookmark.el (bookmark-bmenu-relocate): New function, as
	suggested by David J. Biesack <David.Biesack@sas.com>.
	(bookmark-bmenu-mode-map): Bind `bookmark-bmenu-relocate' to "R".
	(bookmark-bmenu-mode): Describe binding in doc string.
	(bookmark-set-filename): Save the bookmark list if it's time.

2004-06-13  Kenichi Handa  <handa@m17n.org>

	* international/utf-8.el (ccl-decode-mule-utf-8): Fix previous change.
	(ccl-untranslated-to-ucs): Fix typo.

2004-06-12  Karl Chen  <quarl@hkn.eecs.berkeley.edu>  (tiny change)

	* progmodes/python.el (python-open-block-statement-p):
	Fix indentation after a block opening that contains a comment.

2004-06-12  J,Ai(Br,At(Bme Marant  <jerome@marant.org>  (tiny change)

	* bindings.el (completion-ignored-extensions): Add file extensions
	of Python byte-compiled files.

2004-06-12  Juri Linkov  <juri@jurta.org>

	* info.el (Info-goto-node): Add autoload.
	(Info-toc): Add substring-no-properties on Info file name.
	(Info-mode, info, Info-toc, Info-mode-menu): Doc fix.
	(Info-mode-map): Bind L to Info-history, T to Info-toc.

2004-06-12  Kenichi Handa  <handa@m17n.org>

	* international/mule-cmds.el (set-language-environment):
	Load subst tables if necessary.

	* international/mule.el (decode-char): Load subst tables if necessary.
	(encode-char): Likewise.

	* international/utf-16.el (utf-16-decode-ucs): Handle a surrogate
	pair correctly.  Call ccl-mule-utf-untrans for untranslable chars.
	(utf-16le-decode-loop): Set r5 to -1 before loop.
	(utf-16be-decode-loop): Likewise.
	(ccl-decode-mule-utf-16le): Add EOF processing block.
	(ccl-decode-mule-utf-16be): Likewise.
	(ccl-decode-mule-utf-16le-with-signature): Likewise.
	(ccl-decode-mule-utf-16be-with-signature): Likewise.
	(ccl-decode-mule-utf-16): Likewise.  Set r5 to -1 initially.
	(ccl-mule-utf-16-encode-untrans): New CCL.
	(utf-16-decode-to-ucs): Handle pre-read character.
	(utf-16le-encode-loop): Handle surrogate pair.
	(utf-16be-encode-loop): Likewise.
	(ccl-encode-mule-utf-16le-with-signature): Adjust for the change
	of utf-16le-encode-loop.
	(ccl-encode-mule-utf-16be-with-signature): Adjust for the change
	of utf-16be-encode-loop.
	(mule-utf-16-post-read-conversion):
	Call utf-8-post-read-conversion at first.
	(mule-utf-16[{le|be}], mule-utf-16{le|be}-with-signature):
	Include CJK charsets in safe-charsets if utf-translate-cjk-mode is on.
	Add post-read-conversion and pre-write-conversion.

	* international/utf-8.el (utf-translate-cjk-charsets): New variable.
	(utf-translate-cjk-unicode-range): New variable.
	(utf-translate-cjk-load-tables): New function.
	(utf-lookup-subst-table-for-decode): New function.
	(utf-lookup-subst-table-for-encode): New function.
	(utf-translate-cjk-mode): Init-value changed to t.  Don't load
	tables here.  Update safe-charsets of utf-* coding systems.
	(ccl-mule-utf-untrans): New CCL.
	(ccl-decode-mule-utf-8): Call ccl-mule-utf-untrans.  Use `repeat'
	at end of each branch.
	(ccl-mule-utf-8-encode-untrans): New CCL.
	(ccl-encode-mule-utf-8): Call ccl-mule-utf-8-encode-untrans.
	(ccl-untranslated-to-ucs): Handle 2-byte encoding.  Set r1 to the
	length of encoding.  Don't return r0.
	(utf-8-compose): New arg hash-table.  Handle 2-byte encoding.
	(utf-8-post-read-conversion): Narrow to region properly.
	If utf-translate-cjk-mode is on, load tables if necessary.
	Call utf-8-compose with hash-table arg if necessary.
	Call XXX-compose-region instead of XXX-post-read-convesion.
	(utf-8-pre-write-conversion): New function.
	(mule-utf-8): Include CJK charsets in safe-charsets if
	utf-translate-cjk-mode is on.  Add pre-write-conversion.

	* international/characters.el: Temporarily set
	utf-translate-cjk-mode to nil.

	* language/devan-util.el (devanagari-compose-region):
	Add autoload cookie.

	* international/ccl.el (ccl-dump-call): Fix printing the
	subroutine name.

2004-06-11  Luc Teirlinck  <teirllm@auburn.edu>

	* dired.el (dired-revert): If buffer is marked unmodified before
	reverting, keep it marked unmodified.
	Adapt to new conventions for commenting out code.
	(dired-make-relative): Adapt to new conventions for commenting out code.

2004-06-10  Miles Bader  <miles@gnu.ai.mit.edu>

	* eshell/esh-module.el (eshell-load-defgroups):
	Bind `vc-handled-backends' to nil when opening files.

2004-06-11  Juanma Barranquero  <lektu@terra.es>

	* files.el (parse-colon-path, cd): Doc fixes (refer to
	`path-separator', not colon).

2004-06-10  Juanma Barranquero  <lektu@terra.es>

	* newcomment.el (comment-search-forward)
	(comment-search-backward): Fix typos in docstring.
	(comment-region): Doc fix.

2004-06-10  Luc Teirlinck  <teirllm@auburn.edu>

	* dired.el (dired-insert-old-subdirs): Adapt to fact that the R
	switch is no longer stored in `dired-switches-alist'.

	* dired-aux.el (dired-insert-subdir): Do not store R switch in
	`dired-switches-alist'.

2004-06-10  Kim F. Storm  <storm@cua.dk>

	* pcvs.el (cvs-mode-diff-yesterday): New command.

	* pcvs-defs.el (cvs-mode-diff-map): Bind y to cvs-mode-diff-yesterday.

2004-06-10  Juri Linkov  <juri@jurta.org>

	* emacs-lisp/edebug.el (edebug-eval-defun):
	* emacs-lisp/lisp-mode.el (eval-defun-1): Add `defface'.
	Fix docstring.

	* simple.el (eval-expression-print-format): Don't print additional
	information on the first call to `eval-print-last-sexp'.
	(next-error-find-buffer): Fix punctuation.
	(killing) <defgroup>: Fix punctuation.
	(yank-excluded-properties): Change group from editing to killing.

	* replace.el (perform-replace): Use `limit' to terminate the
	while-loop explicitly.

2004-06-09  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* toolbar/tool-bar.el (tool-bar-add-item, tool-bar-local-item):
	Use lc-*.xpm as prefix instead of *-locol.xpm.

	* toolbar/lc-copy.xpm, toolbar/lc-cut.xpm
	* toolbar/lc-help.xpm, toolbar/lc-home.xpm
	* toolbar/lc-index.xpm, toolbar/lc-jump_to.xpm
	* toolbar/lc-left_arrow.xpm, toolbar/lc-new.xpm
	* toolbar/lc-open.xpm, toolbar/lc-paste.xpm
	* toolbar/lc-preferences.xpm, toolbar/lc-print.xpm
	* toolbar/lc-right_arrow.xpm, toolbar/lc-save.xpm
	* toolbar/lc-saveas.xpm, toolbar/lc-search.xpm
	* toolbar/lc-spell.xpm, toolbar/lc-undo.xpm
	* toolbar/lc-up_arrow.xpm:
	Renamed from *-locol.xpm.

2004-06-09  Rajesh Vaidheeswarran  <rv@gnu.org>

	* ffap.el (ffap-string-at-point-mode-alist): Fix the url mode to
	include forms like &<str>; as valid url patterns.

2004-06-08  Luc Teirlinck  <teirllm@auburn.edu>

	* dired.el (dired-diff, dired-backup-diff)
	(dired-clean-directory, dired-do-chmod, dired-do-chgrp)
	(dired-do-chown, dired-do-touch, dired-do-print)
	(dired-do-shell-command, dired-do-kill-lines, dired-do-compress)
	(dired-do-byte-compile, dired-do-load, dired-do-redisplay)
	(dired-create-directory, dired-do-copy, dired-do-symlink)
	(dired-do-hardlink, dired-do-rename, dired-do-rename-regexp)
	(dired-do-copy-regexp, dired-do-hardlink-regexp)
	(dired-do-symlink-regexp, dired-upcase, dired-downcase)
	(dired-maybe-insert-subdir, dired-next-subdir)
	(dired-prev-subdir, dired-goto-subdir, dired-mark-subdir-files)
	(dired-kill-subdir, dired-tree-up, dired-tree-down)
	(dired-hide-subdir, dired-hide-all, dired-show-file-type)
	(dired-run-shell-command, dired-query): Remove redundant,
	or incorrect, autoloads.

	* dired-aux.el (dired-kill-tree): Do not kill DIRNAME, even if it
	does not end in a slash.  Add optional argument KILL-ROOT.
	Update docstring.
	(dired-do-touch, dired-clean-directory, dired-run-shell-command)
	(dired-query): Add autoloads.

2004-06-08  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-set-window-height):
	Rearrange the save-* functions because a buffer can have several current
	point in different windows.
	(compilation-error-regexp-alist-alist): Recognize {standard input}
	GNU messages (for gcc --pipe) and more kinds of Oracle messages.

2004-06-08  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* toolbar/copy-locol.xpm, toolbar/cut-locol.xpm
	* toolbar/help-locol.xpm, toolbar/home-locol.xpm
	* toolbar/index-locol.xpm, toolbar/jump_to-locol.xpm
	* toolbar/left_arrow-locol.xpm, toolbar/new-locol.xpm
	* toolbar/open-locol.xpm, toolbar/paste-locol.xpm
	* toolbar/preferences-locol.xpm, toolbar/print-locol.xpm
	* toolbar/right_arrow-locol.xpm, toolbar/save-locol.xpm
	* toolbar/saveas-locol.xpm, toolbar/search-locol.xpm
	* toolbar/spell-locol.xpm, toolbar/undo-locol.xpm
	* toolbar/up_arrow-locol.xpm:
	New versions of icons that uses fewer colors.

	* toolbar/tool-bar.el (tool-bar-local-item)
	(tool-bar-local-item-from-menu): Try to use icons with fewer colors
	if display-color-cells is 256 or less.

2004-06-08  Kim F. Storm  <storm@cua.dk>

	* wid-edit.el (widget-specify-button): Use hand pointer rather
	than mouse-face as visible mouse-over effect.

2004-06-07  Karl Fogel  <kfogel@red-bean.com>

	* saveplace.el (save-place-alist-to-file): Bind `print-length'
	and `print-level' to nil when writing out `save-place-alist'.
	Thanks to Kai Grossjohann <kai@emptydomain.de> for enlightenment.

2004-06-07  Juanma Barranquero  <lektu@terra.es>

	* completion.el (completion-kill-region): Doc fix.

	* format.el (format-insert-annotations)
	(format-annotate-location): Doc fixes.
	(format-subtract-regions): Make arguments match their use in docstring.

	* simple.el (kill-region): Doc fix.

	* subr.el (insert-buffer-substring-no-properties)
	(insert-buffer-substring-as-yank): Doc fixes.

2004-06-07  Luc Teirlinck  <teirllm@auburn.edu>

	* dired-aux.el (dired-do-redisplay, dired-maybe-insert-subdir):
	Update docstring.
	(dired-reset-subdir-switches): New function.

	* dired.el (dired-undo): Call `dired-build-subdir-alist'.
	Limit scope of `buffer-read-only' binding.

2004-06-06  Emilio C. Lopes  <eclig@gmx.net>

	* eshell/esh-cmd.el (eshell/which): Respect commands quoted with
	eshell-explicit-command-char.

2004-06-06  Juanma Barranquero  <lektu@terra.es>

	* help-fns.el (help-argument-name): Inherit from italic face only
	if the frame supports it.

2004-06-06  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* toolbar/alias.pbm, toolbar/close.pbm, toolbar/copy.pbm
	* toolbar/cut.pbm, toolbar/help.pbm, toolbar/home.pbm
	* toolbar/index.pbm, toolbar/jump_to.pbm, toolbar/left_arrow.pbm
	* toolbar/new.pbm, toolbar/open.pbm, toolbar/paste.pbm
	* toolbar/preferences.pbm, toolbar/print.pbm, toolbar/right_arrow.pbm
	* toolbar/save.pbm, toolbar/saveas.pbm, toolbar/search.pbm
	* toolbar/spell.pbm, toolbar/undo.pbm, toolbar/up_arrow.pbm:
	New conversions from xpm files.

	* toolbar/README: New file.

2004-06-06  Richard M. Stallman  <rms@gnu.org>

	* isearch.el (isearch-mode-map): Undo previous change.

2004-06-05  Juri Linkov  <juri@jurta.org>

	* bindings.el (debug-ignored-errors): Add regexps for history
	related messages.  Remove $ from "No further undo information".
	Move Ediff's messages to ediff.el.

	* ediff.el: Move Ediff's debug-ignored-errors from bindings.el.

	* cus-edit.el (custom-display): Add `min-colors'.

	* custom.el (defface): Add `supports' to docstring.

	* help-fns.el (help-argument-name): Add :group 'help.

2004-06-05  Luc Teirlinck  <teirllm@auburn.edu>

	* find-dired.el (find-ls-subdir-switches): New user option.
	(find-dired): No longer call `abbreviate-file-name' on DIR.
	Set `dired-subdir-switches' buffer-locally.

	* locate.el: Merge the two `Commentary' sections.
	(locate-ls-subdir-switches): New user option.
	(locate): Update for other changes.
	(locate-mode-map): Restore Dired binding for mouse-2.
	Bind `locate-mouse-view-file' to M-mouse-2.
	Bind `l' to `locate-do-redisplay'.
	(locate-main-listing-line-p, locate-do-redisplay): New functions.
	(locate-mouse-view-file, locate-tags, locate-find-directory):
	Print message if used outside main listing.
	(locate-mode): Update docstring.  Make `*Locate*' buffer read-only.
	Various changes to support inserted subdirectories.
	(locate-insert-header): Change header of *Locate* buffer.

	* dired-aux.el (dired-do-redisplay, dired-maybe-insert-subdir):
	Change interactive default switches.
	(dired-rename-subdir-2): Update `dired-switches-alist'.
	(dired-insert-subdir, dired-kill-subdir):
	Handle `dired-switches-alist'.  Do not mark buffer modified.
	(dired-insert-subdir-validate): Handle `dired-subdir-switches'.
	(dired-insert-subdir-doinsert): Omit messages.
	Handle `dired-subdir-switches'.
	(dired-hide-subdir, dired-hide-all): Do not mark buffer modified.

	* dired.el (dired-subdir-switches, dired-switches-alist): New vars.
	(dired-insert-old-subdirs): Do not repeatedly delete and reinsert
	subdirs if -R switch is used for a subdir.
	(dired-mode): Set `dired-switches-alist'.
	(dired-build-subdir-alist): Only print number of directories in
	echo area when invoked interactively.

2004-06-05  Lars Hansen  <larsh@math.ku.dk>

	* dired-x.el (dired-omit-mode): Rename from
	dired-omit-files-p.  Use define-minor-mode to define it.
	(dired-omit-files-p): Add as alias for dired-omit-mode.
	(dired-omit-toggle): Delete.  Replaced by dired-omit-mode and
	dired-mark-omitted.
	(dired-mark-omitted): Add.  Bind to M-O.

2004-06-05  Kenichi Handa  <handa@m17n.org>

	* ps-print.el: Fix typos (kein'ichi -> ken'ichi)

2004-06-05  Juanma Barranquero  <lektu@terra.es>

	* help-fns.el (help-argument-name): Reintroduce face.
	(help-default-arg-highlight): Use it, now that
	`face-differs-from-default-p' can be trusted.

2004-06-05  Matt Hodges  <matt@stchem.bham.ac.uk>  (tiny change)

	* textmodes/table.el: Sentence commands added to Point Motion
	group; kill and backward-kill commands added to Extraction group.

2004-06-04  Mario Lang  <mlang@delysid.org>

	* battery.el (battery-linux-proc-acpi): `mA' was hardcored, but some
	systems appear to use mW, make the code handle this.  Fix a
	division-by-zero bug while at it, and handle kernels with
	a slightly different layout in /proc/acpi.

2004-06-04  Karl Fogel  <kfogel@red-bean.com>

	* vc-svn.el (vc-svn-checkin): Use 'nconc' instead of 'list*',
	because the latter is a CL-ism.  This fixes the bug reported by
	Shawn Boyette <mdxi@collapsar.net> in
	http://lists.gnu.org/archive/html/emacs-devel/2004-05/msg00442.html.

2004-06-04  Miles Bader  <miles@gnu.org>

	* faces.el (display-supports-face-attributes-p): Function moved to
	C code.  Previously only the tty-related portion of this function
	was done in C; however the previous attempt to do a halfway-proper
	job for non-tty displays in lisp didn't work properly because of
	funny conditions during Emacs startup.
	(face-differs-from-default-p): Simplify, now that
	display-supports-face-attributes-p works properly on all display
	types.  Remove :stipple from comparison; it doesn't really work
	in emacs anyway.

2004-06-04  Miles Bader  <miles@gnu.org>

	* faces.el (face-differs-from-default-p): Use a different
	implementation, so we can really check whether FACE displays
	differently or not.

2004-06-04  Miles Bader  <miles@gnu.org>

	* faces.el (display-supports-face-attributes-p): Implement a
	`different from default' check for non-tty displays.

2004-06-03  David Kastrup  <dak@gnu.org>

	* woman.el (woman-mapcan): More concise code.
	(woman-topic-all-completions, woman-topic-all-completions-1)
	(woman-topic-all-completions-merge): Replace by a simpler and
	much faster implementation based on O(n log n) sort/merge instead
	of the old O(n^2) behavior.

2004-06-03  Miles Bader  <miles@gnu.org>

	* subr.el (read-number): Use canonical format for default in prompt.

	* minibuf-eldef.el (minibuffer-default-in-prompt-regexps):
	Add regexp for " [...]" style defaults.

2004-06-02  Romain Francoise  <romain@orebokech.com>

	* ibuf-ext.el (ibuffer-jump-to-buffer): Add support for filter
	groups: if the user asks for a hidden buffer, open the
	corresponding filter group to expose it.

	* ibuffer.el (ibuffer-mode-map): Add key binding `M-g' to
	`ibuffer-jump-to-buffer'.
	(ibuffer-jump-offer-only-visible-buffers): New user option.

2004-06-02  Juanma Barranquero  <lektu@terra.es>

	* faces.el (frame-update-faces): Add empty docstring so the one
	for `ignore' doesn't show through.

	* subr.el (process-kill-without-query): Remove spurious "\n" on
	obsolescence string.
	(focus-frame, unfocus-frame): Add obsolescence declaration and
	empty docstring.

	* international/mule.el (register-char-codings): Make alias for
	`ignore'.  Move docstring to obsolescence info and remove redundancy.

2004-06-02  Kim F. Storm  <storm@cua.dk>

	* frame.el (blink-cursor-start): Turn cursor off initially so blink
	starts after blink-cursor-delay rather than 2*blink-cursor-delay.

2004-06-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* comint.el (comint-replace-by-expanded-history-before-point):
	Obey `start' as the docstring says.
	(comint-send-input, comint-snapshot-last-prompt, comint-output-filter)
	(comint-update-fence): Prevent font-lock from running unnecessarily.
	(comint-dynamic-list-completions): Use with-current-buffer.

2004-06-01  Roland Winkler  <Roland.Winkler@physik.uni-erlangen.de>

	* textmodes/bibtex.el (bibtex-format-entry): Fix regexps.
	(bibtex-parse-strings): Bugfix, use assoc instead of assoc-string.
	(bibtex-entry-update): Handle alternatives and optional fields.
	(bibtex-parse-entry): Bugfix, handle empty key.

2004-05-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-arch.el (vc-arch-state): Don't assume the file exists.

2004-05-31  Lars Hansen  <larsh@math.ku.dk>

	* desktop.el (desktop-save): Don't save minor modes without a
	known mode initialization function.

2004-05-30  Luc Teirlinck  <teirllm@auburn.edu>

	* replace.el (query-replace-interactive): Convert defvar -> defcustom.

	* autorevert.el: Update `Commentary' section.

2004-05-30  Juanma Barranquero  <lektu@terra.es>

	* dos-fns.el (convert-standard-filename):
	* files.el (convert-standard-filename):
	* w32-fns.el (convert-standard-filename):
	Rework docstring (wording by Eli Zaretskii and Kai Grossjohann).

2004-05-30  Kai Grossjohann  <kai.grossjohann@gmx.net>

	Sync with Tramp.

	* net/tramp.el (tramp-let-maybe): Reverse args of `get'.
	(tramp-let-maybe): Move to an earlier spot in the file.
	Patch by Andreas Schwab.

2004-05-30  Andreas Schwab  <schwab@suse.de>

	* dired.el (dired-get-filename): Don't use dired-re-dot.

2004-05-30  Richard M. Stallman  <rms@gnu.org>

	* files.el (find-file): Doc fix.

	* font-lock.el (lisp-font-lock-keywords-2): Add multiple-value-bind.

2004-05-30  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el (gdb-current-frame, gud-watch)
	(gdb-locals-mode, gdb-frame-handler): Display current frame in the
	modeline of the locals buffer.
	(gdb-goto-breakpoint): Handle gdbmi.
	(gdb-get-frame-number): Change for gdbmi.

2004-05-30  Michael Albinus  <michael.albinus@gmx.de>

	* files.el (file-remote-p): Apply file name handler for operation
	`file-remote-p'.  It isn' a property any longer.
	(file-relative-name): `fh' and `fd' get the required value via
	`find-file-name-handler' already.

	* ange-ftp.el (ange-ftp-file-remote-p): New defun.
	(top): Remove setting of `file-remote-p' property for
	`ange-ftp-hook-function'.  Add `ange-ftp' property to `file-remote-p'.

2004-05-29  Michael Albinus  <michael.albinus@gmx.de>

	Version 2.0.41 of Tramp released.

	* tramp.el (tramp-wait-for-regexp, tramp-wait-for-output):
	Throw away if process has died.
	Reported by Luc Teirlinck <teirllm@dms.auburn.edu>.
	(tramp-out-of-band-prompt-regexp): Rename to
	`tramp-process-alive-regexp', because its usage is widen.
	(tramp-actions-copy-out-of-band): Apply it.
	(tramp-actions-before-shell, tramp-multi-actions):
	Add `tramp-action-process-alive' action.
	(tramp-action-process-alive): New defun.
	(tramp-file-name-handler-alist, tramp-file-name-for-operation):
	Add entry for `file-remote-p'.
	(tramp-handle-file-remote-p): New defun.
	(top): Remove setting of `file-remote-p'.  Don't set
	`inhibit-file-name-handlers' and `inhibit-file-name-operation'.

	* tramp-smb.el (tramp-smb-file-name-handler-alist): Add entry for
	`file-remote-p'.

	* tramp-uu.el (tramp-uuencode-region): Padding characters aren't
	counted for (last) line.  [They should or they shouldn't?  --Stef]
	Reported by Aaron Ucko <ucko@ncbi.nlm.nih.gov>.

2004-05-29  Kai Grossjohann  <kai.grossjohann@gmx.net>

	* tramp.el (tramp-initial-commands): Add "unset HISTFILE"; this is
	not really necessary but seems to keep the shell history smaller
	in some cases.  It is no substitute for setting HISTFILE and
	HISTSIZE from tramp-open-connection-setup-interactive-shell,
	though.  Suggested by Luc Teirlinck.
	(tramp-open-connection-setup-interactive-shell): Export variables
	HISTFILE and HISTSIZE, do not just set them.  From Luc Teirlinck.
	(tramp-set-process-query-on-exit-flag): New compat function.
	(tramp-open-connection-multi, tramp-open-connection-su)
	(tramp-open-connection-rsh, tramp-open-connection-telnet)
	(tramp-do-copy-or-rename-file-out-of-band): Use it.
	(tramp-let-maybe): New macro, let-binds a variable only if it
	isn't obsolete.
	(tramp-check-ls-commands, tramp-handle-expand-file-name)
	(tramp-handle-file-truename): Use it.
	(tramp-completion-file-name-regexp-unified): Avoid matching
	filenames starting with "/:" -- those are reserved for
	file-name-non-special.

	* tramp-smb.el (tramp-smb-open-connection):
	Use tramp-set-process-query-on-exit-flag compat function.

2004-05-29  Richard M. Stallman  <rms@gnu.org>

	* net/browse-url.el (browse-url-interactive-arg): Doc fix.

	* emacs-lisp/lisp-mode.el (prin1-char): Catch errors from `string'.
	(eval-last-sexp-print-value): Print char equivalent regardless
	of standard-output value.

	* thumbs.el (thumbs-subst-char-in-string): Delete.
	(thumbs-thumbname): Use subst-char-in-string.
	(thumbs-resize-image): Use condition-case, not ignore-errors.
	(thumbs-kill-buffer): Likewise.

	* thumbs.el: Don't include cl.  Don't bother with old Emacs versions.
	(thumbs-mode): Make buffer read-only.
	(thumbs-make-thumb): Unconditionally accept an existing file.
	(thumbs-insert-thumb): Add thumb-image-file property to the image.
	(thumbs-do-thumbs-insertion): Be smarter about where to put newlines.
	(thumbs-show-thumbs-list): Error if images not supported.
	(thumbs-save-current-image): Improve prompt string.
	(thumbs-mode-map): Define u, R, x.
	(thumbs-unmark): New command.
	(thumbs-emboss-image): Minor cleanup.
	(thumbs-forward-char, thumbs-backward-char): Skip chars with no image.
	(thumbs-rename-images): New command.
	(thumbs-show-image-num): Rewrite.  Don't rename the buffer.

	* thumbs.el (thumbs-current-image): New function.
	(thumbs-file-list, thumbs-file-alist): New functions.
	(thumbs-find-image): Delete arg L.
	Don't set up thumbs-fileL as buffer-local global var.
	(thumbs-find-image-at-point): Use thumbs-current-image.
	(thumbs-set-image-at-point-to-root-window): Likewise.
	(thumbs-delete-images): Use thumbs-current-image, thumbs-file-alist.
	Record and warn about errors.  Update thumbs-markedL for deletions.
	(thumbs-next-image, thumbs-previous-image): Use thumbs-file-alist.
	(thumbs-redraw-buffer): Use thumbs-file-list.
	(thumbs-mark): Use thumbs-current-image.
	(thumbs-show-name): Use thumbs-current-image.

	* imenu.el (imenu--menubar-select): Set imenu-menubar-modified-tick
	and imenu--last-menubar-index-alist.

	* subr.el (with-selected-window): Undo previous change.

2004-05-29  John Paul Wallington  <jpw@gnu.org>

	* thumbs.el (thumbs-show-name): Do nothing if no image at point.
	(thumbs-mouse-find-image): New command.
	(thumbs-mode-map): Bind it to mouse-2.
	(thumbs-mode): Make mode-class special.
	(thumbs-view-image-mode): Likewise.

2004-05-29  Pavel Kobiakov  <pk_at_work@yahoo.com>

	* flymake.el: New file.

2004-05-28  Luc Teirlinck  <teirllm@auburn.edu>

	* files.el (find-file-noselect-1): Do not bind
	`inhibit-read-only' to t during execution of
	`find-file-not-found-functions'.

2004-05-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-mcvs.el (vc-mcvs-print-log, vc-mcvs-diff):
	* vc-arch.el (vc-arch-diff): Add optional `buffer' arg.

2004-05-28  Juri Linkov  <juri@jurta.org>

	* simple.el (eval-expression-print-format): New fun.

	* simple.el (eval-expression):
	* emacs-lisp/lisp-mode.el (eval-last-sexp-print-value):
	* emacs-lisp/edebug.el (edebug-compute-previous-result)
	(edebug-eval-expression): Print additionally the value returned by
	`eval-expression-print-format'.

	* emacs-lisp/lisp.el (insert-pair-alist): New var.
	(insert-pair): Make arguments optional.  Find character pair
	from `insert-pair-alist' according to the last input event.
	(insert-parentheses): Make arguments optional.
	(raise-sexp, delete-pair): New funs.

	* emacs-lisp/lisp-mode.el (indent-pp-sexp): New fun.
	(emacs-lisp-mode-map, lisp-interaction-mode-map):
	Bind C-M-q to `indent-pp-sexp'.

	* emacs-lisp/pp.el (pp-buffer): New fun created from the code in
	`pp-to-string' modified to be able to format text with newlines.
	(pp-to-string): Move the buffer-formatting part of the code to
	`pp-buffer'.  Call `pp-buffer'.

	* info.el (Info-desktop-buffer-misc-data): Don't save information
	about virtual files.
	(Info-restore-desktop-buffer): Restore Info buffers in prepared
	buffers with names obtained from the desktop file instead of the
	default *info* buffer.

2004-05-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (with-selected-window): Only save/restore the selected window.

	* progmodes/compile.el (compilation-error-regexp-alist):
	Use expand-file-name and data-directory.

	* progmodes/grep.el (grep-tree): Rework previous fix.

	* mouse.el (mouse-set-region-1): Use temporary transient-mark-mode
	after the user marked text with the mouse.

	* startup.el (command-line): Keep the first regexp of
	auto-save-file-name-transforms intact.

2004-05-28  Juanma Barranquero  <lektu@terra.es>

	* cus-edit.el (customize-face, customize-face-other-window)
	(custom-face-edit-delete): Make arguments match their use in
	docstring.
	(custom-unloaded-symbol-p, custom-unloaded-widget-p): Fix typo in
	docstring.

	* cvs-status.el (cvs-tree-merge, cvs-tags->tree): Use `butlast',
	not `cvs-butlast'.

	* pcvs-util.el (cvs-butlast, cvs-nbutlast): Remove (`butlast' and
	`nbutlast' are in subr.el).

	* w32-fns.el (w32-using-nt, w32-shell-dos-semantics)
	(set-w32-system-coding-system): Doc fixes.

	* textmodes/artist.el (artist-last, artist-remove-nulls): Simplify.
	(artist-draw-ellipse-general, artist-draw-ellipse-with-0-height):
	Make arguments match their use in docstring.
	(artist-draw-region-trim-line-endings)
	(artist-mouse-choose-operation): Fix typo in docstring.
	(artist-key-set-point-common): Doc fix.

2004-05-28  Simon Josefsson  <jas@extundo.com>

	* mail/smtpmail.el (smtpmail-open-stream):
	Bind starttls-extra-arguments too, if starttls.el uses GNUTLS.

2004-05-26  Simon Josefsson  <jas@extundo.com>

	* starttls.el: Merge with my GNUTLS based starttls.el.
	(starttls-gnutls-program, starttls-use-gnutls)
	(starttls-extra-arguments, starttls-process-connection-type)
	(starttls-connect, starttls-failure, starttls-success): New variables.
	(starttls-program, starttls-extra-args): Doc fix.
	(starttls-negotiate-gnutls, starttls-open-stream-gnutls): New funs.
	(starttls-negotiate, starttls-open-stream): Check `starttls-use-gnutls'
	and pass on to corresponding *-gnutls function if it is set.

2004-05-27  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el (auto-revert-handler): Disable auto-reverting of
	remote files.

2004-05-27  Michael Albinus  <michael.albinus@gmx.de>

	* files.el (file-name-non-special): There are more operations
	which need handling: `find-backup-file-name',
	`insert-file-contents', `verify-visited-file-modtime',
	`write-region'.  Rename t value of method to `add'.  Add new
	methods `quote' and `unquote-then-quote' to file-arg-indices.

2004-05-25  Juri Linkov  <juri@jurta.org>

	* info.el (Info-toc): Call Info-mode on intermediate buffer.
	(Info-index-nodes): Enclose code in condition-case to catch errors.
	(Info-index-node): Don't search all index nodes if request is only
	for the current node and file is not in the cache of index nodes.
	(Info-mode-map): Bind Info-copy-current-node-name to `w'
	for consistency with dired-copy-filename-as-kill.
	Bind `S' to Info-search-case-sensitively.
	(Info-copy-current-node-name): New arg.  With zero prefix arg put
	the name inside a function call to `info'.  Display copied text in
	the echo area.

2004-05-25  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/lisp-mode.el (lisp-find-tag-default): New function:
	strip the package prefix from the symbol name, if any.
	Make it the `find-tag-default-function' for `lisp-mode'.

2004-05-25  John Paul Wallington  <jpw@gnu.org>

	* gs.el (gs-load-image): Use `set-process-query-on-exit-flag'
	instead of obsolete `process-kill-without-query'.

	* textmodes/texinfmt.el (texinfo-indexvar-alist):
	Declare as variable, not constant.

2004-05-25  Luc Teirlinck  <teirllm@auburn.edu>

	* files.el (find-file-noselect-1): Fix bug introduced by
	Revision 1.694.  As a side effect, `inhibit-read-only'
	is again, by default, t during execution of
	`find-file-not-found-functions'.
	(insert-directory): Check that lines were really inserted by
	the --dired switch, before erasing them.

2004-05-24  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el (gdb-breakpoints-mode, gdb-frames-mode)
	(gdb-locals-mode): Check gud-minor-mode in gud-comint-buffer.
	(gdb-var-update, gdb-var-update-handler, gdb-var-delete)
	(gdb-edit-value, gdb-speedbar-expand-node): Handle new value for
	gud-minor-mode (gdbmi).

2004-05-24  Yoichi NAKAYAMA  <yoichi@geiin.org>  (tiny change)

	* net/browse-url.el (browse-url-interactive-arg): Enable user to
	explicitly select the text to be taken as URL.

2004-05-23  Juri Linkov  <juri@jurta.org>

	* info.el (Info-index-nodes): New var and fun.
	(Info-goto-index, Info-index, info-apropos)
	(Info-find-emacs-command-nodes): Rewrite to use Info-index-nodes.
	(Info-index): Fix docstring.  Store and restore Info-history-list.
	(Info-complete-nodes): New var.
	(Info-complete-menu-item): Use it.
	(Info-index-node): New fun.
	(Info-final-node, Info-forward-node, Info-backward-node)
	(Info-build-toc, Info-try-follow-nearest-node, Info-fontify-node):
	Use Info-index-node.
	(Info-extract-menu-item, Info-extract-menu-counting): Set second
	arg of `Info-extract-menu-node-name' to non-nil for index nodes.
	(Info-find-node-2): If a node with period in its name not found,
	try to find a node without the name part after period.
	(Info-select-node): Call Info-fontify-node only if
	Info-fontify-maximum-menu-size is not nil.
	(info-apropos): Set Info-fontify-maximum-menu-size to nil.
	(Info-find-emacs-command-nodes, Info-goto-emacs-command-node):
	Preserve Info-history-list.
	(Info-toc): Set Info-current-file.
	(Info-build-toc): Move point to the beginning of the buffer.
	Add main-file variable.
	(Info-dir-remove-duplicates, Info-history, Info-toc, info-apropos):
	Use backslashed representation of the control character ^_.

	* textmodes/texinfmt.el (texinfo-print-index): Print index line
	numbers in the new Texinfo 4.7 format.

	* add-log.el (change-log-font-lock-keywords): Remove `:' from
	regexps for function and variable names.

	* descr-text.el (describe-property-list): Add [show] button for
	`syntax-table' property with action to pp to a separate buffer.
	(describe-char): Replace search-forward by re-search-forward with
	whitespace regexp after "character:" to not fail in too narrow windows.

	* simple.el (next-error-find-buffer): Add a rule to return
	next-error capable buffer if one window on the selected frame
	displays such buffer.

2004-05-23  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el (gdb-server-prefix): New variable.
	(gud-watch, gdb-send-item, gdb-breakpoints-mode, gdb-frames-mode)
	(gdb-locals-mode, gdb-send-item, gdb-toggle-breakpoint)
	(gdb-delete-breakpoint, gdb-frames-select, gdb-threads-buffer)
	(gdb-registers-buffer, gdb-reset, gdb-assembler-buffer):
	Handle new value for gud-minor-mode (gdbmi).
	(gdb-buffer-type, gdb-input-queue, gdb-prompting)
	(gdb-output-sink, gdb-current-item, gdb-pending-triggers):
	Change from local to global gdb variable set.
	(gdb-ann3): Initialise above gdb variable set.
	(gdb-var-update, gdb-var-update-handler, gdb-enqueue-input)
	(gdb-dequeue-input, gdb-source, gdb-pre-prompt, gdb-prompt)
	(gdb-subprompt, gdb-starting, gdb-stopping, gdb-frame-begin)
	(gdb-stopped, gdb-post-prompt, gdb-concat-output)
	(def-gdb-auto-update-trigger, def-gdb-auto-update-handler)
	(gdb-info-locals-handler, gdb-invalidate-assembler)
	(gdb-get-current-frame, gdb-frame-handler): Handle gdb variable
	set as global variables.
	(gdb-get-create-buffer): Don't make gud-comint buffer-local.
	Handle gdbmi.
	(gdb-info-breakpoints-custom): Fix regexp.
	(def-gdb-var): Delete.

	* progmodes/gud.el (gud-menu-map, gud-speedbar-menu-items)
	(gud-speedbar-buttons, gud-sentinel, gud-display-line)
	(gud-basic-call): Handle new value for gud-minor-mode (gdbmi) for
	a new mode.  The file (gdb-mi.el) for this mode will be included
	with the GDB distribution (6.2 onwards) and will use GDB/MI as its
	primary interface.

2004-05-23  Jesper Harder  <harder@ifa.au.dk>

	* progmodes/grep.el (grep-tree): Ensure that DIR argument is
	interpreted as a directory.

2004-05-22  Richard M. Stallman  <rms@gnu.org>

	* textmodes/paragraphs.el (sentence-end): Match unicode curly quotes
	as a close quote.

	* textmodes/bibtex.el: Use assoc-string, not assoc-ignore-case.

	* progmodes/idlw-shell.el (idlwave-shell-get-object-class):
	Use assoc-string, not assoc-ignore-case.

	* progmodes/ada-mode.el: Use assoc-string, not assoc-ignore-case.

	* emacs-lisp/lisp.el (mark-defun, narrow-to-defun):
	If moving back then fwd gets a defun that ends before point,
	try again moving fwd then back.

	* files.el (file-name-non-special): Allow t in file-arg-indices
	to mean requote the return value.  Use `identity' as an element
	rather than as the whole value.

	* gs.el (gs-options): Add -dSAFER.  Mark it risky.

2004-05-22  Juanma Barranquero  <lektu@terra.es>

	* help-fns.el (help-add-fundoc-usage): Use %S only for output of
	`help-make-usage'.
	(help-highlight-arguments): Skip function name before searching
	for arguments.

2004-05-21  Juanma Barranquero  <lektu@terra.es>

	* allout.el (allout-chart-subtree, allout-rebullet-topic-grunt):
	Don't mention in the docstring these arguments meant for
	internal (recursive) use only.
	(allout-char-spec): Comment out (it's not implemented).
	(allout-old-expose-topic, allout-exposure): Fix docstring and add
	obsolescence declaration.
	(allout-flatten-exposed-to-buffer)
	(allout-indented-exposed-to-buffer): Fix typos in docstring.
	(my-mark-marker): Doc fix.
	(produce-allout-mode-map, allout-sibling-index)
	(allout-isearch-expose, allout-distinctive-bullet)
	(allout-open-topic, allout-reindent-body)
	(allout-rebullet-heading, allout-process-exposed)
	(allout-insert-listified, allout-latex-verb-quote)
	(allout-insert-latex-header, allout-insert-latex-trailer):
	Make arguments match their use in docstring.
	(allout-primary-bullet, allout-old-style-prefixes)
	(allout-inhibit-protection, allout-init, allout-mode)
	(allout-before-change-protect, allout-flag-region):
	Use "Emacs" instead of "emacs" in docstrings.

2004-05-21  Masayuki Ataka  <ataka@milk.freemail.ne.jp>  (tiny change)

	* international/characters.el: Modify syntax of more characters.

2004-05-21  Masatake YAMATO  <jet@gyve.org>

	* progmodes/etags.el (tags-apropos, list-tags): Require apropos.
	(etags-tags-completion-table): Show parsing progress.

2004-05-20  Luc Teirlinck  <teirllm@auburn.edu>

	* locate.el (locate-prompt-for-command): Shorten first line of
	docstring.
	(locate-mode): Expand docstring and include keymap summary.

	* files.el (find-file-noselect-1): Limit the scope of the
	`inhibit-read-only' binding.  Make sure that `inhibit-read-only'
	is, by default, nil during the execution of
	`find-file-not-found-functions' and `find-file-hook'.

2004-05-20  Michael Mauger  <mmaug@yahoo.com>

	* facemenu.el (facemenu-color-name-equal): New function.
	(list-colors-display): Use it to compare colors instead of
	facemenu-color-equal.

2004-05-20  Dan Nicolaescu  <dann@ics.uci.edu>

	* compare-w.el (compare-windows-face): Use min-colors instead of
	checking for tty or pc types.

2004-05-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* simple.el (do-auto-fill): Remove unused vars `bol' and `opoint'.
	(completion-setup-function): Use with-current-buffer.
	Properly save excursion.  Simplify.
	Don't assume there is necessarily a `mouse-face' property somewhere.

	* progmodes/gud.el (gud-reset): Use unless & with-current-buffer.

	* progmodes/gdb-ui.el (gdb-reset): Use unless.  Fix regexp.

	* emacs-lisp/bytecomp.el (byte-compile-log): Use backquotes.
	(byte-compile-log-1): Don't call (byte-goto-log-buffer).
	Use with-current-buffer.
	(byte-goto-log-buffer): Delete.
	(byte-compile-log-file): Call compilation-forget-errors.

2004-05-19  Takaaki Ota  <Takaaki.Ota@am.sony.com>  (tiny change)

	* net/ldap.el (ldap-search-internal): Avoid mixing standard error
	output messages into the search result.

2004-05-19  Masatake YAMATO  <jet@gyve.org>

	* wid-edit.el (widget-radio-button-notify): Revert my last
	change.  Reported by Katsumi Yamaoka <yamaoka@jpl.org>.

2004-05-19  Kenichi Handa  <handa@m17n.org>

	* international/characters.el: Fix syntax (open/close) of CJK chars.

2004-05-18  Karl Chen  <quarl@hkn.eecs.berkeley.edu>  (tiny change)

	* help-mode.el (help-go-back): Don't depend on position of back button.

2004-05-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* files.el (auto-save-file-name-transforms): Make sure ange-ftp temp
	files files don't contain an accidental additional /.

	* textmodes/tex-mode.el (tex-compilation-parse-errors): Save excursion
	in source buffer.

2004-05-18  Masatake YAMATO  <jet@gyve.org>

	* wid-edit.el (widget-radio-button-notify): Don't pass `widget'
	to widget-apply.  :action method assumes 2 arguments, not 3.

2004-05-17  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* progmodes/f90.el (f90-end-block-re, f90-start-block-re):
	New constants.
	(hs-special-modes-alist): Add an f90-mode entry.

2004-05-17  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/cl-indent.el (common-lisp-indent-function-1):
	Indent "without-" forms just like "with-" and "do-".  Use regexp-opt.

2004-05-16  Kim F. Storm  <storm@cua.dk>

	* emacs-lisp/timer.el (timer-event-handler): Fix last change.

2004-05-15  John Wiegley  <johnw@newartisans.com>

	* eshell/esh-io.el (eshell-get-target): Whitespace changes.
	(eshell-output-object-to-target): Improve output speed 20% by not
	calling `eshell-stringify' if something is already known to be a string.

2004-05-15  Alex Ott  <ott@jet.msk.su>

	* textmodes/ispell.el (ispell-local-dictionary-alist):
	Add windows-1251 to the choice of coding systems.
	(ispell-dictionary-alist-6): Add support for "russianw.aff",
	encoded in cp1251.

2004-05-15  Dan Nicolaescu  <dann@ics.uci.edu>

	* progmodes/compile.el (compilation-warning-face)
	(compilation-info-face): Use min-colors.

2004-05-15  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* toolbar/close.pbm, toolbar/close.xpm, toolbar/copy.pbm
	* toolbar/copy.xpm, toolbar/cut.pbm, toolbar/cut.xpm
	* toolbar/help.pbm, toolbar/help.xpm, toolbar/home.pbm
	* toolbar/home.xpm, toolbar/index.pbm, toolbar/index.xpm
	* toolbar/jump_to.pbm, toolbar/jump_to.xpm, toolbar/left_arrow.pbm
	* toolbar/left_arrow.xpm, toolbar/new.pbm, toolbar/new.xpm
	* toolbar/open.pbm, toolbar/open.xpm, toolbar/paste.pbm
	* toolbar/paste.xpm, toolbar/preferences.pbm, toolbar/preferences.xpm
	* toolbar/print.pbm, toolbar/print.xpm, toolbar/right_arrow.pbm
	* toolbar/right_arrow.xpm, toolbar/save.pbm, toolbar/save.xpm
	* toolbar/saveas.pbm, toolbar/saveas.xpm, toolbar/search.pbm
	* toolbar/search.xpm, toolbar/spell.pbm, toolbar/spell.xpm
	* toolbar/undo.pbm, toolbar/undo.xpm, toolbar/up_arrow.pbm
	* toolbar/up_arrow.xpm: New icons from GTK+ version 2.

2004-05-15  Kim F. Storm  <storm@cua.dk>

	* emacs-lisp/timer.el (timer-activate): Add optional arg triggered-p.
	Use it to set triggered-p element of timer.
	(timer-event-handler): Set triggered-p element non-nil while running
	the timer function.

2004-05-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* descr-text.el (describe-char-unicode-data)
	(describe-char-unicodedata-file): Re-enable the unicode code now that
	the licensing issues have been cleared in the unicode-4 license.
	(describe-text-properties-1): Remove unused `overlay' var.
	(describe-char): Remove unused var `buffer'.

2004-05-14  David Ponce  <david@dponce.com>

	* tree-widget.el: New file.

2004-05-13  Marcelo Toledo  <marcelo@marcelotoledo.org>

	* language/european.el ("Brazilian Portuguese"): Add support for
	Brazilian Portuguese.

2004-05-13  John Wiegley  <johnw@newartisans.com>

	* iswitchb.el (iswitchb-use-virtual-buffers): Only turn on
	`recentf-mode' if this variable has been customized to t.

	* eshell/esh-test.el (eshell-test): Call the function
	`emacs-version' rather than trying to build a custom version string.

2004-05-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* net/telnet.el (telnet-mode): Use define-derived-mode.
	Don't modify the global value of comint-prompt-regexp.

2004-05-13  John Paul Wallington  <jpw@gnu.org>

	* version.el (emacs-version): Check for `gtk' feature before
	`x-toolkit' feature.

2004-05-13  Juanma Barranquero  <lektu@terra.es>

	* files.el (file-truename): Don't mention COUNTER and PREV-DIRS
	arguments in the docstring, they're used only in recursive calls.

	* help-fns.el (help-arg-highlighting-function)
	(help-argument-name): Delete.
	(help-default-arg-highlight): New function.
	(help-do-arg-highlighting): Use it.

2004-05-13  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* calendar/appt.el (appt-disp-window):
	Use `calendar-set-mode-line' for a centered mode-line.

2004-05-13  Takaaki Ota  <Takaaki.Ota@am.sony.com>  (tiny change)

	* calendar/appt.el (appt-disp-window): Do not split window
	excessively when `split-height-threshold' is low.

2004-05-12  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gud.el (gud-mode): Add gud-kill-buffer-hook to
	kill-buffer-hook here and make it local.
	(gud-kill-buffer-hook): Use kill-process for a sure kill.

2004-05-12  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-set-window-height):
	Use save-excursion to protect against misplaced marker.

2004-05-12  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* custom.el (defface): Document that type can have value gtk.

	* faces.el (face-spec-set-match-display): Handle type gtk in display.

2004-05-12  Kenichi Handa  <handa@m17n.org>

	* descr-text.el: Require quail at comile time.
	(describe-char): If an input method is on and it supports the
	character, show how to input it.

	* international/quail.el (quail-install-decode-map): Accept a
	char-table whose subtype is `quail-decode-map'.
	(quail-store-decode-map-key, quail-gen-decode-map1)
	(quail-gen-decode-map, quail-find-key1, quail-find-key)
	(quail-show-key): New functions.

2004-05-12  Juanma Barranquero  <lektu@terra.es>

	* generic.el (define-generic-mode): Remove redundant arglist info.

	* help-fns.el (help-split-fundoc, help-add-fundoc-usage):
	Make arguments match their use in docstring.
	(help-arg-highlighting-function): New variable.
	(help-argument-name): Mention it in the docstring.
	(help-do-arg-highlight): Use it.  Expand regexp to accept also
	ARG-xxx and xxx-ARG references.

2004-05-11  Yoichi NAKAYAMA  <yoichi@geiin.org>  (tiny change)

	* mail/rfc2368.el (rfc2368-parse-mailto-url): Make the results of
	parsing "mailto:addr1%2C%20addr2", "mailto:?to=addr1%2C%20addr2",
	and "mailto:addr1?to=addr2" equal.

2004-05-11  Alexander Pohoyda  <alexander.pohoyda@gmx.net>  (tiny change)

	* man.el (Man-getpage-in-background): Use shell-file-name
	and shell-command-switch variables instead of hard-coded values.

2004-05-11  Eli Zaretskii  <eliz@gnu.org>

	* iimage.el: New file.

2004-05-11  Juanma Barranquero  <lektu@terra.es>

	* custom.el (custom-initialize-default, defcustom):
	Fix typo in docstring.

	* files.el (set-visited-file-name, file-expand-wildcards):
	Fix docstring.

2004-05-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/lisp-mode.el (prin1-char): Use eventp.

	* subr.el (eventp): Be more discriminating with integers.

2004-05-10  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compile): Add universal prefix arg.
	(compilation-error-regexp-alist-alist): Add edg patterns.

2004-05-10  Sam Steingold  <sds@gnu.org>

	* textmodes/ispell.el (ispell-message):
	Use `message-cite-prefix-regexp' instead of `message-yank-prefix'.

2004-05-10  Dave Love  <fx@gnu.org>

	* progmodes/python.el (help-buffer): Autoload when compiling.
	(python-after-info-look): Don't assume Info-goto-node returns non-nil.
	(run-python): Prepend to any existing PYTHONPATH.

2004-05-10  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-annotation-rules): Add nquery annotation
	for pending breakpoints.

2004-05-10  Richard M. Stallman  <rms@gnu.org>

	* mail/unrmail.el (unrmail): Mostly rewritten.  Parses the file
	directly without calling any functions in Rmail.
	(unrmail-unprune): Function deleted.

2004-05-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/python.el (inferior-python-mode-map): Remove erroneous
	C-c C-z binding.

2004-05-10  Kenichi Handa  <handa@m17n.org>

	* descr-text.el (describe-char): Fix previous change.  Don't make
	a unibyte character to multibyte in the *Help* buffer.

2004-05-10  Miles Bader  <miles@gnu.org>

	* lisp/progmodes/gud.el (gud-common-init): Only consider an existing
	buffer an error if the debugger process is actually running.

2004-05-10  Juanma Barranquero  <lektu@terra.es>

	* help-fns.el (help-argument-name): Default to italic.
	(help-highlight-arguments): Return always (usage . doc), even when
	usage is nil.

	* ibuf-macs.el (define-ibuffer-column, define-ibuffer-sorter)
	(define-ibuffer-filter): Add usage info.
	(define-ibuffer-op): Add usage info (but CL-style defaults for
	keyword args are not shown).

	* subr.el (remove-overlays, read-passwd): Fix docstring.
	(start-process-shell-command): Fix docstring.  Put usage info in a
	format usable by `describe-function'.
	(open-network-stream, open-network-stream-nowait)
	(open-network-stream-server): Fix docstring.

2004-05-09  Jason Rumney  <jasonr@gnu.org>

	* international/code-pages (cp932, cp936, cp949, c950): Remove.
	Only define cp125* if windows-125* is already defined.

	* language/korean.el (cp949): Add alias.

	* language/chinese.el (cp936, cp950): Add aliases.

	* language/japanese.el (cp932): Add alias.

	* term/w32-win.el: Require code-pages.

	* international/mule-cmds.el (set-locale-environment):
	On MS-Windows use ansi code-page for default coding-systems.
	Set up paper sizes for Windows 3 letter languages.

	* international/code-pages.el (cp932, cp936, cp949, cp950):
	Add aliases.  Also add cp125* if not already defined.

2004-05-09  Juanma Barranquero  <lektu@terra.es>

	* help-fns.el (help-highlight-arguments): Don't try to highlight
	missing or autoloaded arglists.  Accept structured arguments, like
	the first ones of `do' and `flet'.

	* pcvs.el (cvs-mode-run, cvs-is-within-p): Fix typo in docstring.
	(cvs-get-marked): Remove redundant arglist info.

	* net/quickurl.el (quickurl, quickurl-browse-url, quickurl-read):
	Don't use CL-style default args.

2004-05-08  Andreas Schwab  <schwab@suse.de>

	* emacs-lisp/checkdoc.el (checkdoc-minor-mode): Doc fix.

	* international/subst-ksc.el: Fix references to utf-translate-cjk
	into utf-translate-cjk-mode.
	* international/subst-big5.el: Likewise.
	* international/subst-gb2312.el: Likewise.
	* international/subst-jis.el: Likewise.
	* international/utf-16.el: Likewise.
	* international/utf-8.el: Likewise.

2004-05-08  John Wiegley  <johnw@newartisans.com>

	* iswitchb.el (iswitchb-use-virtual-buffers): Add support for
	"virtual buffers" (off by default), which makes it possible to
	switch to the "virtual" buffers of recently visited files.  When a
	buffer name search fails, and this option is on, iswitchb will
	look at the list of recently visited files, and permit matching
	against those names.  When the user hits RET on a match, it will
	revisit that file.
	(iswitchb-read-buffer): Add two optional arguments, which makes
	isearchb.el possible.
	(iswitchb-completions, iswitchb-set-matches, iswitchb-prev-match)
	(iswitchb-next-match): Add support for virtual buffers.

	* isearchb.el: This module extends iswitchb to provide "as you
	type" buffer selection.

	* textmodes/flyspell.el (flyspell-highlight-incorrect-region):
	Ignore the read-only property when flyspell highlighting is on.
	Not ignoring it leads to a series of confusing errors.
	(flyspell-highlight-duplicate-region): Ignore read-only, as above,
	but also make sure to call flyspell-incorrect-hook.
	(flyspell-maybe-correct-transposition): Perform transposition test
	by bit twiddling a string, rather than using a temp buffer.
	(flyspell-maybe-correct-doubling): Use a string rather than a temp
	buffer.  This is also the original version of the code, which
	could not be checked in before due to a previous lack of
	assignment papers.  This version has seen heavy usage on my system
	for several years now.

	* calendar/cal-bahai.el: New file, which adds support for the
	Baha'i calendar to Emacs.  This calendar is based on a solar year
	of 19 months of 19 days, with 4 intercalary days.  Each year
	begins on March 21, with the calendar starting in 1844.

	* calendar/cal-menu.el, calendar/calendar.el,
	calendar/diary-lib.el, calendar/holidays.el: Added support for
	using cal-bahai.el.

	* eshell/em-glob.el (eshell-glob-initialize): Move initialization
	of `eshell-glob-chars-regexp' into `eshell-glob-regexp', so that
	function can be used outside of eshell buffers.
	(eshell-glob-regexp): Initialize `eshell-glob-chars-regexp' here.

2004-05-08  Juanma Barranquero  <lektu@terra.es>

	* help-fns.el (help-do-arg-highlight): Temporarily set ?\- to be a
	word constituent so FOO-ARG is not recognized as an arg.
	(help-highlight-arguments): Don't skip lists in mandatory arguments.

	* simple.el (next-error): Fix typo in docstring.
	(open-line): Make argument names match their use in docstring.
	(split-line): Fix docstring.

	* emacs-lisp/cl-macs.el (do, do*): Put usage info in a format
	usable by `describe-function'.
	(gensym, gentemp, typep, ignore-errors): Make argument names match
	their use in docstring.

	* progmodes/python.el (python-describe-symbol): Pass INTERACTIVE-P
	argument to `help-setup-xref'.

2004-05-07  Kai Grossjohann  <kai@emptydomain.de>

	Version 2.0.40 of Tramp released.

	* net/tramp.el (tramp-completion-mode, tramp-md5-function):
	Use symbol-function to invoke functions only known on some Emacs
	flavors.  This avoids byte-compiler warnings.  Reported by Kevin
	Scaldeferri <kevin@scaldeferri.com>.
	(tramp-do-copy-or-rename-file-via-buffer): Rename from
	tramp-do-copy-or-rename-via-buffer (without `file'), to make it
	consistent with the other tramp-do-* functions.
	(tramp-do-copy-or-rename-file): Calls adjusted.
	(tramp-process-initial-commands): Avoid liveness check on shell --
	we know that it must be alive since we're opening a connection at
	this moment.
	(tramp-last-cmd): New internal variable.
	(tramp-process-echoes): New tunable.
	(tramp-send-command): Set tramp-last-cmd.
	(tramp-wait-for-output): Delete echo, if applicable.
	(tramp-read-passwd): Construct the key for the password cache in a
	way that works for multi methods, too.
	(tramp-bug): Add backup-directory-alist and
	bkup-backup-directory-info to bug reports, with Tramp counterparts.

2004-05-07  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp*.el: Suppress byte-compiler warnings where possible.

	* net/tramp.el (tramp-out-of-band-prompt-regexp)
	(tramp-actions-copy-out-of-band): New defcustoms.
	(tramp-do-copy-or-rename-file-out-of-band): Asynchronous process
	used instead of a synchronous one.  Allows password entering.
	(tramp-action-out-of-band): New defun.
	(tramp-open-connection-rsh, tramp-method-out-of-band-p):
	Remove restriction with password from doc string.
	(tramp-bug): Add variables `tramp-terminal-prompt-regexp',
	`tramp-out-of-band-prompt-regexp',
	`tramp-actions-copy-out-of-band', `password-cache' and
	`password-cache-expiry'.
	(toplevel): Remove todo item wrt ssh-agent.  Obsolete due to
	password caching.
	(tramp-touch): FILE can be a local file, too.
	(TODO): Remove items done.
	(tramp-handle-insert-directory): Properly quote file name also if
	not full-directory-p.  Handle wildcard case.  Reported by Andreas
	Schwab <schwab@suse.de>.
	(tramp-do-copy-or-rename-file-via-buffer): Set permissions of the
	new file.
	(tramp-handle-file-local-copy, tramp-handle-write-region):
	The permissions of the temporary file are set if filename exists.
	Reported by Ted Stern <stern@cray.com>.
	(tramp-backup-directory-alist)
	(tramp-bkup-backup-directory-info): New defcustoms.
	(tramp-file-name-handler-alist): Add entry for `find-backup-file-name'.
	(tramp-handle-find-backup-file-name): New function.
	Implements Tramp's find-backup-file-name.

	* net/tramp-smb.el (tramp-smb-file-name-handler-alist): Add entry
	for `find-backup-file-name'.

	* net/tramp-vc.el (tramp-vc-workfile-unchanged-p): Correct typo
	("file" -> "filename").  Reported by Kim F. Storm <storm@cua.dk>.

2004-05-07  Lars Hansen  <larsh@math.ku.dk>

	* desktop.el (desktop-buffer-mode-handlers): Fix docstring.

2004-05-07  Juanma Barranquero  <lektu@terra.es>

	* subr.el (lambda): Add arglist description to docstring.
	(declare): Fix typo in docstring.
	(open-network-stream): Fix docstring.
	(process-kill-without-query): Fix docstring and add obsolescence info.
	(last, butlast, nbutlast): Make arguments match their use in docstring.
	(insert-buffer-substring-no-properties): Likewise.
	(insert-buffer-substring-as-yank): Likewise.
	(split-string): Fix docstring.

	* emacs-lisp/byte-run.el (make-obsolete, make-obsolete-variable):
	Make argument names match their use in docstring.

	* emacs-lisp/re-builder.el (reb-auto-update): Fix typo in docstring.

2004-05-06  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el: Improve/extend documentation strings.
	Fit first sentence on one line for apropos-command.

2004-05-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	Changes largely merged in from Dave Love's code.
	* progmodes/python.el: Doc fixes.
	(python-mode-map): Add python-complete-symbol.
	(python-comment-line-p, python-beginning-of-string): Use syntax-ppss.
	(python-comment-indent, python-complete-symbol)
	(python-symbol-completions, python-partial-symbol)
	(python-try-complete): New.
	(python-indent-line): Remove optional arg.  Use python-block-end-p.
	(python-check): Bind compilation-error-regexp-alist.
	(inferior-python-mode): Use rx.  Move keybindings to top level.
	Set comint-input-filter.
	(python-preoutput-filter): Use rx.
	(python-input-filter): Re-introduce.
	(python-proc): Start new process if necessary.
	Check python-buffer non-nil.
	(view-return-to-alist): Defvar.
	(python-send-receive): New.
	(python-eldoc-function): Use it.
	(python-mode-running): Don't defvar.
	(python-mode): Set comment-indent-function.
	Maybe update hippie-expand-try-functions-list.
	(python-indentation-levels): Initialize differently.
	(python-block-end-p): New.
	(python-indent-line): Use it.
	(python-compilation-regexp-alist): Augment.
	(run-python): Import `emacs' module to Python rather than loading
	code directly.  Set python-buffer differently.
	(python-send-region): Use emacs.eexecfile.  Fix orig-start calculation.
	Use python-proc.
	(python-send-command): Go to end of comint buffer.
	(python-load-file): Use python-proc, emacs.eimport.
	(python-describe-symbol): Simplify interactive form.
	Use emacs.help.  Do use temp-buffer-show-hook.
	Call print-help-return-message.
	(hippie-exp): Require when compiling.
	(python-preoutput-continuation): Use rx.

	* diff-mode.el (diff-make-unified): Fix regexp.

2004-05-06  Romain Francoise  <romain@orebokech.com>  (tiny change)

	* ibuffer.el (ibuffer-redisplay-engine): Do not remove folded
	filter groups from the buffer when rebuilding the Ibuffer buffer
	and `ibuffer-show-empty-filter-groups' is nil.

2004-05-06  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* ps-print.el (ps-print-quote): Call ps-value-string.
	(ps-setup): Call ps-comment-string.
	(ps-value-string, ps-comment-string): New funs.

2004-05-06  Juanma Barranquero  <lektu@terra.es>

	* ehelp.el (electric-help-command-loop): Check whether the last
	character is visible, not (point-max).

	* help-fns.el (help-argument-name): Default to bold; don't inherit
	from font-lock-variable-name-face.
	(help-do-arg-highlight): Grok also ARGth occurrences in the docstring.

2004-05-05  Kenichi Handa  <handa@m17n.org>

	* descr-text.el (describe-char): Copy the character with text
	properties and overlays into the first line, and call
	describe-text-properties on it.

2004-05-05  Stephen Eglen  <stephen@anc.ed.ac.uk>

	* iswitchb.el (iswitchb-global-map): Fix typo.
	Remove unwanted ###autoloads from source file.

2004-05-05  Lars Hansen  <larsh@math.ku.dk>

	* wdired.el (wdired-change-to-wdired-mode): Quote wdired-mode-hook
	in run-hooks.  Use substitute-command-keys in message.
	(wdired-abort-changes): Add message.

2004-05-03  Michael Mauger  <mmaug@yahoo.com>

	* emacs/lisp/progmodes/sql.el (sql-xemacs-p, sql-emacs19-p)
	(sql-emacs20-p): Remove.
	(sql-mode-syntax-table): Use shared GNU EMacs/XEmacs syntax.
	(sql-builtin-face, sql-doc-face): Remove.
	(sql-mode-ansi-font-lock-keywords)
	(sql-mode-oracle-font-lock-keywords)
	(sql-mode-postgres-font-lock-keywords)
	(sql-mode-linter-font-lock-keywords)
	(sql-mode-ms-font-lock-keywords)
	(sql-mode-mysql-font-lock-keywords): Use standard fonts.
	(sql-product-font-lock): Fix font-lock reset when font rules change.
	(sql-highlight-product): Remove incorrect font-lock reset logic.

2004-05-04  Jonathan Yavner  <jyavner@member.fsf.org>

	* ses.el (ses-set-parameter): Fix typo.

2004-05-04  Kim F. Storm  <storm@cua.dk>

	* ido.el (ido-read-internal): Fix call to read-file-name for edit.
	Must expand directory for completion to work; and don't mess with
	process-environment.
	(ido-read-file-name): If command has ido property, don't use ido
	if value is ignore, or read as directory if value is dir.
	Set ido ignore property for dired-do-rename command.

2004-05-04  Juanma Barranquero  <lektu@terra.es>

	* ehelp.el (electric-help-command-loop, electric-help-undefined)
	(electric-help-help): Check against unmapped commands.

	* help-fns.el (help-argument-name): New face, inheriting from
	font-lock-variable-name-face, to highlight function arguments in
	`describe-function' and `describe-key'.
	(help-do-arg-highlight): Auxiliary function to highlight a given
	list of arguments in a string.
	(help-highlight-arguments): Highlight the function arguments and
	all uses of them in the docstring.
	(describe-function-1): Use it.  Do docstring output via `insert',
	not 'princ', so text attributes are preserved.

	* winner.el (winner-mode-map): Move `winner-undo' and
	`winner-redo' to C-c <left> and C-c <right>, respectively (the
	previous bindings conflict with `prev-buffer', `next-buffer').

2004-05-03  Roland Winkler  <Roland.Winkler@physik.uni-erlangen.de>

	* textmodes/bibtex.el (bibtex-progress-message): Fix docstring.
	(bibtex-entry-update): New command bound to C-c C-u.
	(bibtex-text-in-string): Fix regexp.
	(bibtex-assoc-of-regexp): Remove.
	(bibtex-progress-message): Fix docstring.
	(bibtex-inside-field): Use if.
	(bibtex-assoc-regexp): New function.
	(bibtex-format-entry): Make code more robust so that it formats
	also old entries.
	(bibtex-autokey-demangle-title): Merge with obsolete function
	bibtex-assoc-of-regexp.
	(bibtex-field-list): New function.
	(bibtex-entry): Use bibtex-field-list.
	(bibtex-parse-entry): Fix docstring.
	(bibtex-print-help-message): Use bibtex-field-list.
	(bibtex-make-field): Use bibtex-field-list.
	(bibtex-entry-index): Bugfix.  Return crossref key if required.
	(bibtex-lessp): Fix docstring.

2004-05-03  Luc Teirlinck  <teirllm@auburn.edu>

	* select.el (xselect-convert-to-string): Move comment to intended line.

2004-05-03  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* toolbar/tool-bar.el (tool-bar-setup): Use lookup-key for
	cut/copy/paste in case menu-bar-enable-clipboard is in effect.

2004-05-03  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* term/x-win.el (x-clipboard-yank): Don't exit on error from
	x-get-selection.

2004-05-03  Jason Rumney  <jasonr@gnu.org>

	* makefile.nt: Remove.

2004-05-03  Kim F. Storm  <storm@cua.dk>

	* emulation/cua-base.el (cua--update-indications): Fix last change.
	(cua-mode): Deactivate mark when cua-mode is enabled.

2004-05-02  Luc Teirlinck  <teirllm@auburn.edu>

	* select.el (xselect-convert-to-string): Bind `inhibit-read-only' to t.

2004-05-03  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el (gud-watch, gdb-display-buffer)
	(gdb-display-source-buffer, gdb-put-breakpoint-icon)
	(gdb-remove-breakpoint-icons, gdb-assembler-custom): Look for
	window over visible frames.
	(gdb-goto-breakpoint): Make buffer display file at breakpoint.

2004-05-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/compile.el (compilation-gcpro): New var.
	(compilation-fake-loc): Use it.
	(compilation-forget-errors): Reset it.

2004-05-02  Dan Nicolaescu  <dann@ics.uci.edu>

	* diff-mode.el (diff-header-face, diff-file-header-face):
	Use min-colors.

2004-05-02  Roland Winkler  <Roland.Winkler@physik.uni-erlangen.de>

	* textmodes/bibtex.el (bibtex-sort-buffer): Remove error message.
	(bibtex-clean-entry): Disentangle code.
	(bibtex-realign): New function.
	(bibtex-reformat): Use mapcar and bibtex-realign.  Do not use
	bibtex-beginning-of-first-entry and bibtex-skip-to-valid-entry.
	Remove undocumented optional arg called-by-convert-alien.
	(bibtex-convert-alien): Use bibtex-realign.  Use bibtex-reformat
	for sorting instead of bibtex-sort-buffer.

2004-05-02  Eli Zaretskii  <eliz@gnu.org>

	* progmodes/compile.el (compilation-start): In the
	no-async-subprocesses branch, call sit-for to give redisplay a
	chance to show the updated process status in the mode line, and
	fontify the buffer explicitly after the process exits.

2004-05-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/python.el (python-compilation-line-number): Remove.
	(python-compilation-regexp-alist): Don't use it any more.
	(python-orig-start, python-input-filter): Remove.
	(inferior-python-mode): Don't set up comint-input-filter-functions.
	(python-send-region): Use compilation-fake-loc.

	* progmodes/compile.el (compilation-messages-start): New var.
	(compilation-mode): Don't setup next-error-function here.
	(compilation-setup): Set it up here instead (for minor modes as well).
	Make compilation-messages-start buffer local.
	(compilation-next-error-function): Use it.
	(compilation-forget-errors): Set compilation-messages-start.

2004-05-01  Luc Teirlinck  <teirllm@auburn.edu>

	* ielm.el (ielm-prompt-read-only): Update docstring.

	* comint.el (comint-prompt-read-only): Update docstring.
	(comint-update-fence, comint-kill-whole-line)
	(comint-kill-region): New functions.

	* simple.el (kill-whole-line): Use "p" instead of "P" in
	interactive form.

2004-05-01  Juanma Barranquero  <lektu@terra.es>

	* help-fns.el (help-add-fundoc-usage): Use %S instead of %s to
	format arglist so default values in CL-style argument lists are
	correctly shown.

2004-05-01  Jason Rumney  <jasonr@gnu.org>

	* term/w32-win.el (w32-drag-n-drop): Use x-dnd.el functions.

2004-05-01  Kenichi Handa  <handa@m17n.org>

	* international/titdic-cnv.el (miscdic-convert): Don't generate a
	quail file if it is up to date.

2004-04-30  Juri Linkov  <juri@jurta.org>

	* cus-edit.el (custom-mode-map):
	Add key binding `C-x C-s' to `Custom-save'.

	* outline.el (outline-blank-line): New var.
	(outline-next-preface, outline-show-heading)
	(outline-end-of-subtree): Use it.

	* dired-aux.el (dired-touch-initial): New fun.
	(dired-do-chxxx): Call it for op-symbol `touch'.
	(dired-diff): Use `dired-dwim-target-directory'
	if current dired buffer has no buffer mark.

	* bindings.el (propertized-buffer-identification):
	Replace `(:weight bold)' by `Buffer-menu-buffer-face'.
	Add C-M-arrow keys for consistency.

	* files.el (confirm-kill-emacs):
	Change group from top-level `emacs' to `convenience'.

	* emacs-lisp/lisp.el (beginning-of-defun, end-of-defun):
	Push mark on the first call of successive command calls.
	(insert-pair): New fun created from `insert-parentheses' with
	`open' and `close' arguments added.  Enclose active regions
	in paired characters.  Compare adjacent characters syntax with
	inserted characters syntax before inserting a space.
	(insert-parentheses): Call `insert-pair' with ?\( ?\).

	* delsel.el: Don't put `delete-selection' property
	on `insert-parentheses' symbol to take advantage of
	region handling in `insert-pair' function.
	Suggested by Stephan Stahl <stahl@eos.franken.de>.

2004-04-30  Kim F. Storm  <storm@cua.dk>

	* emulation/cua-base.el: Add support for changing cursor types;
	based on patch from Michael Mauger.
	(cua-normal-cursor-color, cua-read-only-cursor-color)
	(cua-overwrite-cursor-color, cua-global-mark-cursor-color):
	Customization cursor type and/or cursor color.
	(cua--update-indications): Handle cursor type changes.
	(cua-mode): Update cursor indications if enabled.

	* menu-bar.el (menu-bar-options-menu): Change menu text for CUA.

	* mouse.el (mouse-drag-copy-region): New defcustom.
	(mouse-set-region, mouse-drag-region-1): Use it.

	* simple.el (kill-ring-save): If region face background color is
	unspecified (if no highlighting), show extent of fully visible
	region even if transient-mark-mode is enabled.

	* emulation/cua-base.el (cua--standard-movement-commands):
	Add cua-scroll-up and cua-scroll-down.
	(cua-scroll-up, cua-scroll-down): New commands.
	(cua--init-keymaps): Remap scroll-up and scroll-down.

	* emulation/cua-rect.el (cua--convert-rectangle-as):
	New defmacro.
	(cua-upcase-rectangle, cua-downcase-rectangle): Use it.
	(cua-upcase-initials-rectangle, cua-capitalize-rectangle):
	New commands (suggested by Jordan Breeding).

2004-04-30  Juanma Barranquero  <lektu@terra.es>

	* smerge-mode.el (smerge-diff-switches): Fix typo in docstring.

2004-04-30  Mario Lang  <mlang@delysid.org>

	* diff.el (diff-switches): Fix typo in docstring.

2004-04-30  Alex Schroeder  <alex@gnu.org>

	* xml.el (xml-debug-print-internal): Don't add newline and
	indentation to text nodes and write empty elements as empty tags
	instead of opening and closing tags.
	(xml-debug-print): Take optional indent-string argument.
	(xml-print): Alias for xml-debug-print.

2004-04-30  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* progmodes/fortran.el (fortran-fill): Use local var `bol' rather
	than duplicate call to `line-beginning-position'.

	* progmodes/f90.el (f90-get-present-comment-type):
	Return whitespace, as well as comment chars, for consistent filling
	of comment blocks.  Use `match-string-no-properties'.
	(f90-break-line): Trim trailing whitespace when filling comments.

2004-04-30  Dave Love  <fx@gnu.org>

	* calendar/diary-lib.el (diary-outlook-formats): New variable.
	(diary-from-outlook-internal, diary-from-outlook)
	(diary-from-outlook-gnus, diary-from-outlook-rmail):
	New functions to import diary entries from Outlook-format
	appointments in mail messages.

2004-04-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/python.el (python-send-command): New fun.
	(python-send-region, python-load-file): Use it.

	* progmodes/compile.el (compilation-last-buffer): Add var alias.

	* help-fns.el (help-C-file-name): Use new subr-name.
	Prepend `src/' to the file name.
	(help-C-source-directory, help-subr-name, help-find-C-source): Remove.
	(describe-function-1, describe-variable): Only find a C source file
	name if DOC is already loaded.

	* help-mode.el (help-function-def, help-variable-def):
	Use the new find-function-search-for-symbol functionality.
	Allow FILE to be `C-source'.

	* emacs-lisp/find-func.el (find-function-C-source-directory): New var.
	(find-function-C-source): New fun.
	(find-function-search-for-symbol): Use it.

2004-03-29  Michael Mauger  <mmaug@yahoo.com>

	* progmodes/sql.el (sql-product-alist): Rename variable
	`sql-product-support'.  Add Postgres login parameters.
	(sql-set-product, sql-product-feature): Update with renamed variable.
	(sql-connect-postgres): Add username prompt.
	(sql-imenu-generic-expression, sql-mode-font-lock-object-name):
	Make patterns less product specific.
	(sql-xemacs-p, sql-emacs19-p): Add flags for Emacs variants.
	(sql-mode-abbrev-table): Modify initialization.
	(sql-builtin-face): Add variable.
	(sql-keywords-re): Add macro.
	(sql-mode-ansi-font-lock-keywords): Update for ANSI-92.
	(sql-mode-oracle-font-lock-keywords): Update for Oracle 9i.
	(sql-mode-postgres-font-lock-keywords): Update for Postgres 7.3.
	(sql-mode-mysql-font-lock-keywords): Update for MySql 4.0.
	(sql-mode-linter-font-lock-keywords)
	(sql-mode-ms-font-lock-keywords): Use `sql-keywords-re' macro.
	(sql-mode-sybase-font-lock-keywords)
	(sql-mode-informix-font-lock-keywords)
	(sql-mode-interbase-font-lock-keywords)
	(sql-mode-ingres-font-lock-keywords)
	(sql-mode-solid-font-lock-keywords)
	(sql-mode-sqlite-font-lock-keywords)
	(sql-mode-db2-font-lock-keywords): Default to nil.
	(sql-product-font-lock): Always highlight ANSI keywords.
	(sql-add-product-keywords): Made similar to `font-lock-add-keywords'.
	(sql-send-string): Add function.

2004-04-29  Dave Love  <fx@gnu.org>

	* progmodes/cfengine.el (cfengine-beginning-of-defun)
	(cfengine-end-of-defun): Ensure progress through buffer.

	* info-look.el (cfengine-mode): Accept a terminal ().

2004-04-29  Juri Linkov  <juri@jurta.org>

	* isearch.el (isearch-mode-map): Bind \C-w to isearch-yank-word
	instead of isearch-yank-word-or-char.  Add new key bindings for
	isearch-yank-char to \C-f, and isearch-del-char to \C-b.
	(isearch-del-char): New fun.
	(isearch-forward, isearch-edit-string): Update docstring.
	(isearch-yank-char): Doc fix.
	(isearch-other-meta-char): Restore point after scrolling.

	* progmodes/compile.el (compilation-context-lines): Add nil option
	to disable compilation output window scrolling.
	(compilation-set-window): Use it.

	* outline.el (outline-next-preface, outline-show-heading):
	Don't leave unhidden blank line before heading.
	(outline-end-of-subtree): Include last newline into subtree.
	(hide-entry): Leave point at beginning of heading instead of end.
	(outline-up-heading): Push mark for the first call of successive
	command calls.

2004-04-28  Luc Teirlinck  <teirllm@auburn.edu>

	* comint.el (comint-prompt-read-only): New variable.
	(comint-output-filter): Implement it.

	* ielm.el (ielm-prompt-read-only, ielm-prompt): Update docstring.
	(ielm-prompt-internal): New variable.
	(ielm-font-lock-keywords): Remove irrelevant ielm-prompt keyword.
	(ielm-send-input): Delete unused variable `buf'.
	(ielm-eval-input): Use `ielm-prompt-internal'.
	(inferior-emacs-lisp-mode): Use new variables
	`comint-prompt-read-only' and `ielm-prompt-internal'.
	Get rid of obsolete variable `directory-sep-char'.
	(ielm): Use `zerop'.

2004-04-29  John Paul Wallington  <jpw@gnu.org>

	* thumbs.el (toplevel): Require cl at compile time.
	Remove conditional definitions of `ignore-errors' and `caddar'
	because they occur at run time.

2004-04-28  Nick Roberts  <nickrob@gnu.org>

	* progmodes/gdb-ui.el (gdb-frame-breakpoints-buffer)
	(gdb-frame-assembler-buffer, gdb-frame-threads-buffer)
	(gdb-frame-registers-buffer, gdb-frame-locals-buffer)
	(gdb-frame-gdb-buffer, gdb-frame-stack-buffer): Use selected-window.

	* progmodes/gud.el (gud-common-init): Throw an error if program is
	already running under gdb.

2004-04-28  John Paul Wallington  <jpw@gnu.org>

	* thumbs.el (thumbs-delete-images): Fix formatting of prompt.
	(thumbs-show-image-num): Move assignment of
	`thumbs-current-image-filename' within scope of `i'.
	(thumbs-emboss-image): Don't use `evenp'.

2004-04-28  Richard M. Stallman  <rms@gnu.org>

	* progmodes/compile.el (compilation-context-lines): Default now 0.

2004-04-28  Juanma Barranquero  <lektu@terra.es>

	Use `time-less-p' from calendar/time-date.el instead of defining
	custom versions of it.

	* pcomplete.el (pcomplete-time-less-p): Remove.

	* thumbs.el (time-less-p): Remove.

	* calendar/timeclock.el (timeclock-time-less-p): Remove.
	(timeclock-generate-report): Use `time-less-p'.

	* emacs-lisp/autoload.el (autoload-before-p): Remove.
	(update-file-autoloads, update-directory-autoloads): Use `time-less-p'.

2004-04-28  Masatake YAMATO  <jet@gyve.org>

	* subr.el (remove-overlays): Make arguments optional.

	* wid-edit.el (widget-specify-button): Put evaporate to the
	overlay for sample.
	(widget-specify-sample): Put evaporate to the overlay for sample.
	(widget-specify-doc): Put evaporate to the overlay for documentation.

2004-04-27  Jesper Harder  <harder@ifa.au.dk>

	* info.el (info-apropos): Make it an index node.  Align node names
	like makeinfo.

2004-04-27  Eli Zaretskii  <eliz@gnu.org>

	* net/browse-url.el (browse-url-netscape-sentinel)
	(browse-url-mozilla-sentinel, browse-url-galeon-sentinel)
	(browse-url-epiphany-sentinel, browse-url-mosaic):
	Use browse-url-*-program instead of a literal program name.

2004-04-27  Kevin Ryde  <user42@zip.com.au>

	* eshell/em-alias.el:
	* eshell/em-dirs.el:
	* eshell/em-hist.el:
	* eshell/em-unix.el: Add "(require 'eshell)", to get necessary
	features when M-x customize-group loads modules before the main
	eshell.el.

2004-04-27  Matthew Mundell  <matt@mundell.ukfsn.org>

	* subr.el (momentary-string-display): Support EXIT-CHAR that is
	either a character representation of an event or an event
	description list.

	* type-break.el: Capitalise Emacs and Lisp.
	(type-break-good-break-interval, type-break-demo-boring-stats)
	(type-break-terse-messages, type-break-file-name): New defcustoms.
	(type-break-post-command-hook)
	(type-break-warning-countdown-string): Quote variable names in doc.
	(type-break-interval-start, type-break-auto-save-file-name): New vars.
	(type-break-mode): Document type-break-good-break-interval and the
	"session" file.  Schedule break according to the session file.
	Kill session file buffer on exit.  Organise for save-some-buffers
	to always save the session file.
	(type-break-mode-line-message-mode, type-break-query-mode):
	Uppercase arguments.
	(type-break-file-time, type-break-file-keystroke-count, timep)
	(type-break-choose-file, type-break-get-previous-time)
	(type-break-get-previous-count): New defuns.
	(type-break): Avoid break querying after a completed break in the
	case where the query was initiated during user invocation of the
	break.  Optional terse messages.
	Use type-break-good-break-interval if type-break-good-rest-interval is
	nil.  File the break time.
	(type-break-schedule): New optional args for overriding the use of
	the current time.
	(type-break-cancel-time-warning-schedule): Avoid leftover warnings
	after a break.
	(type-break-check): File the keystroke count.
	(type-break-do-query): Prevent a second query when the break is
	interrupted.  Optional terse message.
	(type-break-keystroke-reset): Record the start of a typing interval.
	(type-break-demo-boring): Optional terse messages.  Display word
	per minute and keystroke counts according to
	type-break-demo-boring-stats.

2004-04-27  Daniel M Coffman  <coffmand@us.ibm.com>  (tiny change)

	* arc-mode.el (archive-maybe-copy): If ARCHIVE includes leading
	directories, make sure they exist under archive-tmpdir.

2004-04-27  Juri Linkov  <juri@jurta.org>

	* help.el (view-emacs-news): With argument, display info for the
	selected version by finding it among different NEWS files, and
	narrowing the buffer to the selected version.

	* info.el: Add *info*<[0-9]+> to same-window-regexps instead of
	same-window-buffer-names.
	(info): New arg `buffer'.  Use it.  Doc fix.  Read file name for
	non-numeric prefix argument, append the number to the buffer name
	for numeric prefix argument.
	(info-other-window): Bind same-window-regexps to nil.
	(Info-reference-name): Rename to Info-point-loc.
	(Info-find-node-2): Call forward-line for numeric Info-point-loc,
	and Info-find-index-name for stringy Info-point-loc.
	(Info-extract-menu-node-name): New arg `index-node'.  Use regexp
	without middle `.', but with final `.' and optional line number
	for it.  Set Info-point-loc for index nodes.
	(Info-index): Remove middle `.' from index entry regexp.
	Modify line number regexp.
	(Info-index-next): Decrement line number.
	(info-apropos): Remove middle `.' from index entry regexp.
	Add optional line number regexp at the end.  Add matched value
	for line number to the result list and insert it to the buffer.
	Replace match-string by match-string-no-properties.
	Reorder result list.
	(Info-fontify-node): Hide index line numbers.
	(Info-goto-node): Replace "\\s *\\'" by "\\s +\\'" to not trim
	empty matches.
	(Info-follow-reference): Use `str' instead of
	Info-following-node-name-re.
	(Info-toc): Use full file names.  Set Info-current-node to "Top".
	(Info-fontify-node): Compare file names without directory name.
	(Info-try-follow-nearest-node): Don't set Info-reference-name.
	Set second arg of Info-extract-menu-node-name for index nodes.
	(info-xref-visited): Use magenta3 instead of magenta4.
	(Info-mode): Add info-apropos to docstring.

	* log-view.el (log-view-diff): Replace interactive code "r"
	by a list to allow to call it even if region is not active.

	* paren.el (show-paren-highlight-openparen): New var.
	(show-paren-function): Turn on openparen highlighting when
	matching forward if show-paren-highlight-openparen is non-nil.

	* simple.el (kill-ring-save): Use blink-matching-delay instead of
	the constant value 1.
	(completions-common-part): Expand docstring.

	* textmodes/picture.el (picture-mode-map): Add arrow keys.

2004-04-27  Kim F. Storm  <storm@cua.dk>

	* image.el (insert-sliced-image): Use line-height instead of
	line-spacing property on newline.

2004-04-26  Lars Hansen  <larsh@math.ku.dk>

	* desktop.el (desktop-buffer-misc-data-function): Rename to
	desktop-save-buffer and change docstring.
	(desktop-buffer-modes-to-save): Delete.
	(desktop-save-buffer-p): Use desktop-save-buffer instead of
	desktop-buffer-modes-to-save.
	(desktop-save): Rename desktop-buffer-misc-data-function to
	desktop-save-buffer and allow non-function value.
	(desktop-missing-file-warning): Correct docstring.

	* dired.el (dired-mode): Rename desktop-buffer-misc-data-function
	to desktop-save-buffer.

	* info.el (Info-mode): Rename desktop-buffer-misc-data-function	to
	desktop-save-buffer.

	* mail/rmail.el (rmail-variables): Bind desktop-save-buffer to t.

	* mh-e/mh-e.el (mh-folder-mode): Bind desktop-save-buffer to t.

2004-04-26  Eli Zaretskii  <eliz@gnu.org>

	* progmodes/gud.el (gud-pdb-command-name): Change default to "pydb".

2004-04-25  Luc Teirlinck  <teirllm@auburn.edu>

	* ielm.el (ielm-prompt-read-only, ielm-prompt): Expand docstring.
	(ielm): Only go to the end of the buffer when starting a new process.

2004-04-25  Juanma Barranquero  <lektu@terra.es>

	* ielm.el (inferior-emacs-lisp-mode): Display working buffer on the
	mode line.  Bind `inhibit-read-only' to t before modifying
	properties of text in the buffer.
	(ielm): Force point to the end of buffer, even when running ielm
	from inside itself.

2004-04-25  Jesper Harder  <harder@ifa.au.dk>

	* info.el (info-apropos): Reset Info-complete-cache.

2004-04-25  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-error-regexp-alist-alist):
	Also recognize severe Irix et al. messages.
	(compilation-normalize-filename, compile-abbreviate-directory):
	Delete functions.
	(compilation-get-file-structure): New function inherits
	functionality of the two preceding ones.
	(compilation-internal-error-properties, compilation-fake-loc):
	Use it so that different paths to the same file share the same
	markers.  Also optimize finding adjacent marker slightly.

2004-04-25  Kim F. Storm  <storm@cua.dk>

	* image.el (insert-sliced-image): Add line-spacing t property
	to newlines separating image lines.

2004-04-24  Luc Teirlinck  <teirllm@auburn.edu>

	* comint.el (comint-delete-output): Bind inhibit-read-only to t.

	* ielm.el (ielm-prompt-read-only): New user option.
	(ielm-prompt): Expand docstring to describe new behavior.
	(inferior-emacs-lisp-mode): Implement ielm-prompt-read-only and
	mention it in the docstring.

2004-04-24  Andreas Schwab  <schwab@suse.de>

	* progmodes/sh-script.el (sh-leading-keywords) <sh>: Add "!".

	* diff.el (diff): Set default-directory in diff buffer.

2004-04-24  Eli Zaretskii  <eliz@gnu.org>

	* mail/sendmail.el (mail-bury): Don't delete the frame where the
	mail was being composed if the terminal cannot display more than
	one frame; instead, switch to previous frame.

	* mail/rmail.el (rmail-mail-new-frame): Doc fix.
	(rmail-start-mail): Support rmail-mail-new-frame even on
	terminals that can display only one frame at a time.

2004-04-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/checkdoc.el (checkdoc-output-error-regex-alist): New var.
	(checkdoc-output-font-lock-keywords): Remove error regexp.
	(checkdoc-output-mode-map): Remove.
	(checkdoc-output-mode): Derive from compilation-mode.
	(checkdoc-find-error-mouse, checkdoc-find-error): Remove.

	* dired.el (dired-mode-map): Add a menu entry for wdired.

	* emacs-lisp/rx.el (rx-syntax): Move sregex style syntax to code.
	(rx-bracket, rx-check-any, rx-any): Clean up name space.

	* wdired.el: (wdired-mode-map): Move init into declaration.
	Fix `return' binding.
	(wdired-change-to-wdired-mode, wdired-change-to-dired-mode):
	Use force-mode-line-update.
	(wdired-get-filename): Use `unless'.
	(wdired-preprocess-files): Don't assume names have no \n and use / for
	dir separator.
	(wdired-normalize-filename): Use replace-regexp-in-string.
	(wdired-load-hooks): Remove.
	(wdired-mode-hooks): Rename to wdired-mode-hook.

	* info-look.el: Add support for cfengine-mode.
	(info-lookup-setup-mode): Use dolist.

2004-04-23  Juan Le,As(Bn Lahoz Garc,Am(Ba  <juan-leon.lahoz@tecsidel.es>

	* wdired.el: New file.

2004-04-23  Juanma Barranquero  <lektu@terra.es>

	* ielm.el (inferior-emacs-lisp-mode): Fix docstring.

	* pcomplete.el (pcomplete-opt, pcomplete-actual-arg)
	(pcomplete-match-string, pcomplete-comint-setup, pcomplete-here)
	(pcomplete--help, pcomplete--here): Doc fixes.

2004-04-23  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-default-workfile-unchanged-p): Fix code that
	handles wrong-number-of-arguments in backend call.

	* vc.el (vc-print-log): Likewise.

2004-04-20  Dave Love  <fx@gnu.org>

	* emacs-lisp/rx.el: Doc fixes.
	(rx-constituents): Add/extend many forms.
	(rx-check): Check form is a list.
	(bracket): Defvar.
	(rx-check-any, rx-any, rx-check-not): Modify.
	(rx-not): Simplify.
	(rx-trans-forms, rx-=, rx->=, rx-**, rx-not-char, rx-not-syntax): New.
	(rx-kleene): Use rx-trans-forms.
	(rx-quote-for-set): Delete.
	(rx): Allow multiple args.

2004-04-23  Kenichi Handa  <handa@m17n.org>

	* international/mule-util.el (char-displayable-p): Simplify by
	using internal-char-font.

2004-04-23  Juanma Barranquero  <lektu@terra.es>

	* makefile.w32-in: Add "-*- makefile -*-" mode tag.

2004-04-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* diff-mode.el (diff-next-error): New fun.
	(diff-mode): Use it.

	* simple.el (next-error): Change arg name.
	Add support for the documented C-u C-x ` usage.

	* frame.el (special-display-popup-frame, next-multiframe-window)
	(previous-multiframe-window): Only consider frames on same display.

2004-04-22  Lars Hansen  <larsh@math.ku.dk>

	* info.el (Info-restore-desktop-buffer): Delete with-no-warnings.
	* mh-e/mh-e.el (mh-restore-desktop-buffer): Delete with-no-warnings.

2004-04-22  Kim F. Storm  <storm@cua.dk>

	* net/telnet.el (telnet): Add optional port arg.

2004-04-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/compile.el (compilation-mode-font-lock-keywords):
	Minor sanity check on the `hyperlink' slot.

	* Makefile.in (recompile): Compile new files.

	* emacs-lisp/bytecomp.el (batch-byte-recompile-directory):
	Add byte-recompile-directory's optional `arg'.

	* cvs-status.el (cvs-tree-use-charset): New var.
	(cvs-tree-char-space, cvs-tree-char-hbar, cvs-tree-char-vbar)
	(cvs-tree-char-branch, cvs-tree-char-eob, cvs-tree-char-bob)
	(cvs-status-cvstrees): Use it.

	* emacs-lisp/checkdoc.el (checkdoc-output-mode):
	Make it a normal major mode.
	(checkdoc-buffer-label): Make sure the file name is meaningful.
	(checkdoc-output-to-error-buffer): Remove.
	(checkdoc-error, checkdoc-start-section): Rewrite.

	* info.el (info-node, info-menu-5, info-xref, info-header-node)
	(Info-title-1-face, Info-title-2-face, Info-title-3-face)
	(Info-title-4-face): Use new syntax.
	(info-xref-visited): Inherit from info-xref.

	* progmodes/python.el (python-maybe-jython): Don't assume point-min==1.

2004-04-21  Teodor Zlatanov  <tzz@lifelogs.com>

	* simple.el (next-error-last-buffer, next-error-function):
	New variables for the next-error framework.
	(next-error-buffer-p): New function.
	(next-error-find-buffer): Generalize compilation-find-buffer.
	(next-error, previous-error, first-error, next-error-no-select)
	(previous-error-no-select): Move from compile.el.

	* replace.el (occur-next-error, occur-1): Hook into the next-error
	framework.

	* progmodes/compile.el (compilation-start):
	Set next-error-last-buffer so next-error knows where to jump.
	(compilation-setup): Set the buffer-local variable
	next-error-function to 'compilation-next-error-function.
	(compilation-buffer-p, compilation-buffer-internal-p): Use an
	alternate way to find if a buffer is a compilation buffer, for
	next-error convenience.
	(next-error-no-select, previous-error-no-select, next-error)
	(previous-error, first-error): Move to simple.el.
	(compilation-find-buffer): Move to next-error-find-buffer in simple.el.
	(compilation-last-buffer): Remove.
	(compilation-start, compilation-next-error, compilation-setup)
	(compilation-next-error-function, compilation-find-buffer):
	Remove compilation-last-buffer use.

2004-04-21  Juanma Barranquero  <lektu@terra.es>

	* font-lock.el (font-lock-preprocessor-face): Remove spurious quote.
	(font-lock-warning-face): Fix spacing.

	* makefile.w32-in (WINS): Add url/ directory.

2004-04-21  Lars Hansen  <larsh@math.ku.dk>

	* desktop.el (desktop-buffer-mode-handlers): New variable.
	Alist of major mode specific functions to restore a desktop buffer.
	(desktop-buffer-handlers): Make variable obsolete.
	(desktop-create-buffer): Use desktop-buffer-mode-handlers.
	Catch errors signaled in handlers.  Update buffer count.
	Evaluate desktop-buffer-point.
	(desktop-buffer-dired): Rename to dired-restore-desktop-buffer and
	move to dired.el.
	(desktop-buffer-info): Rename to Info-restore-desktop-buffer and
	move to info.el.
	(desktop-buffer-rmail): Rename to rmail-restore-desktop-buffer and
	move to mail/rmail.el.
	(desktop-buffer-mh): Rename to mh-restore-desktop-buffer and move
	to mh-e/mh-e.el.
	(desktop-buffer-file): Rename to desktop-restore-file-buffer.
	On fail, print message (to message buffer) even if
	desktop-missing-file-warning is nil.
	(desktop-buffer-misc-data-function): New buffer local variable.
	Function returning major mode specific data.
	(desktop-buffer-misc-functions): Make variable obsolete.
	(desktop-save): Use desktop-buffer-misc-data-function.
	(desktop-buffer-dired-misc-data): Rename to
	dired-desktop-buffer-misc-data and move to dired.el.
	(desktop-buffer-info-misc-data): Rename to
	Info-desktop-buffer-misc-data and move to info.el.
	(desktop-read): Add message about number of buffers restored/failed.

	* dired.el (dired-restore-desktop-buffer) Move from desktop.el.
	Add parameters.  Pause to display error only when
	desktop-missing-file-warning is non-nil.
	(dired-desktop-buffer-misc-data): Move from desktop.el.  Add parameter.
	(dired-mode): Bind desktop-buffer-misc-data-function.

	* info.el (Info-restore-desktop-buffer): Move from desktop.el.
	Add Parameters.
	(Info-desktop-buffer-misc-data): Move from desktop.el.  Add parameter.
	(Info-mode): Bind desktop-buffer-misc-data-function.

	* mail/rmail.el (rmail-restore-desktop-buffer): Move from desktop.el.
	Add Parameters.

	* mh-e/mh-e.el (mh-restore-desktop-buffer): Move from desktop.el.
	Add Parameters.

2003-04-21  Paul Pogonyshev  <pogonyshev@gmx.net>

	* dabbrev.el (dabbrev--substitute-expansion): Don't lose
	the case of letters in case-insensitive expansions when the
	abbrev is preceded by characters with letter syntax.

2004-04-21  Richard M. Stallman  <rms@gnu.org>

	* progmodes/cperl-mode.el (cperl-putback-char):
	Delete Emacs 18 definition.

	* international/mule.el (ctext-post-read-conversion):
	Use assoc-string, not assoc-ignore-case.

	* international/mule-cmds.el: Use assoc-string, not assoc-ignore-case.

	* emacs-lisp/easymenu.el (easy-menu-add):
	Do call x-popup-menu, but only if it's defined.

	* emacs-lisp/disass.el (disassemble): Handle lambda-exp as arg.

	* emacs-lisp/bytecomp.el (byte-compile-no-warnings):
	Handle multiple args: compile like progn.

	* emacs-lisp/byte-run.el (with-no-warnings): Simplify:
	take all args as &rest arg.

	* autoinsert.el (auto-insert-alist): Insert the user's name in
	copyright notice, rather than Free Software Foundation.

2004-04-21  Kenichi Handa  <handa@m17n.org>

	* descr-text.el (describe-char): Make it work on *Help* buffer.

2004-04-21  Kim F. Storm  <storm@cua.dk>

	* image.el (insert-image): Add optional SLICE arg.
	(insert-sliced-image): New defun.

2004-04-20  Lawrence Mitchell  <wence@gmx.li>  (tiny change)

	* subr.el (read-number): Check whether `default' is nil.

2004-04-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/compile.el (compilation-error-properties):
	Split into two.
	(compilation-internal-error-properties): New one.
	(compilation-compat-error-properties): Use it.  Fix the non-marker case.

2004-04-20  Richard M. Stallman  <rms@gnu.org>

	* window.el (split-window-save-restore-data):
	Don't update the data if OLD-INFO is nil.

	* view.el (view-return-to-alist): Mark it permanent local.

	* subr.el (event-modifiers): Fix the criterion for ASCII control chars.

	* recentf.el (recentf-save-list): Catch and warn about errors.

	* menu-bar.el (menu-bar-update-buffers): Call copy-sequence
	so "Buffers" won't be pure.

	* help-mode.el (help-mode-finish): Set help-return-alist first
	thing, setting only the entry for the selected window.

	* help-fns.el (describe-function-1): If many non-control non-meta
	keys run the command, don't list all of them.

2004-04-20  Juanma Barranquero  <lektu@terra.es>

	* vc-svn.el (vc-svn-print-log, vc-svn-diff): Add optional BUFFER
	arg.  Copied from Andre Spiegel's patch of 2004-03-21.

	* calendar/time-date.el (time-to-day-in-year): Fix docstring.

2004-04-20  Kenichi Handa  <handa@m17n.org>

	* international/quail.el (quail-lookup-key): New optional arg
	NOT-RESET-INDICES.
	(quail-get-translations): Call quail-lookup-key with
	NOT-RESET-INDICES t.
	(quail-completion): Likewise.
	(quail-lookup-map-and-concat): Likewise.

2004-04-20  Kenichi Handa  <handa@m17n.org>

	* international/quail.el (quail-update-translation): Don't insert
	such an unsupported multibyte char in a unibyte buffer.

2004-04-20  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-frame-parameters): New constant.
	(gdb-frame-breakpoints-buffer, gdb-frame-stack-buffer)
	(gdb-frame-threads-buffer, gdb-frame-registers-buffer)
	(gdb-frame-locals-buffer, gdb-frame-gdb-buffer)
	(gdb-frame-assembler-buffer): Improve behaviour with
	multiple frames.
	(gdb-display-buffer): Extend search to all visible frames.

2004-04-19  Eli Zaretskii  <eliz@gnu.org>

	* mail/rmail.el (rmail-convert-to-babyl-format): Don't remove ^M
	characters left after base64 decoding.
	(rmail-decode-region): Use -dos variety of `coding', to remove any
	^M characters left after qp or base64 decoding.

2004-04-19  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* x-dnd.el (x-dnd-open-local-file, x-dnd-open-file): Improve error
	messages.

2004-04-19  Stephen Eglen  <stephen@gnu.org>

	* add-log.el (add-change-log-entry): Update doc string to mention
	add-log-full-name and add-log-mailing-address.

2004-04-18  Juri Linkov  <juri@jurta.org>

	* info.el (Info-find-file, Info-find-node-2): Add history and toc.
	(Info-find-node-2): Simplify error message.
	(Info-insert-dir): Use Info-following-node-name.
	(Info-goto-node): Remove *info-history* and *info-toc*.
	(Info-history): Create a node of the virtual history file.
	(Info-toc): Create a node of the virtual toc file.
	(Info-insert-toc): New arg `curr-file' for reference file names.
	(info-apropos): Remove redundant var binding for temp-file.
	(Info-index, Info-index-next, Info-mode): Doc fix.
	(Info-goto-emacs-command-node): Don't jump to *info* from
	non-*info* Info buffers.
	(Info-fontify-node): Don't show the file name of external
	references if `Info-hide-note-references' is `hide'.  Don't hide
	newlines at the end of paragraphs.

	* international/mule-diag.el (list-input-methods):
	Fix args to help-xref-button.

	* help-fns.el (help-with-tutorial): Call `hack-local-variables'
	to put into effect local variables from TUTORIAL files.

	* textmodes/paragraphs.el (sentence-end) <function>: New fun
	with default value taken from the variable `sentence-end'.
	(sentence-end) <defcustom>: Set default to nil.  Doc fix.
	Add nil const to :type.
	(sentence-end-without-period, sentence-end-double-space)
	(sentence-end-without-space): Doc fix.

	* textmodes/paragraphs.el (forward-sentence):
	* textmodes/fill.el (canonically-space-region, fill-nobreak-p)
	(fill-delete-newlines):
	* progmodes/cc-cmds.el (c-beginning-of-statement):
	Use function `sentence-end' instead of variable `sentence-end'.

2004-04-18  Andreas Schwab  <schwab@suse.de>

	* progmodes/compile.el (compilation-start): Set window start to
	point-min if compilation-scroll-output is nil.

2004-04-18  John Wiegley  <johnw@newartisans.com>

	* iswitchb.el (iswitchb-completions): Remove dependency on cl.

2004-04-18  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-goto-info): Require 'info.
	(gdb-info-breakpoints-custom): Revert previous change.
	(gdb-view-assembler): Update assembler if necessary.
	(gdb-frame-handler): Parse correctly for gdb-current-frame.
	(gdb-display-source-buffer): Update properly when both source and
	assembler are visible.

2004-04-17  John Wiegley  <johnw@newartisans.com>

	* iswitchb.el (iswitchb-max-to-show): Add a new config variable
	which limits the number of names shown in the minibuffer.  Off by
	default.
	(iswitchb-completions): Use `iswitchb-max-to-show'.  This speeds
	up iswitchb for users with a multitude of open buffers by showing
	only the first and last N/2 buffers in the completion list (which
	is enough to aid C-s/C-r, and to know that more characters are
	needed to refine the completion list).

2004-04-17  Richard M. Stallman  <rms@gnu.org>

	* files.el (locate-file-completion): Handle nil in path-and-suffixes.
	(file-truename): Expand all ~ constructs directly.
	(insert-directory): Delete any error msg output by the
	`insert-directory-program'.

	* allout.el (allout-mode-exposure-menu, allout-mode-editing-menu):
	(allout-mode-navigation-menu, allout-mode-misc-menu): New defvars.
	(allout-prior-bindings, allout-added-bindings): Defvars deleted.
	(allout-init): Use find-file-hook, not find-file-hooks.
	(allout-mode): Eliminate Emacs 18 support.
	Use write-contents-functions, not local-write-file-hooks.

2004-04-17  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-error-properties): Fix for
	adding messages when there are already markers for their file.
	(compilation-fake-loc): New function.

2004-04-16  Dave Love  <fx@gnu.org>

	* progmodes/python.el (python-compilation-line-number): Fix braindamage.
	(python-load-file): Fix python-orig-start setting.

	* progmodes/compile.el: Doc fixes.
	(compilation-error-regexp-alist-alist)
	(compilation-mode-font-lock-keywords): Allow non-ASCII where possible.
	(compilation-assq): Wrap in eval-when-compile.
	(compilation-mode-font-lock-keywords): Don't use list*.
	(compilation-start): Avoid warning.
	(compilation-compat-error-properties)
	(compilation-directory-properties): Add keymap property.
	(compilation-parsing-end): Make it a marker for better compatibility.

	* progmodes/python.el (python-after-info-look): Use with-no-warnings.

2004-04-16  Mark A. Hershberger  <mah@everybody.org>

	* xml.el: Doc fixes.
	(xml-get-children): Only looks at sub-tags and ignore strings.

	* xml.el (xml-parse-tag): Avoid overwriting node-name.

2004-04-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* diff-mode.el (diff-end-of-hunk): Be more careful with unified hunks.

2004-04-16  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-default-workfile-unchanged-p): Quote signal.

	* vc.el (vc-print-log): Likewise.

2004-04-16  Masatake YAMATO  <jet@gyve.org>

	* simple.el (completion-setup-function): Set an initial value
	to `element-common-end' before entering loop.  Set a value
	to `element-common-end' at the end of loop.
	The bug is reported by Juri Linkov <juri@jurta.org> in emacs-devel list.
	(completions-common-part): Rename from completion-de-emphasis.
	(completions-first-difference): Rename from completion-emphasis.
	Suggested by RMS.

2004-04-16  Juanma Barranquero  <lektu@terra.es>

	* bookmark.el (bookmark-send-edited-annotation): Fix docstring.
	(bookmark-edit-annotation-mode): Add mode name.

2004-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* smerge-mode.el (smerge-match-conflict): Try to do something sensible
	for nested conflict markers.
	(smerge-find-conflict): Better handle errors in smerge-match-conflict.

2004-04-15  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-goto-info): New function.

	* progmodes/gud.el (gud-menu-map, gud-tool-bar-map): Add help button.

2004-04-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/bytecomp.el (batch-byte-compile-file):
	Give a backtrace if requested.

	* progmodes/ada-mode.el (ada-create-menu): Remove redundant call.

	* progmodes/python.el (python-mouse-2-command, python-RET-command):
	Remove unused functions.
	(python-orig-start-line, python-orig-file): Remove.
	(python-orig-start): New var.
	(python-input-filter, python-compilation-line-number)
	(python-send-region, python-load-file): Use it.

	* info.el (info): Always jump to *info*.

	* subr.el (posn-set-point): New function.

	* mouse.el (mouse-set-point): Use it.

	* progmodes/compile.el (compile-goto-error): Use it.
	(compilation-button-map): New keymap.
	(compilation-error-properties): Use it.
	(compilation-shell-minor-mode-map): Don't bind mouse-2.

	* smerge-mode.el (smerge-popup-context-menu): Use it.

	* emacs-lisp/checkdoc.el (checkdoc-output-mode-map)
	(checkdoc-find-error-mouse, checkdoc-find-error): Use it to merge the
	mouse and non-mouse case.

	* diff-mode.el (diff-goto-source): Make it work for mouse bindings.
	(diff-mouse-goto-source): Make it an alias of diff-goto-source.

	* pcvs.el (cvs-mode-toggle-mark): Rename from cvs-mouse-toggle-mark.
	Make it work for non-mouse events.

	* pcvs-info.el (cvs-status-map): Update binding name.

2004-04-14  Mark A. Hershberger  <mah@everybody.org>

	* xml.el (xml-maybe-do-ns): New function to handle namespace
	parsing of both attribute and element names.
	(xml-ns-parse-ns-attrs, xml-ns-expand-el, xml-ns-expand-attr)
	(xml-intern-attrlist): Remove in favor of xml-maybe-do-ns.
	(xml-parse-tag): Update assumed namespaces.  Clean up namespace parsing.
	(xml-parse-attlist): Make it do its own namespace parsing.

2004-04-14  Dave Love  <fx@gnu.org>

	* progmodes/python.el (run-python): Fix use of \n.
	(python-load-file): Remove `try' from Python fragment.
	(python-describe-symbol): Fix message.

	* comint.el: Doc fixes.
	(comint-last-input-start, comint-last-input-end)
	(comint-last-output-start): Give them values.
	(comint-arguments): Avoid warning.
	(comint-skip-prompt): Use line-end-position.
	(comint-backward-matching-input): Rename arg to agree with doc.
	(comint-extract-string): Use syntax-ppss.
	(comint-dynamic-simple-complete): Delete useless list construction.
	(comint-redirect-subvert-readonly): New.
	(comint-redirect-preoutput-filter): Use it.

	* emacs-lisp/lisp.el (beginning-of-defun-raw, end-of-defun):
	Correctly handle negative arguments when calling hook functions.

2004-04-14  Jesper Harder  <harder@ifa.au.dk>

	* info.el (info-apropos): Don't clobber Info-history-list.

2004-04-14  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-setup):
	Localize overlay-arrow-position.
	(compilation-sentinel): Restructure code equivalently.
	(compilation-next-error): Find message on same line after point if
	not found before point.
	(compile-mouse-goto-error): Restore function so that compilation
	buffer need not be current and use compile-goto-error.
	(compile-goto-error): Restore function.
	(next-error): Set overlay-arrow-position.
	(compilation-forget-errors): Don't localize already local
	compilation-locs and remove FIXME about refontifying.

2004-04-14  Kim F. Storm  <storm@cua.dk>

	* startup.el (emacs-quick-startup): New defvar (set by -Q).
	(command-line): New option -Q.  Like -q --no-site-file, but
	in addition it also disables menu-bar, tool-bar, scroll-bars,
	tool-tips, and the blinking cursor.
	(command-line-1): Skip startup screen if -Q.
	(fancy-splash-head): Use ":align-to center" prop to center splash image.

	* emulation/cua-base.el (cua-read-only-cursor-color)
	(cua-overwrite-cursor-color, cua-global-mark-cursor-color): Doc fix.

2004-04-13  Dave Love  <fx@gnu.org>

	* progmodes/python.el: Doc fixes.  Changes for compiler warnings.
	(syntax): Don't require.
	(python) <defgroup>: Add :version.
	(python-quote-syntax): Re-written.
	(inferior-python-mode): Move stuff here from run-python and add
	some more.
	(python-preoutput-continuation, python-preoutput-result)
	(python-dotty-syntax-table): New.
	(python-describe-symbol): Use them.
	(run-python): Move stuff to inferior-python-mode.  Modify code
	loaded into Python.
	(python-send-region): Use python-proc, python-send-string.
	(python-send-string): Send newlines too.  Callers changed.
	(python-load-file): Re-written.
	(python-eldoc-function): New.
	(info-look): Don't require.
	(python-after-info-look): New.  A modified version of former
	top-level code for use with eval-after-load.
	(python-maybe-jython, python-guess-indent): Use widened buffer.
	(python-fill-paragraph): Re-written.
	(python-mode): Fix outline-regexp.  Set outline-heading-end-regexp,
	eldoc-print-current-symbol-info-function.  Add to eldoc-mode-hook.

2004-04-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/python.el (run-python): Use compilation-shell-minor-mode.
	Set compilation-error-regexp-alist earlier.

	* progmodes/compile.el (compilation-minor-mode-map)
	(compilation-shell-minor-mode-map, compile-mouse-goto-error)
	(compile-goto-error): Re-merge the mouse and non-mouse commands.

2004-04-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/compile.el (compile-goto-error): Select the buffer/window
	corresponding to the event.

2004-04-12  Joe Buehler  <jbuehler@hekiman.com>

	* loadup.el: Add cygwin to system-type list, for unexec() support.

2004-04-12  John Paul Wallington  <jpw@gnu.org>

	* ibuffer.el (ibuffer-delete-window-on-quit): Remove.
	(ibuffer-restore-window-config-on-quit): New variable to replace
	`ibuffer-delete-window-on-quit'.  Update all references.
	(ibuffer-prev-window-config): New variable.
	(ibuffer-quit): Restore previous window configuration instead of
	deleting window.
	(ibuffer): Save window configuration before showing Ibuffer buffer.

	* help.el (describe-mode): Doc fix.

2004-04-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/compile.el (compilation-mode-font-lock-keywords): Fix test
	not to treat nil as a function.

	* vc-arch.el (vc-arch-root): Be a bit more careful.
	(vc-arch-register): Save the buffer if we modified it.
	(vc-arch-delete-rej-if-obsolete): Save excursion.
	(vc-arch-find-file-hook): Use the simpler after-save-hook.
	(vc-arch-responsible-p, vc-arch-init-version): New functions.

	* net/ldap.el (ldap-search): Use list*.

2004-04-12  Juri Linkov  <juri@jurta.org>

	* info.el (Info-follow-reference): Allow multiline reference name.

2004-04-11  Dave Love  <fx@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-cond): Fix last change.

	* progmodes/python.el: New file.

2004-04-11  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-arg-list): Function removed.
	(vc-default-workfile-unchanged-p): Use condition-case to check for
	backward compatibility.

	* vc.el (vc-print-log): Use condition-case to check for backward
	compatibility.

2004-04-11  Juri Linkov  <juri@jurta.org>

	* dired.el (dired-faces): New defgroup.
	(dired-header, dired-mark, dired-marked, dired-flagged)
	(dired-warning, dired-directory, dired-symlink, dired-ignored):
	New faces.
	(dired-header-face, dired-mark-face, dired-marked-face)
	(dired-flagged-face, dired-warning-face, dired-directory-face)
	(dired-symlink-face, dired-ignored-face): New face variables.
	(dired-font-lock-keywords): Use them instead of font-lock faces.
	Split the rule for dired marks into 3 separate rules: for marks,
	marked file names and flagged file names.

	* help-mode.el (help-make-xrefs): Add a final newline to the
	*Help* buffer.

2004-04-11  John Paul Wallington  <jpw@gnu.org>

	* replace.el (occur-engine): Distinguish between one and several
	matches in the matches per buffer heading.

2004-04-11  Kim F. Storm  <storm@cua.dk>

	* ido.el (ido-confirm-unique-completion): New defcustom.
	(ido-complete): Use it.
	(ido-write-file): Set it to t unconditionally.

2004-04-10  Miles Bader  <miles@gnu.org>

	RCS keyword removal (only non-comment changes are enumerated here):

	* emacs-lisp/bytecomp.el (byte-compile-version): Variable removed.
	(byte-compile-insert-header): Don't use `byte-compile-version'.
	* forms.el (forms-version): Variable removed.
	(forms-mode): Don't use `forms-version'.
	* recentf.el (recentf-version): Variable removed.
	* progmodes/delphi.el (delphi-version): Variable removed.
	* progmodes/ada-mode.el (ada-mode): RCS keyword removed from docstring.

2004-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/easymenu.el (easy-menu-add): Make it work in non-X Emacs.

2004-04-09  Jesper Harder  <harder@ifa.au.dk>

	* info.el (info-apropos): Improve menu item regexp.

2004-04-09  Simon Josefsson  <jas@extundo.com>

	* mail/smtpmail.el: Add comment, based on report by
	kdc@rcn.com (Kevin D. Clark).

2004-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/compile.el (compilation-mode-font-lock-keywords):
	Redo one more thing that I didn't notice Daniel had undone.

2004-04-08  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-source-window): Remove variable.
	(gdb-goto-breakpoint, gdb-display-buffer)
	(gdb-display-source-buffer, gdb-view-source-function)
	(gdb-view-assembler, gdb-setup-windows, gdb-restore-windows)
	(gdb-source-info, gdb-frame-handler): Don't specify a window
	for display.
	(gdb-info-breakpoints-custom): Remove superfluous update of
	assembler buffer.
	(gdb-many-windows): Make settable outside gdb.

2004-04-08  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* calendar/diary-lib.el (diary-mode, fancy-diary-display-mode):
	Derive from fundamental-mode rather than text-mode.

2004-04-08  Juri Linkov  <juri@jurta.org>

	* info.el (Info-history): Doc fix.
	(Info-history-list): New var.
	(info-xref): Change magenta4 to blue, remove bold for dark and
	light backgrounds, change bold to underline for non-color classes.
	(info-xref-visited): New face.
	(Info-fontify-visited-nodes): New custom.
	(Info-hide-note-references): Add new value `hide'.  Doc fix.
	(Info-reference-name): New var.
	(Info-selection-hook): New custom.
	(Info-edit-mode-hook): New var.
	(Info-find-file): New fun.
	(Info-find-node): Move part of code to Info-find-file.
	(Info-find-node-2): Add anchors to Info-history-list.  Move point
	to the place with the reference name if name is defined.
	(Info-select-node): Add current node to Info-history-list.
	(Info-goto-node): Switch to *info* from *info-history* *info-toc*.
	(Info-search-whitespace-regexp): New custom.
	(Info-search-case-fold): New var.
	(Info-search): Add "case-sensitively" to the prompt.
	Use Info-search-whitespace-regexp.  Set Info-search-case-fold.
	(Info-search-case-sensitively, Info-search-next): New fun.
	(Info-up): Move point to the menu item of the current node.
	(Info-history): New fun.  Add *info-history* to
	same-window-buffer-names.
	(Info-toc): New fun.  Add *info-toc* to same-window-buffer-names.
	(Info-insert-toc): New fun.
	(Info-build-toc): New fun.
	(Info-follow-reference): Add new arg `fork'.  Doc fix.
	Replace [ \n\t]* by [ \n\t]+ in the *Note regexp.  For references
	with the same name prefer the reference closest to point.
	(Info-next-reference): Replace * by + in the *Note regexp.
	Add regexp for http:// and ftp://.  Skip the *Note prefix.
	(Info-prev-reference): Replace * by + in the *Note regexp.
	Add regexp for http:// and ftp://.  Skip the *Note prefix.
	(Info-follow-nearest-node): Add new arg `fork'.
	(Info-try-follow-nearest-node): Add new arg `fork'.
	Call browse-url for http:// and ftp:// references.
	Set Info-reference-name for index entries.
	(Info-mode-menu): Add menu items for Info-search-case-sensitively,
	Info-search-next, Info-history, Info-toc, clone-buffer.
	(Info-menu-update): Replace * by + in the *Note regexp.
	(Info-mode): Add documentation for Info-history, Info-toc,
	Info-search-case-sensitively, Info-search-next, clone-buffer.
	(Info-fontify-menu-headers): Remove fun.  Move code to
	Info-fontify-node.
	(Info-fontify-node): Add docstring.  Add local vars
	fontify-visited-p and not-fontified-p.  If not-fontified-p is t
	then fontify header line, titles, menu headers, http and ftp
	references, refill paragraphs.  If not-fontified-p is t or
	fontify-visited-p is t then fontify cross references, menu items.
	Fontify menu headers.  Fontify http and ftp references.
	Change regexp for cross references to require whitespace after *Note,
	add matching groups for file and node names.  Remove hack for quote.
	Use display property for Info-hide-note-references=t.  Use fifth
	or fourth match for help-echo.  Display visited nodes in a
	different face.  Unhide file names of external references.
	Unhide newlines.  Display visited menu items in a different face.

2004-04-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/compile.el: Require CL.
	(compilation-mode-font-lock-keywords): Re-install the "line as
	function" patch.

	* help-fns.el (help-C-source-directory): New var.
	(help-subr-name, help-C-file-name, help-find-C-source): New funs.
	(describe-function-1, describe-variable): Use them.

	* help-mode.el (help-function-def, help-variable-def): Handle hyperrefs
	to C source files specially.

2004-04-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	* info.el (Info-hide-cookies-node): New function.
	(Info-select-node): Use it.
	(Info-display-images-node): Remove message with image file name.

2004-04-07  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compilation-warning-face)
	(compilation-info-face, compilation-skip-threshold)
	(compilation-skip-visited, compilation-context-lines):
	Declare :version when added to Emacs.
	(compilation-error-regexp-alist-alist): Extend caml and irix.
	(compilation-setup): Fix if font-locked w/o font-lock-defaults.
	(compilation-mode-font-lock-keywords): Temporarily undo line as
	function patch, which wasn't ready.

2004-04-07  Kenichi Handa  <handa@m17n.org>

	* international/latin1-disp.el (latin1-display-setup): Check each
	character is displayable or not instead of calling
	latin1-display-check-font.

2004-04-06  Kenichi Handa  <handa@m17n.org>

	* language/ethio-util.el (ethio-sera-being-called-by-w3):
	New variable.
	(ethio-sera-to-fidel-ethio): Check ethio-sera-being-called-by-w3
	instead of sera-being-called-by-w3.
	(ethio-fidel-to-sera-buffer): Likewise.
	(ethio-find-file): Bind ethio-sera-being-called-by-w3 to t
	instead of sera-being-called-by-w3.
	(ethio-write-file): Likewise.

2004-04-05  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: Doc fix.

2004-04-05  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-use-inferior-io-buffer): New option.
	(gdb-ann3, gdb-send, gdb-starting, gdb-stopping)
	(gdb-setup-windows): Only use separate IO buffer if required.

2004-04-06  Kim F. Storm  <storm@cua.dk>

	* term.el (term-is-xemacs): Remove.
	(term-if-xemacs, term-ifnot-xemacs): Test (featurep 'xemacs).
	(term-window-width): New function.
	(term-mode, term-check-size): Use it.
	(term-mode): Disable overflow-newline-into-fringe in term buffer.

2004-04-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cus-edit.el (custom-add-parent-links): Change unbound variable
	`symbol' to `name'.

2004-04-05  Jesper Harder  <harder@ifa.au.dk>
	* info.el (info-apropos): New function.
	(Info-mode-menu): Add it.
	(Info-find-node, Info-find-node-2): Grok apropos virtual file.

	* help-mode.el (help-make-xrefs): Recognize aliased variable with
	inherited docstring.

	* play/gamegrid.el (gamegrid-add-score-insecure): Use sort-fields.

2004-04-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textmodes/fill.el (fill-comment-paragraph): Obey indent-tabs-mode.

	* progmodes/compile.el (font-lock): Don't require any more.
	(compilation-error-properties, compilation-start, compilation-sentinel)
	(compilation-filter, next-error): Use with-current-buffer.
	(compilation-skip-to-next-location, compilation-skip-threshold)
	(compilation-skip-visited): Move to silence the byte-compiler.
	(compilation-setup): Simplify.
	(compilation-next-error): Use line-(beginning|end)-position.
	Make sure `pt' is non-nil before using compilation-loop.
	(compile-goto-error): Add optional event arg.  Use it.
	(compile-mouse-goto-error): Make it an alias of compile-goto-error.
	(compilation-minor-mode-map, compilation-shell-minor-mode-map):
	Update the binding for mouse-2.
	(first-error): Set compilation-current-error to nil rather than bob.
	(compilation-parsing-end, compilation-parse-errors-function)
	(compilation-error-list, compilation-old-error-list):
	"New" compatibility variables.
	(compile-buffer-substring, compilation-compat-error-properties)
	(compilation-compat-parse-errors, compilation-forget-errors):
	New compatibility functions.
	(compilation-mode-font-lock-keywords): Use them.

2004-04-04  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el (auto-revert-handler): If point (or a window
	point) is at the end of the buffer, keep it there after
	reverting.  This allows to tail a file.
	Mention this in the `Commentary'.

	* format.el (format-write-file): Add optional argument CONFIRM
	and make it behave like the analogous argument to `write-file'.

2004-04-04  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* progmodes/ebnf2ps.el: Doc fix.
	(ebnf-version): New version number (4.2).
	(ebnf-syntax): Customization and docstring fix.
	(ebnf-eliminate-empty-rules, ebnf-optimize, ebnf-otz-initialize):
	Put autoloaded funs before first use.
	(ebnf-style-database): Add dtd entry.
	(ebnf-syntax-alist): Add dtd initialization.
	(ebnf-token-sequence): New fun.
	(ebnf-comment-table): Add new comment action character.
	(ebnf-dtd-parser, ebnf-dtd-initialize): Autoload funs from ebnf-dtd.

	* progmodes/ebnf-dtd.el: New file, implement a parser for DTD (Data
	Type Definition for XML).

	* progmodes/ebnf-abn.el (ebnf-abn-concatenation):
	* progmodes/ebnf-bnf.el (ebnf-sequence):
	* progmodes/ebnf-ebx.el (ebnf-ebx-concatenation):
	* progmodes/ebnf-iso.el (ebnf-iso-single-definition):
	* progmodes/ebnf-yac.el (ebnf-yac-sequence):
	Code simplification: call ebnf-token-sequence.

2004-04-04  Eli Zaretskii  <eliz@gnu.org>

	* calendar/timeclock.el (timeclock-relative)
	(timeclock-get-project-function, timeclock-get-workday-function)
	(timeclock-query-out, timeclock-when-to-leave)
	(timeclock-when-to-leave-string, timeclock-log-data)
	(timeclock-generate-report, timeclock-in): Doc fixes.

2004-04-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* url/: New dir.  Import the URL package from its repository.

2004-04-03  Andreas Schwab  <schwab@suse.de>

	* diff-mode.el (diff-mode): Fix missing quote.

2004-04-03  Juri Linkov  <juri@jurta.org>

	* descr-text.el (describe-property-list): Add `font-lock-face'.

	* dired.el (dired-font-lock-keywords): Fix permission regexps.

2004-04-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* x-dnd.el (x-dnd-handle-moz-url, x-dnd-insert-utf16-text):
	Use utf-16le on little endian machines and utf-16be otherwise.

2004-04-02  David Kastrup  <dak@gnu.org>

	* net/browse-url.el (browse-url-generic): Use call-process
	instead of start-process to allow browsers that fork and detach.

2004-04-01  Daniel Pfeiffer  <occitan@esperanto.org>

	* compile.el (compilation-current-error): New var.
	(compilation-setup, compile-mouse-goto-error)
	(compile-goto-error, next-error): Use it.
	(compilation-skip-to-next-location): Default to t, which gives
	contiguous skipping like old compile (where this was redundant).
	(compilation-next-error): Prevent previous-* commands from moving
	back to message at or just before point.

2004-04-01  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-view-source-function, gdb-view-assembler)
	(gdb-source-info): Don't display source at startup, if required.
	(gdb-show-main): New option.
	(gdba): Update documentation.
	(gdb-source): Cover case of auto-display output.

2004-03-31  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el: Delete obsolete autoload's and defvar's.
	(auto-revert-check-vc-info): New user option.
	(auto-revert-vc-cvs-file-version, auto-revert-vc-buffer-p)
	(auto-revert-handler-vc): Delete.
	(auto-revert-handler): Treat return value `fast' of
	buffer-stale-function specially.  Check `auto-revert-check-vc-info'.

	* buff-menu.el (Buffer-menu-mode): Make the buffer-stale-function
	return `fast'.

	* files.el (buffer-stale-function): Doc change.

2004-03-31  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: New tip on Tips section.
	(pr-version): New version number (6.7.4).
	(pr-shell-file-name): Initialization fix.

2004-03-31  Juri Linkov  <juri@jurta.org>

	* dired.el: Add autoload for `dired-do-touch'.
	(dired-touch-program): New var.
	(dired-mode-map): Bind `dired-do-touch' to T and add menu-item.
	(dired-no-confirm): Add `touch' to docstring.

	* dired-aux.el (dired-do-touch): New fun.
	(dired-do-chxxx): Add argument -t for touch operation.

	* dired-x.el (dired-mark-sexp): Replace hard-coded month names by
	`dired-move-to-filename-regexp'.

2004-03-31  H,Ae(Bkan Granath  <hakan.granath@kau.se>  (tiny change)

	* dired.el (dired-move-to-filename-regexp): Add `.' to HH:MM.

2004-03-30  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* progmodes/ebnf2ps.el (ebnf-eps-finish-and-write): Write a buffer if
	and only if the buffer was modified.

2004-03-30  Kenichi Handa  <handa@m17n.org>

	* international/characters.el: Delete pairs for U+2308..U+230B.

2004-03-29  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gud.el (gud-gdb-marker-filter): Include "\n" in regexp
	to detect the beginning of a level 2 or 3 annotation.

2004-03-29  Kenichi Handa  <handa@m17n.org>

	* international/ucs-tables.el (ucs-insert): Fix the error message.

2004-03-29  Kenichi Handa  <handa@m17n.org>

	* international/mule-util.el (char-displayable-p): Fix generation
	of XLFD file name.

	* Makefile.in (setwins, setwins_almost): Change directory to $wd
	before finding directories by `find'.

2004-03-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (interactive-form): Delete.  Now implemented in C.

	* pcvs.el (cvs-parse-process): Workaround for Darwin.

	* vc.el (vc-version-diff, vc-default-diff-tree): Change `rel' -> `rev'.
	(vc-diff-label): New fun.
	(vc-diff-internal): Use it.

	* progmodes/gdb-ui.el (gdb-post-prompt): Fix test.

2004-03-28  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* progmodes/ebnf-abn.el (ebnf-abn-parser): Handle initial comments.

	* progmodes/ebnf-ebx.el: New file, implement a parser for EBNF used to
	specify XML (EBNFX).

	* progmodes/ebnf2ps.el: Doc fix.
	(ebnf-version): New version number (4.1).
	(ebnf-syntax): Adjust customization.
	(ebnf-style-database): Add ebnfx entry.
	(ebnf-syntax-alist): Add ebnfx initialization.
	(ebnf-ebx-parser, ebnf-ebx-initialize): Autoload funs from ebnf-ebx.

	* printing.el: Doc fix.
	(pr-version): New version number (6.7.3).
	(pr-menu-position): Adjust X and Y positions when mouse-pixel-position
	returns nil for mouse position.  Reported by Drew Adams
	<drew.adams@oracle.com>.
	(pr-update-menus): Modify interactive declaration.  Reported by Drew
	Adams <drew.adams@oracle.com>.

2004-03-28  Nick Roberts  <nick@nick.uklinux.net>

	* progmodes/gdb-ui.el (gdb-ann3, gdb-send-item)
	(gud-gdba-marker-filter): Log the process input and output, if
	required.  From Stefan Monnier.
	(gdb-debug-log, gdb-enable-debug-log): New variables.
	(gdb-post-prompt): Don't do gdb-var-update on Mac OS X.

2004-03-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-hooks.el (vc-file-not-found-hook): Fix typo.
	From lorentey@elte.hu (L$,1 q(Brentey K,Aa(Broly).

2004-03-27  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el (auto-revert-handler): Handle auto-revert-mode.
	Call vc-find-file-hook here instead of in auto-revert-buffers.
	(auto-revert-buffers): Delete call to vc-find-file-hook.
	(auto-revert-verbose, global-auto-revert-non-file-buffers)
	(global-auto-revert-mode, auto-revert-set-timer)
	(auto-revert-handler, auto-revert-buffers): Doc fixes.

2004-03-27  Francis J. Wright  <F.J.Wright@qmul.ac.uk>

	* woman.el (woman-change-fonts): Rename local variable
	woman-font-alist to font-alist to avoid a compiler warning.

2004-03-27  Dave Love  <fx@gnu.org>

	* emacs-lisp/rx.el (rx): Doc fix.
	Fix copyright years.

	* strokes.el (strokes-global-set-stroke-string): New function.
	(strokes-list-strokes): Cope with strings, not just commands.
	Set foreground colour of image.
	(strokes-global-set-stroke): Doc fix.

2004-03-26  Luc Teirlinck  <teirllm@auburn.edu>

	* buff-menu.el (Buffer-menu-revert-function): Make it suitable for
	Auto Revert mode.
	(Buffer-menu-files-only): New variable.
	(Buffer-menu-toggle-files-only): New function.
	(Buffer-menu-mode-map): Bind it to `T'.
	(Buffer-menu-mode): Mention `T' in docstring.
	Set buffer-stale-function.
	(list-buffers-noselect): Mark buffer non-modified and set
	Buffer-menu-files-only.

	* dired.el (buffer-stale-function): Remove no longer needed defvar.

	* autorevert.el (auto-revert-handler): Print revert message
	before, rather than after, reverting.
	(buffer-stale-function): Move to files.el.

	* files.el (buffer-stale-function): Move here from autorevert.el.

2004-03-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc.el (vc-maybe-resolve-conflicts): Don't prompt the user.

	* calc/calc.el (calc-mode-map): Use mapc.

	* apropos.el (apropos-mode): Don't autoload.
	(apropos-symbols-internal): New fun.  Extracted from `apropos'.
	(apropos): Use it.
	(apropos-print): Add optional `text' argument.
	(apropos-describe-plist): Use help-buffer and hexlp-setup-xref.
	Don't assume point-min == 1.

	* bs.el (bs-buffer-list): Use buffer-local-value.
	(bs--set-toggle-to-show): Use with-current-buffer.

	* buff-menu.el (Buffer-menu-sort, Buffer-menu-make-sort-button):
	New funs.
	(list-buffers-noselect): Use them.  Adjust :align-to to new style.

	* cvs-status.el (cvs-tree-use-jisx0208): Use char-displayable-p.

	* dabbrev.el (dabbrev-expand): Fix regexp construction.
	(dabbrev--find-expansion): Use pop.
	(dabbrev--search): Use match-string-no-properties.

	* dired.el (dired-mode): Use run-mode-hooks.
	(dired-move-to-end-of-filename): Use match-string.

	* ediff-init.el (ediff-hide-face): Check that facemenu-unlisted-faces
	is bound before using it.
	(ediff-verbose-p): Make it into a var since it's not constant.

	* electric.el (Electric-pop-up-window): Avoid popping up a new frame.

	* faces.el (read-face-font): Don't cons up unnecessarily.
	(header-line, tool-bar): Share common parts.

	* files.el (file-relative-name): Use compare-strings.

	* finder.el (finder-mode): Follow coding convention.

	* subr.el (read-number): New function.

	* ses.el (ses-read-number): Move to subr.el.
	(ses-set-header-row): Use read-number.

2004-03-26  Andre Spiegel  <spiegel@gnu.org>

	* vc-hooks.el (vc-arg-list): New function, which handles both
	compiled and uncompiled code.
	(vc-default-workfile-unchanged-p): Use it.

	* vc.el (vc-print-log): Undo prev change, use new function
	vc-arg-list from vc-hooks.el.

2004-03-26  Masatake YAMATO  <jet@gyve.org>

	* simple.el (completion-setup-function): Emphasize the
	first uncommon characters in the completions; and de-emphasize
	the common prefix substrings.
	(completion-emphasis): New face.
	(completion-de-emphasis): New face.

2004-03-25  Juanma Barranquero  <lektu@terra.es>

	* progmodes/cperl-mode.el (cperl-indent-alist, cperl-where-am-i):
	Comment out (it's unused and unfinished code).

2004-03-25  Sam Steingold  <sds@gnu.org>

	* vc.el (vc-print-log): Fix a bug in the last patch:
	backend-function may be a byte-compiled object, not a lambda.

2004-03-25  Juri Linkov  <juri@jurta.org>

	* descr-text.el (describe-property-list): Add a button
	for `face' property that calls `describe-face'.
	Suggested by luis fernandes <elf@ee.ryerson.ca>

	* international/mule.el (keyboard-coding-system):
	* kmacro.el (kmacro-call-macro): Fix docstring.

	* dired.el: Fix comments.

	* textmodes/fill.el (fill): Fix Info link.

	* font-lock.el (fast-lock, lazy-lock):
	* jit-lock.el (jit-lock): Remove links to removed Support Modes
	Info node.

	* eshell/eshell.el (eshell): Fix broken info-link.

	* eshell/em-alias.el (eshell-alias, eshell-bad-command-tolerance):
	* eshell/em-banner.el (eshell-banner):
	* eshell/em-smart.el (eshell-smart):
	* eshell/esh-cmd.el (eshell-cmd):
	Comment out broken info-links to incomplete Info manual.

	* info-xref.el: Fix commentary.

2004-03-25  Kevin Ryde  <user42@zip.com.au>

	* info-xref.el (info-xref-check-buffer): Report empty filename parts.
	Remove spurious node duplicate suppression, doesn't work, not wanted.
	(info-xref-output): Take format style args, add "sit-for 0" to let
	user see the results as they progress.
	(info-xref-check-all-custom): New function.

2004-03-25  Nick Roberts  <nick@nick.uklinux.net>

	* gdb-ui.el: Moved to progmodes.

2004-03-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* diff-mode.el (diff-font-lock-keywords): Disable yank-handler.

2004-03-24  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* calendar/appt.el (appt-check): Remove superfluous progn.
	When finished with diary buffer: if it was not being displayed
	before, kill it; otherwise restore its original state.
	Suggested by Matthew Mundell <matt@mundell.ukfsn.org>.

	* calendar/calendar.el (calendar-set-mode-line): Use total
	available mode-line width, rather than frame-width.

	* calendar/diary-lib.el (fancy-diary-display): Set mode-line
	after mode change so effect not lost.

2004-03-23  Dave Love  <fx@gnu.org>

	* dired.el (dired) <defgroup>: Add link to manual.
	(dired-font-lock-keywords): Add highlighting on unusual permissions.
	(dired-revert): Use dolist.
	(dired-mode-map): Add U binding.
	(dired-mode): Add font-lock-beginning-of-syntax-function.
	(dired-garbage-files-regexp): Make it a defcustom.

2004-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-arch.el (vc-arch-diff): Handle the special case where `newvers'
	is equivalent to nil.
	(vc-arch-diff3-rej-p): Be a bit more flexible in what we accept.
	(vc-arch-mode-line-string): Accept `added' state.
	(vc-arch-state): Use inode-sigs if available.
	(vc-arch-add-tagline): Rename from vc-arch-add-tag.
	Copy&delete existing id file if any.  Fallback if uuidgen is absent.
	(vc-arch-tagline-re): New var.
	(vc-arch-file-source-p, vc-arch-file-id, vc-arch-tagging-method):
	New functions.
	(vc-arch-find-file-not-found-hook, vc-arch-register): New backend ops.
	(vc-arch-registered): Try our best guess using vc-arch-file-source-p.

	* vc-hooks.el (vc-default-find-file-not-found-hook): New fun.
	(vc-file-not-found-hook): Use it.

	* diff-mode.el (diff-default-read-only): Change default.
	(diff-mode-hook): Make it a defcustom.  Add some options.
	(diff-mode-map): Bind diff-refine-hook.
	(diff-yank-handler): New var.
	(diff-yank-function): New fun.
	(diff-font-lock-keywords): Use them.
	(diff-end-of-file): Handle case where file-header looks like diff text.
	(diff-hunk-kill): Adjust to "new" hunk-next behavior.
	(diff-file-kill): Delete a subsequent empty line, if applicable.
	(diff-hunk-file-names): New fun, extracted from diff-tell-file-name.
	(diff-find-file-name): Use it.
	(diff-tell-file-name): New command.
	(diff-mode): Be careful with view-mode.
	(diff-delete-if-empty, diff-delete-empty-files, diff-make-unified):
	New functions, for use in diff-mode-hook.
	(diff-find-source-location): Catch "regex too large" errors.
	(diff-apply-hunk, diff-test-hunk): Go to old or new file.
	(diff-refine-hunk): New command.

	* smerge-mode.el (smerge-mode-menu): Fix activate pred for resolve.
	(smerge-context-menu-map): Remove unused var.
	(smerge-keep-all): Preserve markers.
	(smerge-keep-n): New fun.
	(smerge-keep-base, smerge-keep-other, smerge-keep-mine)
	(smerge-keep-current, smerge-ediff): Use it.
	(smerge-kill-current): Use it.  Make it work on some 3-part conflicts.
	(smerge-popup-context-menu): Also use context-menu on 3-part conflicts.
	(smerge-resolve): Resolve trivial 3-part conflicts.

2004-03-23  Juri Linkov  <juri@jurta.org>

	* man.el (Man-width): New var.
	(Man-getpage-in-background): Use it.
	(Man-support-local-filenames): New var and fun.
	(Man-build-man-command): Don't add a second %s.
	(Man-fontify-manpage): Clean up message.
	(Man-mode): Set outline-regexp, outline-level,
	imenu-generic-expression.

	* woman.el (woman-fill-frame): Doc fix.
	(woman-decode-region): Use window-width instead of frame-width.

	* abbrevlist.el (list-one-abbrev-table):
	* descr-text.el (describe-char):
	* international/mule-diag.el (describe-current-coding-system):
	* international/quail.el (quail-insert-decode-map):
	Use window-width instead of frame-width.

	* jka-compr.el (jka-compr-compression-info-list): Add tbz and dz.
	(jka-compr-mode-alist-additions): Add tbz.
	(jka-compr-write-region, jka-compr-insert-file-contents):
	Add message for undefined compress-program.
	(jka-compr-write-region): Remove redundant var bindings.

	* dired-x.el (dired-guess-shell-alist-default): Add choices for
	extracting files into subdirectory.  Add tbz and dz.  Fix regexps.
	Add extensions .[0-9] for man and nroff, and .pod for perldoc.
	(dired-man): Use dired-guess-shell-command.
	(dired-guess-shell-case-fold-search): Change defvar to defcustom.
	Change default nil to t.

	* dired-aux.el (dired-compress-file-suffixes): Add dz and tbz.
	(dired-compare-directories): Add default value for empty input.

	* help-at-pt.el: Move suggestions for key bindings to Commentary.

	* time.el (display-time-string-forms): Fix help-echo date format.

2004-03-22  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el (global-auto-revert-non-file-buffers): Expand docstring.
	(buffer-stale-function): New variable.
	(auto-revert-list-diff, auto-revert-dired-file-list)
	(auto-revert-dired-changed-p, auto-revert-buffer-p): Delete.
	(auto-revert-handler): Take over some functionality of deleted
	functions.
	(auto-revert-buffers): Delete call to auto-revert-buffer-p.

	* dired.el (dired-directory-changed-p): New fun, extracted from
	dired-internal-noselect.
	(dired-buffer-stale-p): New fun.
	(dired-internal-noselect): Use dired-directory-changed-p.
	Eliminate revert messages.
	(dired-mode): Set buffer-stale-function to dired-buffer-stale-p.

2004-03-23  Kenichi Handa  <handa@m17n.org>

	* international/characters.el: Setup syntaxes for more parentheses
	Unicode characters.

	* international/mule-cmds.el (select-safe-coding-system):
	Merge coding-system and auto-cs before comparing them.

2004-03-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pp.el (pp-eval-expression): Simplify.

	* emacs-lisp/lisp-mode.el (lisp-mode-variables): Don't set
	normal-auto-fill-function and comment-indent-function.
	The default values now work just as well.
	Don't set font-lock-beginning-of-syntax-function since we already set
	syntax-begin-function.
	(lisp-outline-level): Put ;;;###autoload at same level as (.
	(prin1-char): Quote special chars.

	* emacs-lisp/lisp-mnt.el (lm-keywords-finder-p): Use defvar rather
	than with-no-warnings.

	* emacs-lisp/edebug.el (edebug-display): Bring up a debug trace
	if the source location can't be found.
	(edebug-compute-previous-result): Use prin1-char.

	* emacs-lisp/checkdoc.el (checkdoc-error): Don't assume point-min == 1.
	(debug-ignored-errors): Add an entry.

	* emacs-lisp/bytecomp.el (byte-recompile-directory): Ignore hidden dir.
	(byte-compile-file): Output warning when deleting a file.

	* emacs-lisp/byte-run.el (defsubst): Add edebug spec and use backquote.
	(dont-compile, eval-when-compile, eval-and-compile): Add edebug spec.

	* emacs-lisp/byte-opt.el (byte-compile-log-lap)
	(byte-compile-inline-expand): Use backquote.
	(byte-optimize-pure-func): Rename from byte-optimize-concat.
	(symbol-name, regexp-opt, regexp-quote): Mark as pure.

	* emacs-lisp/backquote.el (backquote-list*-macro): Use nreverse.

	* emacs-lisp/advice.el (ad-subr-arglist): Simplify.

2004-03-22  Juri Linkov  <juri@jurta.org>

	* finder.el (finder-known-keywords): Fix data, tex, unix.

	* play/landmark.el: Fix keywords.

	* language/ethio-util.el (ethio-find-file): Doc fix.

	* emacs-lisp/warnings.el: Doc fix.

	* textmodes/ispell.el (ispell-help): Doc fix.

2004-03-21  Luc Teirlinck  <teirllm@auburn.edu>

	* format.el (format-insert-file): Always return a list of two
	elements, like insert-file-contents does.

2004-03-21  Andre Spiegel  <spiegel@gnu.org>

	* vc.el: Add new optional BUFFER argument to vc-BACKEND-print-log
	and vc-BACKEND-diff.
	(vc-print-log): If the print-log implementation supports it, use
	the new BUFFER argument to direct output to *vc-change-log*, not *vc*.
	(vc-version-diff, vc-diff-internal): Doc fixes.

	* vc-hooks.el (vc-default-workfile-unchanged-p): If the
	implementation supports it, let diff output go to *vc*,
	not *vc-diff*, since this is an internal call.

	* vc-cvs.el (vc-cvs-print-log, vc-cvs-diff): Add optional BUFFER arg.

	* vc-rcs.el (vc-rcs-print-log, vc-rcs-diff): Likewise.

	* vc-sccs.el (vc-sccs-print-log, vc-sccs-diff): Likewise.

2004-03-21  Dave Love  <fx@gnu.org>

	* progmodes/cfengine.el (cfengine-mode):
	Set parse-sexp-ignore-comments.

	* emacs-lisp/rx.el (rx): Work at compile time, not run time.

2004-03-21  Juanma Barranquero  <lektu@terra.es>

	* allout.el (allout-mode): Fix docstring.

2004-03-20  Luc Teirlinck  <teirllm@auburn.edu>

	* files.el (insert-directory): Fix bug if SWITCHES is a list.

	* autorevert.el (auto-revert-interval): Make new value take
	effect immediately when set through Custom.
	(auto-revert-set-timer): Add interactive declaration.

2004-03-19  David Ponce  <david@dponce.com>

	* ruler-mode.el (ruler-mode-header-line-format-old):
	Don't `make-variable-buffer-local'.
	(ruler-mode-ruler-function): Default to `ruler-mode-ruler'.
	(ruler-mode-header-line-format): Simply funcall the above.
	(ruler-mode): Use `make-local-variable' and `kill-local-variable'
	to save/restore a previous header line format.
	(ruler-mode-space): Don't depend on a numeric WIDTH value.
	(ruler-mode-ruler): Use symbolic display elements for scrollbar,
	fringes and margins width.
	(ruler-mode-ruler-function): Default to ruler-mode-ruler.

2004-03-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* log-edit.el (log-edit-font-lock-keywords): Typo.

	* textmodes/tex-mode.el (tex-shell): Set error parsing function here.
	(tex-send-tex-command): Rather than here.
	(tex-compilation-parse-errors): Simplify.

	* info.el (Info-default-dirs): Don't ignore last part of I-d-d-l.

	* time.el (display-time-string-forms): Add help-echo with date on time.

	* composite.el (compose-region): Use restore-buffer-modified-p.

	* disp-table.el (standard-display-8bit): Simplify.

	* server.el (server-process-filter): Delete temp frame.

	* add-log.el (add-change-log-entry): Simplify.

2004-03-19  Kim F. Storm  <storm@cua.dk>

	* hexl.el (hexl-mode-ruler): Adapt to new :align-to semantics.
	(hexl-follow-line): Don't require 'fringe.

	* progmodes/compile.el (compilation-start): Always set
	compilation-last-buffer and return it.

2004-03-17  Luc Teirlinck  <teirllm@auburn.edu>

	* simple.el (clone-buffer): Doc fix.

2004-03-18  Juanma Barranquero  <lektu@terra.es>

	* emacs-lisp/byte-run.el (make-obsolete-variable): Fix docstring.

2004-03-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* log-edit.el (log-edit-font-lock-keywords): New var.
	(log-edit-mode): Use it.

2004-03-17  Nick Roberts  <nick@nick.uklinux.net>

	* gdb-ui.el (gdb-var-list-children-handler): Handle C++ classes
	properly for watching in speedbar.

2004-03-17  Masatake YAMATO  <jet@gyve.org>

	* smerge-mode.el (smerge-popup-context-menu):
	Put `unwind-protect' around `overlay-put' and `popup-menu'.

2004-03-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-arch.el (vc-arch-workfile-unchanged-p): Define to avoid dup-diff.
	(vc-arch-workfile-version, vc-arch-mode-line-rewrite):
	Take sealed revisions into account.
	(vc-arch-checkin): Extract a summary line from the message.

2004-03-16  Masatake YAMATO  <jet@gyve.org>

	* register.el (register): Provide `register' feature.

2004-03-15  Masatake YAMATO  <jet@gyve.org>

	Added context menu support in smerge mode.
	Most of the part is written by Stefan Monnier.

	* smerge-mode.el (smerge-context-menu-map, smerge-context-menu):
	New keymap and menu.
	(smerge-text-properties): New function.
	(smerge-remove-props): New function.
	(smerge-popup-context-menu): New function.
	(smerge-resolve): Call `smerge-remove-props'.
	(smerge-keep-base, smerge-keep-other, smerge-keep-mine): Ditto.
	(smerge-keep-current): Ditto.
	(smerge-kill-current): New function.
	(smerge-match-conflict): Put text properties.
	Detect the file as `same-diff conflict' if the filename is "ANCESTOR".

2004-03-15  David Ponce  <david@dponce.com>

	* ruler-mode.el: (ruler-mode-left-fringe-cols)
	(ruler-mode-right-fringe-cols, ruler-mode-left-scroll-bar-cols)
	(ruler-mode-right-scroll-bar-cols): Remove.
	(ruler-mode-window-col, ruler-mode-mouse-set-left-margin)
	(ruler-mode-mouse-set-right-margin, ruler-mode-ruler):
	Use fringe-columns and scroll-bar-columns.

2004-03-15  Masatake YAMATO  <jet@gyve.org>

	* hl-line.el (hl-line-range-function): New variable.
	(hl-line-move): New function.
	(global-hl-line-highlight): Use `hl-line-move'.
	(hl-line-highlight): Ditto.

	* scroll-bar.el (scroll-bar-columns):
	* fringe.el (fringe-columns): New function derived from ruler-mode.el.

	* ruler-mode.el (top-level): Require scroll-bar and fringe.
	(ruler-mode-left-fringe-cols)
	(ruler-mode-right-fringe-cols): Use `fringe-columns'.
	(ruler-mode-right-scroll-bar-cols)
	(ruler-mode-left-scroll-bar-cols): Use `scroll-bar-columns'.
	(ruler-mode-ruler-function): New variable.
	(ruler-mode-header-line-format): Call `ruler-mode-ruler-function'
	if the value for `ruler-mode-ruler-function'is given.

	* hexl.el (hexl-mode-hook): Make the hook customizable.
	(hexl-address-area, hexl-ascii-area): New customize variables.
	(hexlify-buffer): Put font-lock-faces on the address area and
	the ascii area.
	(hexl-activate-ruler): New function.
	(hexl-follow-line): New function.
	(hexl-highlight-line-range): New function.
	(hexl-mode-ruler): New function.

2004-03-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc-hooks.el (vc-handled-backends): Add Arch.  Move MCVS down.
	(vc-default-find-file-hook): New fun.
	(vc-find-file-hook): Call new find-file-hook operation.

	* vc-arch.el: New file.

2004-03-12  Jesper Harder  <harder@ifa.au.dk>

	* info-look.el (info-lookup): Reuse an existing Info window.

2004-03-12  Francis J. Wright  <F.J.Wright@qmul.ac.uk>

	* woman.el (woman-preserve-ascii): Default value changed to t and
	doc string revised.

2004-03-12  Richard M. Stallman  <rms@gnu.org>

	* pcvs.el (cvs-mode-add-change-log-entry-other-window):
	Fix minor bug.

	* replace.el (occur-engine): Change message for count of matches.

	* emacs-lisp/bytecomp.el (byte-compile-get-constant):
	For strings, do compare text properties.

2004-03-11  Daniel Pfeiffer  <occitan@esperanto.org>

	* progmodes/compile.el (compile-auto-highlight)
	(compilation-error-list, compilation-old-error-list)
	(compilation-parse-errors-function, compilation-parsing-end)
	(compilation-error-message, compilation-directory-stack)
	(compilation-enter-directory-regexp-alist)
	(compilation-leave-directory-regexp-alist)
	(compilation-file-regexp-alist, compilation-nomessage-regexp-alist)
	(compilation-current-file, compilation-regexps): Remove vars.

	(compile-error-at-point, compilation-error-filedata)
	(compilation-error-filedata-file-name, compile-reinitialize-errors)
	(compilation-next-error-locus, compilation-forget-errors)
	(count-regexp-groupings, compilation-parse-errors)
	(compile-collect-regexps, compile-buffer-substring): Remove funs.

	(compile-internal): Make obsolete.

	(compilation-first-column, compilation-error)
	(compilation-directory-matcher, compilation-page-delimiter)
	(compilation-mode-font-lock-keywords, compilation-debug)
	(compilation-error-face, compilation-warning-face)
	(compilation-info-face, compilation-line-face)
	(compilation-column-face, compilation-enter-directory-face)
	(compilation-leave-directory-face, compilation-skip-threshold)
	(compilation-skip-visited, compilation-context-lines): New vars.

	(compilation-warning-face, compilation-info-face)
	(compilation-message-face): New faces.

	(compilation-error-regexp-alist-alist): New constant.

	(compilation-face, compilation-directory-properties)
	(compilation-assq, compilation-error-properties, compilation-start)
	(define-compilation-mode, compilation-loop)
	(compilation-set-window): New functions.

	(compile): Additional argument for interactive compiles like TeX.

	* progmodes/grep.el (kill-grep): Move here from compile.el
	(grep-error, grep-hit-face, grep-error-face)
	(grep-mode-font-lock-keywords): New variables.
	(grep-regexp-alist): Simplify regexp and add `binary' case.
	(grep-mode): New mode.
	(grep-process-setup): Simplify.

2004-03-11  Jason Rumney  <jasonr@gnu.org>

	* net/ldap.el (ldap-search-internal): Handle file URLs with drive
	letters on DOS/Windows.

2004-03-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* server.el (server-name): New var.
	(server-socket-dir): New var to replace server-socket-name.
	(server-start): Use them.

2004-03-11  Simon Josefsson  <jas@extundo.com>

	* mail/smtpmail.el (smtpmail-read-response): Abort if process has
	died to avoid infloop.  Reported by Jonathan Glauner
	<jglauner@sbum.org>.

2004-03-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* smerge-mode.el (smerge-check-cache, smerge-check): New var and fun.
	(smerge-mode-menu): Use it to deactivate menu entries.
	(smerge-keep-current): New fun.
	(smerge-keep-current): Use it.

2004-03-10  John Paul Wallington  <jpw@gnu.org>

	* foldout.el (foldout-fold-list, foldout-modeline-string):
	Declare them as variables, not constants.

2004-03-10  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* ps-print.el: Modification to print *Messages* buffer.
	(ps-print-version): New version 6.6.4.
	(ps-message-log-max): New fun.
	(ps-spool-without-faces, ps-spool-with-faces)
	(ps-count-lines-preprint): Code fix.

	* printing.el: New tips in Tips section.

2004-03-09  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* delim-col.el: Doc fix.

	* printing.el: Doc fix.  New doc section (Tips).

2004-03-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* type-break.el (type-break-emacs-variant): Remove.
	(type-break-run-at-time, type-break-cancel-function-timers):
	Use fboundp rather than version name and number.

2004-03-09  Masatake YAMATO  <jet@gyve.org>

	* hexl.el (hexl-mode): Use `make-local-variable' instead of
	`make-variable-buffer-local'.

2004-03-08  Michael Albinus  <Michael.Albinus@alcatel.de>

	* find-dired.el (find-dired): Call `shell-command' instead of
	`start-process-shell-command'.  By this, Tramp takes over
	handling of remote directories.

2004-03-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* newcomment.el (comment-use-global-state): New var.
	(comment-search-forward): Use it.

	* emacs-lisp/lisp-mode.el (lisp-mode-variables): Set it.

	* cus-edit.el (fill) <defgroup>: Move to fill.el.

	* textmodes/fill.el (fill) <defgroup>: Move from cus-edit.el.
	(enable-kinsoku): Make it a defcustom.
	(fill-comment-paragraph): Don't rely on fill-prefix to bound the
	paragraph to same-comment-start-marker.

2004-03-07  Dave Love  <fx@gnu.org>

	* net/browse-url.el (rfc2368-parse-mailto-url): Autoload.
	(browse-url-mail): Use it.

	* mail/rfc2368.el (rfc2368-unhexify-char): Delete.
	(rfc2368-unhexify-string): Use replace-regexp-in-string.

2004-03-07  Francis J. Wright  <F.J.Wright@qmul.ac.uk>

	* woman.el (woman-man.conf-path): Doc fix.
	(woman-parse-man.conf): Also parse OPTIONAL_MANPATH.

2004-03-07  Eli Zaretskii  <eliz@gnu.org>

	* sort.el (sort-columns): Remove ms-dos from the list of systems
	where the external `sort' command is not used.

2004-03-07  Kim F. Storm  <storm@cua.dk>

	* gdb-ui.el (gdb-overlay-arrow-position): Add defvar.
	(gdb-reset): Reset gdb-overlay-arrow-position marker and remove it
	from overlay-arrow-variable-list.
	(gdb-assembler-mode): Use add-to-list for gdb-overlay-arrow-position.

2004-03-06  Nick Roberts  <nick@nick.uklinux.net>

	* gdb-ui.el (gdb-assembler-mode, gdb-assembler-custom): Set up
	overlay arrow string properly for the assembler buffer.

2004-03-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* mail/sendmail.el (mail-mode): Fix last change.

2004-03-05  Nick Roberts  <nick@nick.uklinux.net>

	* gdb-ui.el (gdb-assembler-mode): Create a second overlay arrow
	for the assembler buffer.
	(gdb-assembler-custom): Position the overlay arrow.
	(gdb-put-arrow, gdb-remove-arrow): Delete functions.

2004-03-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/sh-script.el (sh-font-lock-paren): Add @ in case patterns.

	* pcvs-info.el (cvs-fileinfo->backup-file): Use a more constraining
	regexp to distinguish .#ChangeLog.9.1.400 and .#ChangeLog.1.400.

	* mail/sendmail.el (mail-mode): Set comment-start-skip.

	* newcomment.el (uncomment-region): Allow non-terminated comment.
	(comment-normalize-vars): Check the user-specified comstart marker.

2004-03-04  Jesper Harder  <harder@ifa.au.dk>

	* sort.el (sort-columns): Don't use external 'sort' on ms-windows.
	Otherwise, do use it if the region only contains font-lock text
	properties.

2004-03-04  Masatake YAMATO  <jet@gyve.org>

	* hexl.el (hexl-mode): Set `hexl-print-current-point-info'
	as the callback function for eldoc.
	(hexl-print-current-point-info): New function.
	(hexl-current-address): Print the address in both decimal
	and hexadecimal format.

2004-03-04  Richard M. Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-convert-to-babyl-format):
	Specify t for UNIBYTE when calling mail-unquote-printable-region.

	* mail/mail-utils.el (mail-unquote-printable-region):
	New arg UNIBYTE.

	* startup.el (command-switch-alist): Doc fix.

	* simple.el (undo): Temporarily set this-command to `undo-start',
	then set it to `undo' once undo-start returns without error.

	* simple.el (minibuffer-history-sexp-flag): Doc fix.

	* simple.el (kill-line): Don't disregard trailing whitespace
	in eol condition, if show-trailing-whitespace is set.

	* mouse-sel.el (mouse-sel-has-been-enabled): New var.
	(mouse-sel-mode): When enabling, set mouse-sel-has-been-enabled.
	When disabling, restore old values only if mouse-sel-has-been-enabled.

	* isearch.el (isearch-*-char): New arg WANT-BACKSLASH.
	(isearch-{-char): New function.
	(isearch-mode-map): Bind { to isearch-{-char.

	* font-lock.el (lisp-font-lock-keywords-2):
	Turn off the CL with-... and do-... general patterns.
	Instead, recognize several specific with... and do... constructs.

	* files.el (switch-to-buffer-other-window):
	Bind same-window-buffer-names and same-window-regexps to nil.
	(switch-to-buffer-other-frame): Likewise.

2004-03-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textmodes/fill.el (fill-comment-paragraph): Be more careful when
	recognizing leading comment on code line.

2004-03-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (setwins, setwins_almost): Skip .arch-ids and other
	hidden files/directories.

2004-03-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textmodes/fill.el (fill-paragraph): Don't check comment-start-skip,
	only comment-start (in case the mode hasn't set it).

	* Makefile.in (AUTOGENEL): New var.
	(bootstrap-prepare): Rename from bootstrap-clean.
	Don't remove elc files.
	(maintainer-clean): New target.

	* xml.el (xml-get-attribute-or-nil): Simplify.

2004-03-02  Juri Linkov  <juri@jurta.org>

	* net/browse-url.el (browse-url-netscape, browse-url-mozilla)
	(browse-url-galeon, browse-url-epiphany): Encode dollar signs in
	URL to prevent their substitution with the environment variable
	values by browsers.

2004-03-03  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* ps-print.el: Doc fix.
	(ps-print-version): New version number (6.6.3).
	(ps-right-header, ps-right-footer, ps-left-header, ps-left-footer):
	Docstring fix.
	(ps-kill-emacs-check): Check if ps-print temporary buffer is killed
	before printing.
	(ps-time-stamp-yyyy-mm-dd): New fun.
	(ps-time-stamp-iso8601): Alias for ps-time-stamp-yyyy-mm-dd.

2004-03-02  Kim F. Storm  <storm@cua.dk>

	* gdb-ui.el (gdb-mouse-toggle-breakpoint): Remove debug message.

2004-03-01  Juanma Barranquero  <lektu@terra.es>

	* allout.el (allout-rebullet-heading): Fix typo in docstring.

	* desktop.el (desktop-file-version)
	(desktop-after-read-hook): Fix typos.
	(desktop-clear-preserve-buffers): Remove redundant info in
	docstring already shown by the obsolescence message.
	(desktop-truncate, desktop-internal-v2s)
	(desktop-value-to-string): Change argument name to match docstring.

	* emulation/tpu-edt.el (tpu-set-mark): Fix typo in docstring.

	* eshell/em-smart.el (eshell-smart-maybe-jump-to-end): Fix typo in
	docstring.

2004-02-29  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* printing.el: Replace "As Is..." in PostScript file print/preview by
	"No Preprocessing...".  Suggested by Colin Marquardt
	<_marquardt_@zmd.de>.
	(pr-insert-section-4): Adjust buffer interface.

2004-02-29  Kai Grossjohann  <kai.grossjohann@gmx.net>

	Version 2.0.39 of Tramp released.

	* net/tramp.el (tramp-handle-file-local-copy)
	(tramp-handle-write-region, tramp-open-connection-rsh):
	Variable name typo.  Small change.  From Patrick Tullmann
	<tullmann@flux.utah.edu>.
	(tramp-process-connection-type): New variable.
	(tramp-maybe-open-connection): Use it.
	(tramp-do-copy-or-rename-via-buffer): Handle KEEP-DATE arg if possible.
	(tramp-touch): Set last-modified time of a remote file.
	(tramp-handle-write-region): Say which function is used when encoding.

2004-02-29  Michael Albinus  <Michael.Albinus@alcatel.de>

	* net/tramp-smb.el (tramp-smb-handle-file-writable-p): Handle the
	case of non-existing filename, too.  Reported by Christoph Bauer
	<c_bauer@informatik.uni-kl.de>.
	(tramp-smb-get-file-entries): The directory in question should
	have permissions "drwxrwxrwx".  Just virtual, because we don't
	know the real permissions.  Don't we know?
	(tramp-smb-prompt): Add virtual prompt from listing shares, too.
	(tramp-smb-errors): Add "NT_STATUS_ACCOUNT_LOCKED_OUT".
	(tramp-smb-wait-for-output): Optimize algorithm getting pending
	output.  If it was received chunkwise, there have been problems.
	Remove the "prompt not found" error message; it is obvious.
	Simplify algorithm.
	(tramp-smb-process-running): Remove.  Since we acknowledge the
	virtual prompt for shares, there's no need for distinction of
	reading shares (process ends afterwards) and interactive mode of
	smblient.
	(tramp-smb-open-connection): Setting process sentinel removed.
	(tramp-smb-errors): Add "NT_STATUS_WRONG_PASSWORD" and
	"NT_STATUS_NETWORK_ACCESS_DENIED".
	(tramp-smb-maybe-open-connection): Set `process-connection-type'
	to 'pty.  Suggested by Piet van Oostrum <piet@cs.uu.nl>.
	(top-level): Setting default value in `tramp-default-method-alist'
	corrected.  Order of USER and HOST have been wrong.
	Nobody complained for months ...
	(tramp-smb-maybe-open-connection): Use `tramp-process-connection-type'.
	(tramp-smb-open-connection): Clear password cache if login has failed.

	* net/tramp.el (tramp-completion-mode) Don't check for 'xemacs' but
	`tramp-unified-filenames'.
	(tramp-completion-mode): Make test for XEmacs explicitely.
	`event-to-character' can exists in Emacs packages too.
	Reported by Matt Swift <swift@alum.mit.edu>.
	(tramp-buffer-name): Buffer name must contain the user if exists.
	Reported by Adrian Phillips <a.phillips@met.no>.
	(tramp-do-copy-or-rename-file): Handle out-of-band methods.
	Call `tramp-do-copy-or-rename-file-out-of-band' this case.
	(tramp-do-copy-or-rename-file-out-of-band): Rename from
	`tramp-do-copy-or-rename-file-one-local', because it handles also
	the case both files use the same out-of-band method.
	Implementation added.
	(tramp-handle-file-local-copy, tramp-handle-write-region):
	Out-of-band handling removed.  `copy-file' called instead, which
	calls `tramp-do-copy-or-rename-file-out-of-band'.
	(tramp-action-password): Check for out-of-band method removed.
	This function is used for 'login-program.
	(tramp-post-connection): Use `tramp-method-out-of-band-p' when
	appropriate.
	(tramp-completion-function-alist-ssh): Add `tramp-parse-shostkeys'
	and `tramp-parse-sknownhosts'.
	(tramp-completion-function-alist): It's a defvar now, because we
	want to apply the optimized `tramp-set-completion-function'
	instead of a static list.
	(tramp-set-completion-function): Implementation tuned.
	Avoid double entries, and entries where the function or the
	file/directory doesn't exist.
	(tramp-parse-shostkeys, tramp-parse-sknownhosts): New functions
	for SSH2.
	(tramp-file-name-handler-alist): Add `dired-compress-file' entry.
	(tramp-handle-dired-compress-file): New function.
	(tramp-async-proc): New variable.
	(tramp-handle-shell-command): Adding asynchronous processes.
	They are far from being perfect, but it works at least for
	`find-grep-dired' and `find-name-dired' in Emacs 21.4.
	(top-level): Require password.el if visible.  Should be mandatory
	once No Gnus has found its way into (X)Emacs.
	(tramp-read-passwd): Invoke `password-read' if available,
	`read-passwd' otherwise.  `ange-ftp-read-passwd' isn't used as
	fallback any longer.
	(tramp-clear-passwd): New function.
	(tramp-process-actions, tramp-process-multi-actions):
	Clear password cache if login has failed.

	* net/tramp-ftp.el (Commentary): Remove pointer to EFS.  It has
	its own module.
	(tramp-ftp-file-name-handler): Unset `ange-ftp-ftp-name-arg' and
	`ange-ftp-ftp-name-res'.  There could be incorrect values from
	previous calls in case the "ftp" method is used in the Tramp file
	name.  Reported by Katsumi Yamaoka <yamaoka@jpl.org>.

2004-02-28  Richard M. Stallman  <rms@gnu.org>

	* term.el (term-mouse-paste): Call mouse-set-point.

	* thumbs.el: New file.

2004-02-28  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* progmodes/ebnf-abn.el: Doc fix.

	* progmodes/ebnf-bnf.el: Doc fix.
	(ebnf-repeat): Code fix.

	* progmodes/ebnf2ps.el: Doc fix.
	(ebnf-syntax-directory, ebnf-syntax-file): New funs.

2004-02-28  Juri Linkov  <juri@jurta.org>

	* ffap.el (dired-at-point): Additional writability test for
	relative directory names.
	(dired-at-point-prompter): Treat directories as a directory, get
	the directory component from files.
	(ffap-string-at-point): Return string from region if region is active.
	(ffap-file-at-point): Remove redundant code.

2004-02-28  Kim F. Storm  <storm@cua.dk>

	* gdb-ui.el (breakpoint-enabled-icon, breakpoint-disabled-icon):
	Initialize margin area images to nil.
	(breakpoint-bitmap): New defvar for breakpoint fringe bitmaps.
	(breakpoint-enabled-bitmap-face)
	(breakpoint-disabled-bitmap-face): New faces for bpt in fringe.
	(gdb-info-breakpoints-custom): Use gdb-remove-breakpoint-icons.
	(gdb-info-breakpoints-custom): Use gdb-put-breakpoint-icon.
	(gdb-mouse-toggle-breakpoint): Handle bpt in fringe.
	(gdb-reset): Use gdb-remove-breakpoint-icons.
	(gdb-put-string): Add dprop arg to specify alternative display
	property (for setting fringe bitmap).
	(gdb-remove-strings): Doc fix.
	(gdb-put-breakpoint-icon): New defun which displays a breakpoint
	icon in fringe (if available), or else as icon or text in display
	margin.  Creates necessary icons in breakpoint-bitmap,
	breakpoint-enabled-icon, and/or breakpoint-disabled-icon.
	Also make left window margin if required.
	(gdb-remove-breakpoint-icons): New defun to remove breakpoint
	icons inserted by gdb-put-breakpoint-icon.  Remove left margin if
	no longer needed.
	(gdb-assembler-custom): Use gdb-remove-breakpoint-icons and
	gdb-put-breakpoint-icon.
	(gdb-assembler-mode): Don't set left-margin-width here.

2004-02-27  Kevin Ryde  <user42@zip.com.au>

	* info-look.el: In scheme-mode symbol regexp, disallow backquote and
	comma, so that it DTRT in macros.

2004-02-27  Markus Rost  <rost@mathematik.uni-bielefeld.de>

	* progmodes/sh-script.el (sh-shell-arg)
	(sh-require-final-newline, sh-assignment-regexp, sh-builtins)
	(sh-leading-keywords, sh-other-keywords): Fix custom type.

2004-02-27  Dan Nicolaescu  <dann@ics.uci.edu>

	* faces.el (face-spec-set-match-display): Add a new attribute,
	`min-colors'.
	(region, highlight, secondary-selection): Use `min-colors'.

	* custom.el (defface): Add documentation for `min-colors'.

	* font-lock.el (font-lock-comment-face, font-lock-string-face)
	(font-lock-keyword-face, font-lock-function-name-face)
	(font-lock-variable-name-face, font-lock-constant-face):
	Use `min-colors'.

	* isearch.el (isearch, isearch-lazy-highlight-face): Use `min-colors'.

2004-02-25  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* progmodes/ebnf2ps.el: Doc fix.  For compatibility with Emacs 20,
	define assq-delete-all if it's not defined.
	(ebnf-generate-region): Code fix.

	* printing.el: Doc fix.
	(pr-version): New version number (6.7.2).
	(pr-command): Return empty string if command is an empty string.

2004-02-24  Vinicius Jose Latorre  <viniciusjl@ig.com.br>

	* progmodes/ebnf-abn.el: New file, implements an ABNF parser.

	* progmodes/ebnf2ps.el: Doc fix.  Accept ABNF (Augmented BNF).  New
	arrow shapes: semi-up-hollow, semi-up-full, semi-down-hollow and
	semi-down-full.  Fix a bug on productions like test = {"test"}* | (
	"tt" ["test"] ).  Reported by Markus Dreyer
	<mdreyer@ix.urz.uni-heidelberg.de>.
	(ebnf-version): New version number (4.0).
	(ebnf-print-directory, ebnf-print-file, ebnf-spool-directory)
	(ebnf-spool-file, ebnf-eps-directory, ebnf-eps-file)
	(ebnf-delete-style): New commands.
	(ebnf-directory, ebnf-file): New funs.
	(ebnf-special-show-delimiter, ebnf-file-suffix-regexp)
	(ebnf-production-name-p, ebnf-stop-on-error): New options.
	(ebnf-syntax-alist): New var.
	(ebnf-element-width): New fun replacing ebnf-list-width.
	(ebnf-arrow-shape, ebnf-syntax): Custom fix.
	(ebnf-style-custom-list, ebnf-style-database, ebnf-arrow-shape-alist)
	(ebnf-prologue): Adjust vars.
	(ebnf-setup, ebnf-insert-style, ebnf-merge-style, ebnf-apply-style)
	(ebnf-reset-style, ebnf-push-style, ebnf-pop-style)
	(ebnf-check-style-values, ebnf-generate-production)
	(ebnf-generate-region, ebnf-production-dimension, ebnf-justify-list)
	(ebnf-make-terminal1, ebnf-make-or-more1, ebnf-make-repeat)
	(ebnf-token-repeat): Code fix.

	* progmodes/ebnf-yac.el: Doc fix.  Handle Bison pragmas %nonassoc,
	%right, %left and %prec.  Suggested by Matthew K. Junker
	<junker@alum.mit.edu>.
	(ebnf-yac-definitions, ebnf-yac-lex): Code fix.

	* progmodes/ebnf-iso.el: Doc fix.
	(ebnf-iso-token-table, ebnf-iso-non-terminal-chars): Adjust vars.
	(ebnf-iso-lex): Code fix.

	* progmodes/ebnf-bnf.el: Doc fix.
	(ebnf-bnf-lex): Code fix.

	* progmodes/ebnf-otz.el: Doc fix.

2004-02-23  Luc Teirlinck  <teirllm@auburn.edu>

	* abbrev.el (write-abbrev-file): Make argument optional.  Doc fix.
	(abbrev-prefix-mark): Doc fix.

2004-02-23  Nick Roberts  <nick@nick.uklinux.net>

	* gdb-ui.el (gud-watch): Load tooltip, if necessary.
	(gdb-var-create-handler): Force speedbar-update-flag to be non-nil.
	(gdb-var-delete): Make interactive (really).
	(gdb-edit-value): Make non-interactive.

	* progmodes/gud.el (gud-speedbar-menu-items):
	Add gdb-var-delete and, indirectly, gdb-edit-value.
	(gud-install-speedbar-variables): Bind gdb-var-delete to "D".
	(gud-speedbar-buttons): Remove gdb-var-delete from tag-line.
	(gud-gdb-marker-filter): Add comment for annotations.

2004-02-23  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* calendar/calendar.el (generate-calendar)
	(calendar-read-date): Prevent display of BC calendars once more -
	reverts 2003-10-01 change.
	(generate-calendar-month): Doc fix.

2004-02-03  Matthew Mundell  <matt@mundell.ukfsn.org>  (tiny change)

	* calendar/diary-lib.el (fancy-diary-display): Don't rely on
	return value of increment-calendar-month.

2004-02-21  Stephen Compall  <s11@member.fsf.org>

	* saveplace.el (save-place-forget-unreadable-files)
	(save-place-save-skipped, save-place-skip-check-regexp): New vars.
	(save-place-forget-unreadable-files): New function.
	(save-place-alist-to-file): Use it to filter out files that are
	no longer readable.

	* textmodes/texinfo.el (texinfo-insert-@item): Look for the
	current Texinfo environment, using the same method as in
	`texinfo-insert-@end', and insert a space rather than a newline if
	point in a @table environment.

2004-02-21  Juri Linkov  <juri@jurta.org>

	* ffap.el (ffap-file-at-point): Try parent directories.

2004-02-21  Klaus Zeitler  <kzeitler@lucent.com>

	* vcursor.el (vcursor-modifiers): New defcustom.
	(vcursor-cs-binding): Use vcursor-modifiers instead of a
	hard-coded list.

2004-02-21  Masatake YAMATO  <jet@gyve.org>

	* play/animate.el (animate-birthday-present): Accept names other
	than `Sarah', too.

2004-02-21  Juri Linkov  <juri@jurta.org>

	* startup.el: Remove table of command line arguments from the
	Commentary section.

2004-02-20  John Wiegley  <johnw@newartisans.com>

	* eshell/em-pred.el (eshell-modifier-alist): Change the "eval
	again" modifier from 'e' to 'E', since 'e' is also used by the
	"file extension" modifier.

2004-02-19  Luc Teirlinck  <teirllm@auburn.edu>

	* help-fns.el (describe-categories): Doc fix.

2003-02-19  Michael Kifer  <kifer@cs.stonybrook.edu>

	* ediff-util.el (ediff-compute-custom-diffs-maybe): Avoid creating
	temporary file for buffer already visiting one.  This change makes
	output likely to be directly usable by patch program.
	Suggested by Adrian Aichner  <adrian@xemacs.org>

2004-02-20  Nick Roberts  <nick@nick.uklinux.net>

	* gdb-ui.el (gdb-use-colon-colon-notation): Set default to nil for
	case of variables defined in compound statements.
	(gdb-setup-windows, gdb-source-info, gdb-source-info):
	Simplify constructions using switch-to-buffer.

2004-02-19  Simon Josefsson  <jas@extundo.com>

	* play/morse.el: Fix typo.
	(morse-code): Add @.

2004-02-19  Glenn Morris  <gmorris@ast.cam.ac.uk>

	* calendar/appt.el (appt-display-format): Change default to
	'ignore, for backwards compatibility.
	(appt-display-message): If appt-display-format is 'ignore,
	respect old vars appt-msg-window and appt-visible.
	(appt-activate): Don't depend on return value of cancel-timer.

	* calendar/calendar.el (calendar-holidays): Doc fix.

	* calendar/cal-coptic.el (coptic-prompt-for-date):
	Use assoc-string instead of assoc-ignore-case.
	* calendar/cal-french.el (calendar-goto-french-date): Ditto.
	* calendar/cal-hebrew.el (calendar-goto-hebrew-date)
	(mark-hebrew-diary-entries, list-yahrzeit-dates): Ditto.
	* calendar/cal-islam.el (calendar-goto-islamic-date)
	(mark-islamic-diary-entries): Ditto.
	* calendar/cal-julian.el (calendar-goto-julian-date): Ditto.
	* calendar/cal-mayan.el (calendar-read-mayan-haab-date)
	(calendar-read-mayan-tzolkin-date): Ditto.
	* calendar/calendar.el (calendar-read-date): Ditto.
	* calendar/diary-lib.el (mark-diary-entries): Ditto.

2004-02-18  Markus Rost  <rost@mathematik.uni-bielefeld.de>

	* progmodes/executable.el (executable-command-find-posix-p):
	Fix choice of the directory.

2004-02-17  Luc Teirlinck  <teirllm@auburn.edu>

	* simple.el (interprogram-cut-function)
	(interprogram-paste-function, kill-new, kill-append):
	Doc fixes.
	(kill-region): Make it return nil.  Doc fix.
	(yank-pop): Make its argument optional.
	(yank): Make ARG `-' equivalent to `-1'.

2004-02-17  Eli Zaretskii  <eliz@gnu.org>

	* mail/rmail.el (rmail-get-new-mail): Don't reference
	rmail-use-spam-filter if rmail-spam-filter is not loaded.

2004-02-16  Luc Teirlinck  <teirllm@auburn.edu>

	* autorevert.el (auto-revert-buffer-p): Only revert dired buffers
	if one of global-auto-revert-non-file-buffers or autorevert-mode
	is non-nil.

2004-02-16  Eli Zaretskii  <eliz@gnu.org>

	* subr.el (delete-dups): A better implementation from Karl Heuer
	<kwzh@gnu.org>.

2004-02-16  Matt Hodges  <matt@stchem.bham.ac.uk>  (tiny change)

	* net/telnet.el (telnet-interrupt-subjob): Move doc string to the
	correct place.
	* progmodes/icon.el (icon-indent-command): Ditto.
	* textmodes/paragraphs.el (repunctuate-sentences): Ditto.

2004-02-16  Eli Zaretskii  <eliz@gnu.org>

	* progmodes/grep.el (grep-compute-defaults): Undo change from
	2004-01-29: don't use executable-command-find-posix-p.

2004-02-16  Richard Sharman  <rsharman@pobox.com>

	* hilit-chg.el: Use require instead of eval-and-compile.
	(highlight-compare-buffers): New function.

2004-02-16  John Basrai  <jbasrai@comcast.net>  (tiny change)

	* man.el (Man-fontify-manpage): Render section headings in
	`Man-overstrike-face' even when overstrike was not used by man
	formatter for section headings.

2004-02-16  Eli Tziperman  <eli@deas.harvard.edu>

	* rmail-spam-filter.el: (vm-use-spam-filter)
	(rsf-min-region-length-added-to-spam-list): New	variables.
	(rsf-bbdb-auto-delete-spam-bbdb-entries): Rename from
	rmail-bbdb-auto-delete-spam-entries.  Add cc: to recipients for
	spam testing.  Don't delete spam message if automatic deletion
	after output via variable rmail-delete-after-output is turned on.
	(rsf-bbdb-dont-create-entries-for-deleted-messages): Rename from
	rsf-bbdb-dont-create-entries-for-spam.
	(check-field): New function, extracted from code in
	rmail-spam-filter to ease addition of header fields like content-type.
	(message-content-type): New variable to check the content-type:
	field added, also in defcustom of rsf-definitions-alist.
	(rmail-spam-filter): Replace repeated test code for header fields
	by calls to check-field; change the call to
	rmail-output-to-rmail-file such that rmail-current-message stays
	the same to avoid wrong deletion of unseen flags.
	(rsf-add-contents-type): New function to convert old format
	of rmail-spam-definitions-alist into new one.
	Change prefixes of all variables and functions from
	rmail-spam-filter- or spam-filter- or rmail-spam- to rsf-.

2004-02-16  Eli Zaretskii  <eliz@gnu.org>

	* loadhist.el (unload-hook-features-list): New defvar.

2004-02-16  Dave Love  <fx@gnu.org>

	* loadhist.el (unload-feature): Doc fix.  Rename flist to
	unload-hook-features-list.

2004-02-16  Jay Belanger  <belanger@truman.edu>  (tiny change)

	* calc/calc-embed.el (calc-do-embedded-activate): Add autoload
	cookie.  Don't check if we are looking-at open-formula.

2004-02-16  Jesper Harder  <harder@ifa.au.dk>  (tiny change)

	* subr.el (match-string-no-properties): Use substring-no-properties.

2004-02-16  Eli Zaretskii  <eliz@gnu.org>

	* emacs-lisp/rx.el (rx-check, rx-check-any, rx-check-not)
	(rx-repeat, rx-check-backref, rx-syntax, rx-to-string):
	Use lower-case "rx" in all error message.

2004-02-16  Dave Love  <fx@gnu.org>

	* emacs-lisp/rx.el (rx-or): Put group around result.
	(rx-constituents): Add backref.
	(rx-syntax): Add string-delimiter, comment-delimiter.
	(rx-categories): Add combining-diacritic.
	(rx-check-not, rx-greedy, rx): Doc fix.
	(rx-backref, rx-check-backref): New.

2004-02-16  Jesper Harder  <harder@ifa.au.dk>

	* newcomment.el (uncomment-region): Allow eob as comment end.

2004-02-16  Jari Aalto  <jari.aalto@poboxes.com>

	* filecache.el: All message and error commands now use prefix
	"Filecache:" to make it easy to read *Messages* buffer.

2004-02-16  Jari Aalto  <jari.aalto@poboxes.com>

	* autorevert.el: Add support to detect changed dired and VC buffers.
	(auto-revert-active-p, auto-revert-list-diff)
	(auto-revert-dired-file-list, auto-revert-dired-changed-p)
	(auto-revert-handler, auto-revert-active-p): New functions.
	(auto-revert-buffers): Move revert logic to `auto-revert-handler'
	and `auto-revert-active-p'.
	(eval-when-compile): Defvar dired-directory and vc-mode.
	(auto-revert-vc-cvs-file-version, auto-revert-vc-buffer-p)
	(auto-revert-handler-vc): New functions.

2004-02-16  Alfred M. Szmidt  <ams@kemisten.nu>  (tiny change)

	* progmodes/compile.el (compilation-directory): New defvar.
	(compile): Save current directory in compilation-directory.
	(recompile): Bind default-directory to compilation-directory if
	that is non-nil.

2004-02-16  Dave Love  <fx@gnu.org>

	* newcomment.el (comment-insert-comment-function)
	(comment-region-function, uncomment-region-function): New.
	(comment-indent): Use comment-insert-comment-function.
	(uncomment-region): Use uncomment-region-function.
	(comment-region): Use comment-region-function.

	* emacs-lisp/rx.el (rx-not): Bind case-fold-search to nil.

2004-02-16  Richard Stallman  <rms@gnu.org>

	* Makefile.in (TAGS, TAGS-LISP): Filter out of `els' only
	loaddefs* and ldefs-boot*.

2004-02-16  Eli Zaretskii  <eliz@gnu.org>

	* mail/mail-utils.el (rmail-dont-reply-to): Anchor user login name
	and email address at the beginning and end of the address.

	* mail/rmail.el (rmail-default-dont-reply-to-names): Make "info-"
	anchored at the beginning of the email address.

2004-02-16  TAKAI Kousuke  <tak@kmc.gr.jp>  (tiny change)

	* international/ccl.el (ccl-compile-write): Pass `left' to
	ccl-embed-code to generate correct code of write-expr-register.

2004-02-15  Dan Nicolaescu  <dann@ics.uci.edu>  (tiny change)

	* progmodes/grep.el (grep-compute-defaults): Fix typos.

2004-02-15  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* x-dnd.el: Mention support for Motif in commentary.
	(x-dnd-handle-drag-n-drop-event): Ditto.

2004-02-14  Jonathan Yavner  <jyavner@member.fsf.org>

	* ses.el: Use "ses--" prefixes for buffer-local variables.
	Use (point-min) instead of 1, even when we know the buffer
	is unnarrowed.
	(ses-build-load-map): Delete.  Distribute its content to defconst's for
	the three maps.
	(ses-menu, ses-header-line-menu): New menus.
	(ses-mode-map): Use them.
	(ses-read-number) New fun.  Duplicates code from interactive "N" spec.

2004-02-14  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Makefile.in: Fix the CC Mode recompile kludge so it works
	when building in a different directory.

2004-02-13  Luc Teirlinck  <teirllm@auburn.edu>

	* simple.el (kill-new): Put yank-handler property on the entire string.

2004-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* diff.el: Don't use compile any more, use diff-mode instead.
	(diff-regexp-alist, diff-old-file, diff-new-file)
	(diff-parse-differences, diff-process-setup): Remove.
	(diff-sentinel): New fun.
	(diff): Use it.  Run the process ourselves.
	Use diff-mode for the rest of the processing.

	* diff.el (diff): Simplify code handling `switch'.

2004-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* pcvs-defs.el (cvs-menu): Add `tag'.

2004-02-11  Luc Teirlinck  <teirllm@auburn.edu>

	* simple.el (kill-append): Doc fix.

	* emacs-lisp/lisp-mode.el (lisp-mode-variables):
	Adapt outline-regexp to the new conventions for commenting out code.

2004-02-11  John Paul Wallington  <jpw@gnu.org>

	* mail/smtpmail.el (smtpmail-try-auth-methods): Fix typo.

2004-02-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* diff.el (diff-switches): New fun.
	(diff, diff-backup): Use it.
	(diff): Clean up the args construction.  Use backquote.
	Use listp instead of consp to avoid putting a nil arg.
	(diff): Add a revert-buffer function.

2004-02-10  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* x-dnd.el (x-dnd-types-alist): Add COMPOUND_TEXT,  FILE_NAME
	handled by x-dnd-handle-file-name.
	(x-dnd-known-types): Add COMPOUND_TEXT.
	(x-dnd-init-frame): Call x-dnd-init-motif-for-frame.
	(x-dnd-get-state-cons-for-frame): Must do copy-sequence on
	x-dnd-empty-state.
	(x-dnd-forget-drop): Ditto.
	(x-dnd-save-state): Add optional parameter extra-data (for Motif).
	(x-dnd-handle-one-url): Return private when inserting text.
	(x-dnd-insert-ctext): New function.
	(x-dnd-handle-file-name): New function for FILE_NAME.
	(x-dnd-handle-drag-n-drop-event): Add Motif, remove call to error.
	(x-dnd-init-motif-for-frame, x-dnd-get-motif-value)
	(x-dnd-motif-value-to-list, x-dnd-handle-motif): New functions.

2004-02-10  Kenichi Handa  <handa@m17n.org>

	* term/x-win.el (x-select-utf8-or-ctext): Use compare-strings
	instead of while loop.

2004-02-10  Miles Bader  <miles@gnu.org>

	* emacs-lisp/macroexp.el: New file, implements `macroexpand-all'.

2004-02-09  Kenichi Handa  <handa@m17n.org>

	* tar-mode.el (tar-extract): Fix for the case that a file doesn't
	have end-of-line.

2004-02-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Makefile.in: Added extra dependencies in the recompile target
	needed to cope with the compile time macro expansions in CC Mode.

2004-02-09  Kim F. Storm  <storm@cua.dk>

	* fringe.el (no-fringe-bitmap, undef-fringe-bitmap)
	(left-truncation-fringe-bitmap, right-truncation-fringe-bitmap)
	(up-arrow-fringe-bitmap, down-arrow-fringe-bitmap)
	(continued-line-fringe-bitmap, continuation-line-fringe-bitmap)
	(overlay-arrow-fringe-bitmap, top-left-angle-fringe-bitmap)
	(top-right-angle-fringe-bitmap, bottom-left-angle-fringe-bitmap)
	(bottom-right-angle-fringe-bitmap, left-bracket-fringe-bitmap)
	(right-bracket-fringe-bitmap, filled-box-cursor-fringe-bitmap)
	(hollow-box-cursor-fringe-bitmap, hollow-square-fringe-bitmap)
	(bar-cursor-fringe-bitmap, hbar-cursor-fringe-bitmap)
	(empty-line-fringe-bitmap): Define standard fringe bitmaps id's.

2004-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.el (window-safely-shrinkable-p): Don't change the buffer-list.
	Don't allow shrink if there's a window on our right.

	* progmodes/prolog.el (prolog-program-name): Use gprolog if available.
	(prolog-mode-syntax-table, prolog-mode-abbrev-table, prolog-mode-map):
	Bring together declaration and initialization.
	(prolog-mode-variables): Don't set the syntax table.
	Don't set paragraph-start and comment-indent-function.
	Add /*..*/ to the comment regexps.
	(prolog-mode-commands): Remove.  Do it during init of prolog-mode-map.
	(prolog-mode-map): Don't bind TAB.
	(prolog-mode): Set the syntax table.
	(prolog-comment-indent): Remove.
	(inferior-prolog-mode-map): Initialize in the declaration.
	(inferior-prolog-mode-syntax-table)
	(inferior-prolog-mode-abbrev-table): New vars.
	(inferior-prolog-mode): Derive from comint-mode.
	(run-prolog): Avoid switch-to-buffer which can fail in dedicated and
	minibuffer windows.

	* progmodes/grep.el (grep-regexp-alist): Allow :, \t and (
	in file names, as long as it is unabmiguous.

2004-02-08  Andreas Schwab  <schwab@suse.de>

	* textmodes/reftex-toc.el
	(reftex-toc-load-all-files-for-promotion): Remove useless use of
	format.  Doc fix.

	* textmodes/refer.el (refer-find-entry-internal): Remove extra
	format string arguments.

	* tar-mode.el (tar-parse-octal-integer-safe): Add missing format
	string argument.

	* progmodes/xscheme.el (verify-xscheme-buffer): Fix format strings.

	* play/zone.el (zone-call): Fix format string.

	* net/webjump.el (webjump-builtin): Add missing format string argument.

	* midnight.el (midnight-delay-set): Remove extra format string argument.

	* mail/rmail.el (rmail-get-new-mail): Remove useless use of format.

	* hexl.el (hexl-insert-char): Add missing format string argument.

	* format.el (format-decode): Fix format string.

	* emulation/vi.el (vi-mode): Remove extra format string argument.
	(vi-repeat-last-search): Likewise.
	(vi-reverse-last-search): Likewise.
	(vi-goto-mark): Likewise.
	(vi-reverse-last-find-char): Likewise.
	(vi-repeat-last-find-char): Likewise.
	(vi-locate-def): Likewise.

	* emacs-lisp/lisp-mnt.el (lm-verify): Remove useless use of format.

	* ediff-util.el (ediff-toggle-read-only): Remove extra format
	string argument.
	(ediff-toggle-regexp-match): Likewise.

	* dired-aux.el (dired-do-query-replace-regexp): Add missing
	format string argument.

	* calc/calc-map.el (calc-get-operator): Remove extra format
	string argument.

	* calc/calc-forms.el (calc-convert-time-zones): Fix format string.

	* calc/calc-ext.el (calc-do-prefix-help): Remove extra format
	string argument.

	* eshell/esh-mode.el (eshell-send-invisible): Fix format string.

	* eshell/em-hist.el (eshell-hist-word-reference): Fix format string.

	* emulation/viper-ex.el (ex-mark): Remove extra format string argument.

	* emacs-lisp/cl-macs.el (defstruct): Remove extra format string arg.
	(cl-struct-setf-expander): Likewise.

	* vc.el (with-vc-file): Fix unsafe uses of error.
	(vc-cancel-version): Likewise.

2004-02-08  Jan Nieuwenhuizen  <jan.nieuwenhuizen@aspiratie.nl>  (tiny change)

	* progmodes/gud.el (gud-jdb-marker-filter): Add period as optional
	thousands separator; fixes <class>:<line-number> regexp for
	non-english locales.

2004-02-08  Andreas Schwab  <schwab@suse.de>

	* view.el (view-mode-enable): Revert previous change.

2004-02-07  Kim F. Storm  <storm@cua.dk>

	* simple.el (line-number-at-pos): Rename from line-at-pos.
	Uses changed (what-line and vc-annotate-warp-version).

2004-02-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* diff-mode.el (diff-file-regexp-alist, diff-error-regexp-alist)
	(diff-mode): Remove aborted attempt at support for compile.el.
	(diff-mode, diff-minor-mode): Avoid obsolete write-contents-hooks.

2004-02-06  Andreas Schwab  <schwab@suse.de>

	* view.el (view-mode-enable): Add view-mode-map to
	minor-mode-overriding-map-alist.

2004-02-05  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* x-dnd.el (x-dnd-get-local-file-name): Fix byte compiler warning

2004-02-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/cperl-mode.el (cperl-fill-paragraph): Call fill-paragraph
	with point inside rather than after the paragraph.

2004-02-04  Sam Steingold  <sds@gnu.org>

	* mail/smtpmail.el (smtpmail-try-auth-methods):
	Do not try authentication when no mechanism is available.
	Pass port-name as defaultport to `netrc-machine'.

2004-02-04  Stephen Eglen  <stephen@gnu.org>

	* iswitchb.el (iswitchb-minibuffer-setup-hook): Update doc string
	to show how minibuffer height can be constrained.

2004-02-04  John Paul Wallington  <jpw@gnu.org>

	* files.el (auto-mode-alist): Fix .scm, .stk, .ss, .sch entry.

2004-02-03  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* x-dnd.el: New file for drag and drop.

	* term/x-win.el: require x-dnd, set after-make-frame-functions
	to x-dnd-init-frame, let x-dnd-handle-drag-n-drop-event handle
	drag-n-drop event.

	* dired.el (dired-dnd-test-function, dired-dnd-popup-notice)
	(dired-dnd-do-ask-action, dired-dnd-handle-local-file)
	(dired-dnd-handle-file): New functions for drag and drop support.
	(dired-mode): Initialize drag and drop if x-dnd present.

2004-02-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/cperl-mode.el (cperl-mode-map, cperl-do-auto-fill)
	(cperl-menu): Use fill-paragraph, not cperl-fill-paragraph.
	(cperl-mode): Set fill-paragraph-function.
	(cperl-fill-paragraph): Make it non-interactive.

2004-02-02  Benjamin Rutt  <brutt@bloomington.in.us>

	* diff-mode.el (diff-mode-shared-map): Bind q to `quit-window'.

2004-02-02  David Kastrup  <dak@gnu.org>

	* replace.el (perform-replace): Allow 'literal argument in
	regexp-flag to indicate literal replacement.
	(query-replace-regexp-eval): Use it.

2004-02-01  Andreas Schwab  <schwab@suse.de>

	* progmodes/executable.el (executable-command-find-posix-p): Doc fix.

2004-02-01  Stephen Eglen  <stephen@gnu.org>

	* info-look.el: Add support for maxima-mode.  Update commentary
	because info-lookup-symbol is now bound to C-h S.

2004-01-31  Luc Teirlinck  <teirllm@auburn.edu>

	* simple.el (edit-and-eval-command): Bind print-level and
	minibuffer-history-sexp-flag around call to read-from-minibuffer.
	Correct initial position in command-history.

2004-01-30  Luc Teirlinck  <teirllm@auburn.edu>

	* files.el (read-directory-name): Adapt the docstring to recent
	change in Fread_file_name.

2004-01-30  Jonathan Yavner  <jyavner@member.fsf.org>

	* ses.el (ses-print-cell): If print format too wide for column
	width, truncate decimal places if that helps to avoid "#####" fill.
	* ses.el (ses-initial-column-width): Revert previous change.

2004-01-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* jit-lock.el (jit-lock-context-time, jit-lock-context-timer): New var.
	(with-buffer-unmodified, with-buffer-prepared-for-jit-lock):
	Add edebug info.
	(jit-lock-mode): Setup/cancel the new timer.
	(jit-lock-context-fontify): New fun.  Extracted from
	context fontification code of jit-lock-stealth-fontify.
	(jit-lock-stealth-fontify): Don't do context fontification any more.

	* jit-lock.el (jit-lock-stealth-fontify): Allow quit.
	(jit-lock-fontify-now): Handle the `quit' case.
	(jit-lock-contextually): Rename from jit-lock-defer-contextually.

2004-01-29  Jari Aalto  <jari.aalto@poboxes.com>

	* progmodes/executable.el (executable-command-find-posix-p):
	New.  Check if find handles arguments Posix-style.

	* progmodes/grep.el (grep-compute-defaults):
	Use executable-command-find-posix-p.
	(grep-find): Check `grep-find-command'.

	* filecache.el (file-cache-find-posix-p): Delete.
	(file-cache-add-directory-using-find):
	Use `executable-command-find-posix-p'.

2004-01-29  Dave Love  <fx@gnu.org>

	* emacs-lisp/lisp.el (beginning-of-defun-raw, end-of-defun):
	Iterate the hook function if arg is given.
	(mark-defun, narrow-to-defun): Change order of finding the limits.

	* emacs-lisp/bytecomp.el (byte-compile-compatibility): Doc fix.
	(byte-compile-format-warn): New.
	(byte-compile-callargs-warn): Use it.
	(Format, message, error): Add byte-compile-format-like property.
	(byte-compile-maybe-guarded): New.
	(byte-compile-if, byte-compile-cond): Use it.
	(byte-compile-lambda): Compile interactive forms,
	just to make warnings about them.

2004-01-29  Jonathan Yavner  <jyavner@member.fsf.org>

	* ses.el (ses-initial-column-width): Increase to 14, so it will
	work well with the default printer of "%.7g" for extreme values
	like "-1.234567e+07".

2004-01-29  Kenichi Handa  <handa@m17n.org>

	* term/x-win.el (x-selection-value): Optimize for ASCII only case.

2004-01-28  Peter 'Luna' Runestig  <peter@runestig.com>

	* dos-w32.el: Added support for the `default-printer-name' function.

2004-01-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* server.el (server-socket-name): Don't use the hostname in the
	socket name since /tmp is local to the host anyway.

	* emacs-lisp/easy-mmode.el (easy-mmode-define-navigation): Use a more
	robust check of widening and fix var-naming.

2004-01-27  Eli Tziperman  <eli@deas.harvard.edu>

	* rmail-spam-filter.el: Change rmail-spam-filter- or spam-filter-
	or rmail-spam- to rsf- in all function and variable names.
	(rsf-min-region-to-spam-list): New variable.
	(rsf-bbdb-auto-delete-spam-entries): Rename from
	rmail-bbdb-auto-delete-spam-bbdb-entries.  The cc: field is
	scanned together with the recipients field for spam testing; Don't
	delete spam message if rmail-delete-after-output is non-nil;
	(rsf-check-field): New function, extracted from code in
	rmail-spam-filter to ease addition of header fields like
	content-type:;
	(message-content-type): New variable.  The content-type: field was
	added also in defcustom of rsf-definitions-alist;
	(rmail-spam-filter): Replace repeated test code for header fields
	by calls to check-field; change the call to
	rmail-output-to-rmail-file such that rmail-current-message stays
	the same to avoid wrong deletion of unseen flags.
	(rmail-use-spam-filter): Add autoload cookie.

2004-01-27  Jari Aalto  <jari.aalto@poboxes.com>

	* filecache.el (file-cache-find-posix-p): New function.  Detect Cygwin.
	(file-cache-add-directory-using-find): Add Cygwin support.
	(file-cache-find-command-posix-flag): New user variable.

	* filecache.el (file-cache-add-directory): Check for
	directories an remove them from dir-files.

2004-01-27  Richard M. Stallman  <rms@gnu.org>

	* man.el (Man-fontify-manpage): Clean up message.

2004-01-27  Kenichi Handa  <handa@m17n.org>

	* textmodes/paragraphs.el (sentence-end-without-space): New variable.
	(sentence-end): Define using sentence-end-without-space.

	* textmodes/fill.el (fill-delete-newlines): Don't add a space if
	a sentence ends with one of a character in sentence-end-without-space.

